import { useState as er, useEffect as wr, useRef as Ja, useMemo as Rn } from "react";
const Wa = {
  required: (e) => `${e.missingProperty} is required.`,
  minLength: (e) => e.limit === 1 ? "This field is required." : `Should be at least ${e.limit} characters long.`,
  maxLength: (e) => `Should not exceed ${e.limit} characters.`,
  pattern: () => "Invalid format.",
  minimum: (e) => `Should be greater than or equal to ${e.limit}.`,
  maximum: (e) => `Should be less than or equal to ${e.limit}.`,
  enum: (e) => {
    var t;
    return `${(t = e.allowedValues) == null ? void 0 : t.join(", ")} are the only allowed values.`;
  },
  type: (e) => `Should be of type ${e.type}.`,
  format: (e) => `Should be in ${e.format} format.`
}, Ba = (e) => e.instancePath.slice(1), Ya = (e, t) => {
  const r = "Unknown validation error";
  try {
    const a = e.keyword, n = { ...Wa, ...t }[a];
    return typeof n == "function" ? n(e.params) : e.message || r;
  } catch {
    return r;
  }
}, pr = (e, t) => e.reduce((r, a) => {
  const n = Ba(a);
  return n ? {
    ...r,
    [n]: Ya(a, t)
  } : r;
}, {}), jn = (e) => {
  const t = {};
  for (const r in e)
    Object.prototype.hasOwnProperty.call(e, r) && (t[r] = { value: e[r], error: "" });
  return t;
}, Bt = (e) => e == null ? "" : e ?? "", Xa = (e, t) => {
  t.forEach((r) => {
    e.getKeyword(r.keyword) || e.addKeyword(r);
  });
};
var Qa = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function jr(e) {
  return e && e.__esModule && Object.prototype.hasOwnProperty.call(e, "default") ? e.default : e;
}
var Er = { exports: {} }, Zn = {}, Oe = {}, yt = {}, gt = {}, X = {}, vt = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.regexpCode = e.getEsmExportName = e.getProperty = e.safeStringify = e.stringify = e.strConcat = e.addCodeArg = e.str = e._ = e.nil = e._Code = e.Name = e.IDENTIFIER = e._CodeOrName = void 0;
  class t {
  }
  e._CodeOrName = t, e.IDENTIFIER = /^[a-z$_][a-z$_0-9]*$/i;
  class r extends t {
    constructor(m) {
      if (super(), !e.IDENTIFIER.test(m))
        throw new Error("CodeGen: name must be a valid identifier");
      this.str = m;
    }
    toString() {
      return this.str;
    }
    emptyStr() {
      return !1;
    }
    get names() {
      return { [this.str]: 1 };
    }
  }
  e.Name = r;
  class a extends t {
    constructor(m) {
      super(), this._items = typeof m == "string" ? [m] : m;
    }
    toString() {
      return this.str;
    }
    emptyStr() {
      if (this._items.length > 1)
        return !1;
      const m = this._items[0];
      return m === "" || m === '""';
    }
    get str() {
      var m;
      return (m = this._str) !== null && m !== void 0 ? m : this._str = this._items.reduce((N, j) => `${N}${j}`, "");
    }
    get names() {
      var m;
      return (m = this._names) !== null && m !== void 0 ? m : this._names = this._items.reduce((N, j) => (j instanceof r && (N[j.str] = (N[j.str] || 0) + 1), N), {});
    }
  }
  e._Code = a, e.nil = new a("");
  function n(f, ...m) {
    const N = [f[0]];
    let j = 0;
    for (; j < m.length; )
      h(N, m[j]), N.push(f[++j]);
    return new a(N);
  }
  e._ = n;
  const i = new a("+");
  function u(f, ...m) {
    const N = [I(f[0])];
    let j = 0;
    for (; j < m.length; )
      N.push(i), h(N, m[j]), N.push(i, I(f[++j]));
    return y(N), new a(N);
  }
  e.str = u;
  function h(f, m) {
    m instanceof a ? f.push(...m._items) : m instanceof r ? f.push(m) : f.push(_(m));
  }
  e.addCodeArg = h;
  function y(f) {
    let m = 1;
    for (; m < f.length - 1; ) {
      if (f[m] === i) {
        const N = l(f[m - 1], f[m + 1]);
        if (N !== void 0) {
          f.splice(m - 1, 3, N);
          continue;
        }
        f[m++] = "+";
      }
      m++;
    }
  }
  function l(f, m) {
    if (m === '""')
      return f;
    if (f === '""')
      return m;
    if (typeof f == "string")
      return m instanceof r || f[f.length - 1] !== '"' ? void 0 : typeof m != "string" ? `${f.slice(0, -1)}${m}"` : m[0] === '"' ? f.slice(0, -1) + m.slice(1) : void 0;
    if (typeof m == "string" && m[0] === '"' && !(f instanceof r))
      return `"${f}${m.slice(1)}`;
  }
  function p(f, m) {
    return m.emptyStr() ? f : f.emptyStr() ? m : u`${f}${m}`;
  }
  e.strConcat = p;
  function _(f) {
    return typeof f == "number" || typeof f == "boolean" || f === null ? f : I(Array.isArray(f) ? f.join(",") : f);
  }
  function k(f) {
    return new a(I(f));
  }
  e.stringify = k;
  function I(f) {
    return JSON.stringify(f).replace(/\u2028/g, "\\u2028").replace(/\u2029/g, "\\u2029");
  }
  e.safeStringify = I;
  function P(f) {
    return typeof f == "string" && e.IDENTIFIER.test(f) ? new a(`.${f}`) : n`[${f}]`;
  }
  e.getProperty = P;
  function O(f) {
    if (typeof f == "string" && e.IDENTIFIER.test(f))
      return new a(`${f}`);
    throw new Error(`CodeGen: invalid export name: ${f}, use explicit $id name mapping`);
  }
  e.getEsmExportName = O;
  function g(f) {
    return new a(f.toString());
  }
  e.regexpCode = g;
})(vt);
var br = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.ValueScope = e.ValueScopeName = e.Scope = e.varKinds = e.UsedValueState = void 0;
  const t = vt;
  class r extends Error {
    constructor(l) {
      super(`CodeGen: "code" for ${l} not defined`), this.value = l.value;
    }
  }
  var a;
  (function(y) {
    y[y.Started = 0] = "Started", y[y.Completed = 1] = "Completed";
  })(a = e.UsedValueState || (e.UsedValueState = {})), e.varKinds = {
    const: new t.Name("const"),
    let: new t.Name("let"),
    var: new t.Name("var")
  };
  class n {
    constructor({ prefixes: l, parent: p } = {}) {
      this._names = {}, this._prefixes = l, this._parent = p;
    }
    toName(l) {
      return l instanceof t.Name ? l : this.name(l);
    }
    name(l) {
      return new t.Name(this._newName(l));
    }
    _newName(l) {
      const p = this._names[l] || this._nameGroup(l);
      return `${l}${p.index++}`;
    }
    _nameGroup(l) {
      var p, _;
      if (!((_ = (p = this._parent) === null || p === void 0 ? void 0 : p._prefixes) === null || _ === void 0) && _.has(l) || this._prefixes && !this._prefixes.has(l))
        throw new Error(`CodeGen: prefix "${l}" is not allowed in this scope`);
      return this._names[l] = { prefix: l, index: 0 };
    }
  }
  e.Scope = n;
  class i extends t.Name {
    constructor(l, p) {
      super(p), this.prefix = l;
    }
    setValue(l, { property: p, itemIndex: _ }) {
      this.value = l, this.scopePath = (0, t._)`.${new t.Name(p)}[${_}]`;
    }
  }
  e.ValueScopeName = i;
  const u = (0, t._)`\n`;
  class h extends n {
    constructor(l) {
      super(l), this._values = {}, this._scope = l.scope, this.opts = { ...l, _n: l.lines ? u : t.nil };
    }
    get() {
      return this._scope;
    }
    name(l) {
      return new i(l, this._newName(l));
    }
    value(l, p) {
      var _;
      if (p.ref === void 0)
        throw new Error("CodeGen: ref must be passed in value");
      const k = this.toName(l), { prefix: I } = k, P = (_ = p.key) !== null && _ !== void 0 ? _ : p.ref;
      let O = this._values[I];
      if (O) {
        const m = O.get(P);
        if (m)
          return m;
      } else
        O = this._values[I] = /* @__PURE__ */ new Map();
      O.set(P, k);
      const g = this._scope[I] || (this._scope[I] = []), f = g.length;
      return g[f] = p.ref, k.setValue(p, { property: I, itemIndex: f }), k;
    }
    getValue(l, p) {
      const _ = this._values[l];
      if (_)
        return _.get(p);
    }
    scopeRefs(l, p = this._values) {
      return this._reduceValues(p, (_) => {
        if (_.scopePath === void 0)
          throw new Error(`CodeGen: name "${_}" has no value`);
        return (0, t._)`${l}${_.scopePath}`;
      });
    }
    scopeCode(l = this._values, p, _) {
      return this._reduceValues(l, (k) => {
        if (k.value === void 0)
          throw new Error(`CodeGen: name "${k}" has no value`);
        return k.value.code;
      }, p, _);
    }
    _reduceValues(l, p, _ = {}, k) {
      let I = t.nil;
      for (const P in l) {
        const O = l[P];
        if (!O)
          continue;
        const g = _[P] = _[P] || /* @__PURE__ */ new Map();
        O.forEach((f) => {
          if (g.has(f))
            return;
          g.set(f, a.Started);
          let m = p(f);
          if (m) {
            const N = this.opts.es5 ? e.varKinds.var : e.varKinds.const;
            I = (0, t._)`${I}${N} ${f} = ${m};${this.opts._n}`;
          } else if (m = k == null ? void 0 : k(f))
            I = (0, t._)`${I}${m}${this.opts._n}`;
          else
            throw new r(f);
          g.set(f, a.Completed);
        });
      }
      return I;
    }
  }
  e.ValueScope = h;
})(br);
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.or = e.and = e.not = e.CodeGen = e.operators = e.varKinds = e.ValueScopeName = e.ValueScope = e.Scope = e.Name = e.regexpCode = e.stringify = e.getProperty = e.nil = e.strConcat = e.str = e._ = void 0;
  const t = vt, r = br;
  var a = vt;
  Object.defineProperty(e, "_", { enumerable: !0, get: function() {
    return a._;
  } }), Object.defineProperty(e, "str", { enumerable: !0, get: function() {
    return a.str;
  } }), Object.defineProperty(e, "strConcat", { enumerable: !0, get: function() {
    return a.strConcat;
  } }), Object.defineProperty(e, "nil", { enumerable: !0, get: function() {
    return a.nil;
  } }), Object.defineProperty(e, "getProperty", { enumerable: !0, get: function() {
    return a.getProperty;
  } }), Object.defineProperty(e, "stringify", { enumerable: !0, get: function() {
    return a.stringify;
  } }), Object.defineProperty(e, "regexpCode", { enumerable: !0, get: function() {
    return a.regexpCode;
  } }), Object.defineProperty(e, "Name", { enumerable: !0, get: function() {
    return a.Name;
  } });
  var n = br;
  Object.defineProperty(e, "Scope", { enumerable: !0, get: function() {
    return n.Scope;
  } }), Object.defineProperty(e, "ValueScope", { enumerable: !0, get: function() {
    return n.ValueScope;
  } }), Object.defineProperty(e, "ValueScopeName", { enumerable: !0, get: function() {
    return n.ValueScopeName;
  } }), Object.defineProperty(e, "varKinds", { enumerable: !0, get: function() {
    return n.varKinds;
  } }), e.operators = {
    GT: new t._Code(">"),
    GTE: new t._Code(">="),
    LT: new t._Code("<"),
    LTE: new t._Code("<="),
    EQ: new t._Code("==="),
    NEQ: new t._Code("!=="),
    NOT: new t._Code("!"),
    OR: new t._Code("||"),
    AND: new t._Code("&&"),
    ADD: new t._Code("+")
  };
  class i {
    optimizeNodes() {
      return this;
    }
    optimizeNames(s, c) {
      return this;
    }
  }
  class u extends i {
    constructor(s, c, T) {
      super(), this.varKind = s, this.name = c, this.rhs = T;
    }
    render({ es5: s, _n: c }) {
      const T = s ? r.varKinds.var : this.varKind, F = this.rhs === void 0 ? "" : ` = ${this.rhs}`;
      return `${T} ${this.name}${F};` + c;
    }
    optimizeNames(s, c) {
      if (s[this.name.str])
        return this.rhs && (this.rhs = re(this.rhs, s, c)), this;
    }
    get names() {
      return this.rhs instanceof t._CodeOrName ? this.rhs.names : {};
    }
  }
  class h extends i {
    constructor(s, c, T) {
      super(), this.lhs = s, this.rhs = c, this.sideEffects = T;
    }
    render({ _n: s }) {
      return `${this.lhs} = ${this.rhs};` + s;
    }
    optimizeNames(s, c) {
      if (!(this.lhs instanceof t.Name && !s[this.lhs.str] && !this.sideEffects))
        return this.rhs = re(this.rhs, s, c), this;
    }
    get names() {
      const s = this.lhs instanceof t.Name ? {} : { ...this.lhs.names };
      return ue(s, this.rhs);
    }
  }
  class y extends h {
    constructor(s, c, T, F) {
      super(s, T, F), this.op = c;
    }
    render({ _n: s }) {
      return `${this.lhs} ${this.op}= ${this.rhs};` + s;
    }
  }
  class l extends i {
    constructor(s) {
      super(), this.label = s, this.names = {};
    }
    render({ _n: s }) {
      return `${this.label}:` + s;
    }
  }
  class p extends i {
    constructor(s) {
      super(), this.label = s, this.names = {};
    }
    render({ _n: s }) {
      return `break${this.label ? ` ${this.label}` : ""};` + s;
    }
  }
  class _ extends i {
    constructor(s) {
      super(), this.error = s;
    }
    render({ _n: s }) {
      return `throw ${this.error};` + s;
    }
    get names() {
      return this.error.names;
    }
  }
  class k extends i {
    constructor(s) {
      super(), this.code = s;
    }
    render({ _n: s }) {
      return `${this.code};` + s;
    }
    optimizeNodes() {
      return `${this.code}` ? this : void 0;
    }
    optimizeNames(s, c) {
      return this.code = re(this.code, s, c), this;
    }
    get names() {
      return this.code instanceof t._CodeOrName ? this.code.names : {};
    }
  }
  class I extends i {
    constructor(s = []) {
      super(), this.nodes = s;
    }
    render(s) {
      return this.nodes.reduce((c, T) => c + T.render(s), "");
    }
    optimizeNodes() {
      const { nodes: s } = this;
      let c = s.length;
      for (; c--; ) {
        const T = s[c].optimizeNodes();
        Array.isArray(T) ? s.splice(c, 1, ...T) : T ? s[c] = T : s.splice(c, 1);
      }
      return s.length > 0 ? this : void 0;
    }
    optimizeNames(s, c) {
      const { nodes: T } = this;
      let F = T.length;
      for (; F--; ) {
        const M = T[F];
        M.optimizeNames(s, c) || (ve(s, M.names), T.splice(F, 1));
      }
      return T.length > 0 ? this : void 0;
    }
    get names() {
      return this.nodes.reduce((s, c) => H(s, c.names), {});
    }
  }
  class P extends I {
    render(s) {
      return "{" + s._n + super.render(s) + "}" + s._n;
    }
  }
  class O extends I {
  }
  class g extends P {
  }
  g.kind = "else";
  class f extends P {
    constructor(s, c) {
      super(c), this.condition = s;
    }
    render(s) {
      let c = `if(${this.condition})` + super.render(s);
      return this.else && (c += "else " + this.else.render(s)), c;
    }
    optimizeNodes() {
      super.optimizeNodes();
      const s = this.condition;
      if (s === !0)
        return this.nodes;
      let c = this.else;
      if (c) {
        const T = c.optimizeNodes();
        c = this.else = Array.isArray(T) ? new g(T) : T;
      }
      if (c)
        return s === !1 ? c instanceof f ? c : c.nodes : this.nodes.length ? this : new f(je(s), c instanceof f ? [c] : c.nodes);
      if (!(s === !1 || !this.nodes.length))
        return this;
    }
    optimizeNames(s, c) {
      var T;
      if (this.else = (T = this.else) === null || T === void 0 ? void 0 : T.optimizeNames(s, c), !!(super.optimizeNames(s, c) || this.else))
        return this.condition = re(this.condition, s, c), this;
    }
    get names() {
      const s = super.names;
      return ue(s, this.condition), this.else && H(s, this.else.names), s;
    }
  }
  f.kind = "if";
  class m extends P {
  }
  m.kind = "for";
  class N extends m {
    constructor(s) {
      super(), this.iteration = s;
    }
    render(s) {
      return `for(${this.iteration})` + super.render(s);
    }
    optimizeNames(s, c) {
      if (super.optimizeNames(s, c))
        return this.iteration = re(this.iteration, s, c), this;
    }
    get names() {
      return H(super.names, this.iteration.names);
    }
  }
  class j extends m {
    constructor(s, c, T, F) {
      super(), this.varKind = s, this.name = c, this.from = T, this.to = F;
    }
    render(s) {
      const c = s.es5 ? r.varKinds.var : this.varKind, { name: T, from: F, to: M } = this;
      return `for(${c} ${T}=${F}; ${T}<${M}; ${T}++)` + super.render(s);
    }
    get names() {
      const s = ue(super.names, this.from);
      return ue(s, this.to);
    }
  }
  class V extends m {
    constructor(s, c, T, F) {
      super(), this.loop = s, this.varKind = c, this.name = T, this.iterable = F;
    }
    render(s) {
      return `for(${this.varKind} ${this.name} ${this.loop} ${this.iterable})` + super.render(s);
    }
    optimizeNames(s, c) {
      if (super.optimizeNames(s, c))
        return this.iterable = re(this.iterable, s, c), this;
    }
    get names() {
      return H(super.names, this.iterable.names);
    }
  }
  class E extends P {
    constructor(s, c, T) {
      super(), this.name = s, this.args = c, this.async = T;
    }
    render(s) {
      return `${this.async ? "async " : ""}function ${this.name}(${this.args})` + super.render(s);
    }
  }
  E.kind = "func";
  class w extends I {
    render(s) {
      return "return " + super.render(s);
    }
  }
  w.kind = "return";
  class D extends P {
    render(s) {
      let c = "try" + super.render(s);
      return this.catch && (c += this.catch.render(s)), this.finally && (c += this.finally.render(s)), c;
    }
    optimizeNodes() {
      var s, c;
      return super.optimizeNodes(), (s = this.catch) === null || s === void 0 || s.optimizeNodes(), (c = this.finally) === null || c === void 0 || c.optimizeNodes(), this;
    }
    optimizeNames(s, c) {
      var T, F;
      return super.optimizeNames(s, c), (T = this.catch) === null || T === void 0 || T.optimizeNames(s, c), (F = this.finally) === null || F === void 0 || F.optimizeNames(s, c), this;
    }
    get names() {
      const s = super.names;
      return this.catch && H(s, this.catch.names), this.finally && H(s, this.finally.names), s;
    }
  }
  class A extends P {
    constructor(s) {
      super(), this.error = s;
    }
    render(s) {
      return `catch(${this.error})` + super.render(s);
    }
  }
  A.kind = "catch";
  class U extends P {
    render(s) {
      return "finally" + super.render(s);
    }
  }
  U.kind = "finally";
  class Y {
    constructor(s, c = {}) {
      this._values = {}, this._blockStarts = [], this._constants = {}, this.opts = { ...c, _n: c.lines ? `
` : "" }, this._extScope = s, this._scope = new r.Scope({ parent: s }), this._nodes = [new O()];
    }
    toString() {
      return this._root.render(this.opts);
    }
    // returns unique name in the internal scope
    name(s) {
      return this._scope.name(s);
    }
    // reserves unique name in the external scope
    scopeName(s) {
      return this._extScope.name(s);
    }
    // reserves unique name in the external scope and assigns value to it
    scopeValue(s, c) {
      const T = this._extScope.value(s, c);
      return (this._values[T.prefix] || (this._values[T.prefix] = /* @__PURE__ */ new Set())).add(T), T;
    }
    getScopeValue(s, c) {
      return this._extScope.getValue(s, c);
    }
    // return code that assigns values in the external scope to the names that are used internally
    // (same names that were returned by gen.scopeName or gen.scopeValue)
    scopeRefs(s) {
      return this._extScope.scopeRefs(s, this._values);
    }
    scopeCode() {
      return this._extScope.scopeCode(this._values);
    }
    _def(s, c, T, F) {
      const M = this._scope.toName(c);
      return T !== void 0 && F && (this._constants[M.str] = T), this._leafNode(new u(s, M, T)), M;
    }
    // `const` declaration (`var` in es5 mode)
    const(s, c, T) {
      return this._def(r.varKinds.const, s, c, T);
    }
    // `let` declaration with optional assignment (`var` in es5 mode)
    let(s, c, T) {
      return this._def(r.varKinds.let, s, c, T);
    }
    // `var` declaration with optional assignment
    var(s, c, T) {
      return this._def(r.varKinds.var, s, c, T);
    }
    // assignment code
    assign(s, c, T) {
      return this._leafNode(new h(s, c, T));
    }
    // `+=` code
    add(s, c) {
      return this._leafNode(new y(s, e.operators.ADD, c));
    }
    // appends passed SafeExpr to code or executes Block
    code(s) {
      return typeof s == "function" ? s() : s !== t.nil && this._leafNode(new k(s)), this;
    }
    // returns code for object literal for the passed argument list of key-value pairs
    object(...s) {
      const c = ["{"];
      for (const [T, F] of s)
        c.length > 1 && c.push(","), c.push(T), (T !== F || this.opts.es5) && (c.push(":"), (0, t.addCodeArg)(c, F));
      return c.push("}"), new t._Code(c);
    }
    // `if` clause (or statement if `thenBody` and, optionally, `elseBody` are passed)
    if(s, c, T) {
      if (this._blockNode(new f(s)), c && T)
        this.code(c).else().code(T).endIf();
      else if (c)
        this.code(c).endIf();
      else if (T)
        throw new Error('CodeGen: "else" body without "then" body');
      return this;
    }
    // `else if` clause - invalid without `if` or after `else` clauses
    elseIf(s) {
      return this._elseNode(new f(s));
    }
    // `else` clause - only valid after `if` or `else if` clauses
    else() {
      return this._elseNode(new g());
    }
    // end `if` statement (needed if gen.if was used only with condition)
    endIf() {
      return this._endBlockNode(f, g);
    }
    _for(s, c) {
      return this._blockNode(s), c && this.code(c).endFor(), this;
    }
    // a generic `for` clause (or statement if `forBody` is passed)
    for(s, c) {
      return this._for(new N(s), c);
    }
    // `for` statement for a range of values
    forRange(s, c, T, F, M = this.opts.es5 ? r.varKinds.var : r.varKinds.let) {
      const q = this._scope.toName(s);
      return this._for(new j(M, q, c, T), () => F(q));
    }
    // `for-of` statement (in es5 mode replace with a normal for loop)
    forOf(s, c, T, F = r.varKinds.const) {
      const M = this._scope.toName(s);
      if (this.opts.es5) {
        const q = c instanceof t.Name ? c : this.var("_arr", c);
        return this.forRange("_i", 0, (0, t._)`${q}.length`, (J) => {
          this.var(M, (0, t._)`${q}[${J}]`), T(M);
        });
      }
      return this._for(new V("of", F, M, c), () => T(M));
    }
    // `for-in` statement.
    // With option `ownProperties` replaced with a `for-of` loop for object keys
    forIn(s, c, T, F = this.opts.es5 ? r.varKinds.var : r.varKinds.const) {
      if (this.opts.ownProperties)
        return this.forOf(s, (0, t._)`Object.keys(${c})`, T);
      const M = this._scope.toName(s);
      return this._for(new V("in", F, M, c), () => T(M));
    }
    // end `for` loop
    endFor() {
      return this._endBlockNode(m);
    }
    // `label` statement
    label(s) {
      return this._leafNode(new l(s));
    }
    // `break` statement
    break(s) {
      return this._leafNode(new p(s));
    }
    // `return` statement
    return(s) {
      const c = new w();
      if (this._blockNode(c), this.code(s), c.nodes.length !== 1)
        throw new Error('CodeGen: "return" should have one node');
      return this._endBlockNode(w);
    }
    // `try` statement
    try(s, c, T) {
      if (!c && !T)
        throw new Error('CodeGen: "try" without "catch" and "finally"');
      const F = new D();
      if (this._blockNode(F), this.code(s), c) {
        const M = this.name("e");
        this._currNode = F.catch = new A(M), c(M);
      }
      return T && (this._currNode = F.finally = new U(), this.code(T)), this._endBlockNode(A, U);
    }
    // `throw` statement
    throw(s) {
      return this._leafNode(new _(s));
    }
    // start self-balancing block
    block(s, c) {
      return this._blockStarts.push(this._nodes.length), s && this.code(s).endBlock(c), this;
    }
    // end the current self-balancing block
    endBlock(s) {
      const c = this._blockStarts.pop();
      if (c === void 0)
        throw new Error("CodeGen: not in self-balancing block");
      const T = this._nodes.length - c;
      if (T < 0 || s !== void 0 && T !== s)
        throw new Error(`CodeGen: wrong number of nodes: ${T} vs ${s} expected`);
      return this._nodes.length = c, this;
    }
    // `function` heading (or definition if funcBody is passed)
    func(s, c = t.nil, T, F) {
      return this._blockNode(new E(s, c, T)), F && this.code(F).endFunc(), this;
    }
    // end function definition
    endFunc() {
      return this._endBlockNode(E);
    }
    optimize(s = 1) {
      for (; s-- > 0; )
        this._root.optimizeNodes(), this._root.optimizeNames(this._root.names, this._constants);
    }
    _leafNode(s) {
      return this._currNode.nodes.push(s), this;
    }
    _blockNode(s) {
      this._currNode.nodes.push(s), this._nodes.push(s);
    }
    _endBlockNode(s, c) {
      const T = this._currNode;
      if (T instanceof s || c && T instanceof c)
        return this._nodes.pop(), this;
      throw new Error(`CodeGen: not in block "${c ? `${s.kind}/${c.kind}` : s.kind}"`);
    }
    _elseNode(s) {
      const c = this._currNode;
      if (!(c instanceof f))
        throw new Error('CodeGen: "else" without "if"');
      return this._currNode = c.else = s, this;
    }
    get _root() {
      return this._nodes[0];
    }
    get _currNode() {
      const s = this._nodes;
      return s[s.length - 1];
    }
    set _currNode(s) {
      const c = this._nodes;
      c[c.length - 1] = s;
    }
  }
  e.CodeGen = Y;
  function H(v, s) {
    for (const c in s)
      v[c] = (v[c] || 0) + (s[c] || 0);
    return v;
  }
  function ue(v, s) {
    return s instanceof t._CodeOrName ? H(v, s.names) : v;
  }
  function re(v, s, c) {
    if (v instanceof t.Name)
      return T(v);
    if (!F(v))
      return v;
    return new t._Code(v._items.reduce((M, q) => (q instanceof t.Name && (q = T(q)), q instanceof t._Code ? M.push(...q._items) : M.push(q), M), []));
    function T(M) {
      const q = c[M.str];
      return q === void 0 || s[M.str] !== 1 ? M : (delete s[M.str], q);
    }
    function F(M) {
      return M instanceof t._Code && M._items.some((q) => q instanceof t.Name && s[q.str] === 1 && c[q.str] !== void 0);
    }
  }
  function ve(v, s) {
    for (const c in s)
      v[c] = (v[c] || 0) - (s[c] || 0);
  }
  function je(v) {
    return typeof v == "boolean" || typeof v == "number" || v === null ? !v : (0, t._)`!${S(v)}`;
  }
  e.not = je;
  const He = b(e.operators.AND);
  function Xe(...v) {
    return v.reduce(He);
  }
  e.and = Xe;
  const Ie = b(e.operators.OR);
  function z(...v) {
    return v.reduce(Ie);
  }
  e.or = z;
  function b(v) {
    return (s, c) => s === t.nil ? c : c === t.nil ? s : (0, t._)`${S(s)} ${v} ${S(c)}`;
  }
  function S(v) {
    return v instanceof t.Name ? v : (0, t._)`(${v})`;
  }
})(X);
var ee = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.checkStrictMode = e.getErrorPath = e.Type = e.useFunc = e.setEvaluated = e.evaluatedPropsToName = e.mergeEvaluated = e.eachItem = e.unescapeJsonPointer = e.escapeJsonPointer = e.escapeFragment = e.unescapeFragment = e.schemaRefOrVal = e.schemaHasRulesButRef = e.schemaHasRules = e.checkUnknownRules = e.alwaysValidSchema = e.toHash = void 0;
  const t = X, r = vt;
  function a(E) {
    const w = {};
    for (const D of E)
      w[D] = !0;
    return w;
  }
  e.toHash = a;
  function n(E, w) {
    return typeof w == "boolean" ? w : Object.keys(w).length === 0 ? !0 : (i(E, w), !u(w, E.self.RULES.all));
  }
  e.alwaysValidSchema = n;
  function i(E, w = E.schema) {
    const { opts: D, self: A } = E;
    if (!D.strictSchema || typeof w == "boolean")
      return;
    const U = A.RULES.keywords;
    for (const Y in w)
      U[Y] || V(E, `unknown keyword: "${Y}"`);
  }
  e.checkUnknownRules = i;
  function u(E, w) {
    if (typeof E == "boolean")
      return !E;
    for (const D in E)
      if (w[D])
        return !0;
    return !1;
  }
  e.schemaHasRules = u;
  function h(E, w) {
    if (typeof E == "boolean")
      return !E;
    for (const D in E)
      if (D !== "$ref" && w.all[D])
        return !0;
    return !1;
  }
  e.schemaHasRulesButRef = h;
  function y({ topSchemaRef: E, schemaPath: w }, D, A, U) {
    if (!U) {
      if (typeof D == "number" || typeof D == "boolean")
        return D;
      if (typeof D == "string")
        return (0, t._)`${D}`;
    }
    return (0, t._)`${E}${w}${(0, t.getProperty)(A)}`;
  }
  e.schemaRefOrVal = y;
  function l(E) {
    return k(decodeURIComponent(E));
  }
  e.unescapeFragment = l;
  function p(E) {
    return encodeURIComponent(_(E));
  }
  e.escapeFragment = p;
  function _(E) {
    return typeof E == "number" ? `${E}` : E.replace(/~/g, "~0").replace(/\//g, "~1");
  }
  e.escapeJsonPointer = _;
  function k(E) {
    return E.replace(/~1/g, "/").replace(/~0/g, "~");
  }
  e.unescapeJsonPointer = k;
  function I(E, w) {
    if (Array.isArray(E))
      for (const D of E)
        w(D);
    else
      w(E);
  }
  e.eachItem = I;
  function P({ mergeNames: E, mergeToName: w, mergeValues: D, resultToName: A }) {
    return (U, Y, H, ue) => {
      const re = H === void 0 ? Y : H instanceof t.Name ? (Y instanceof t.Name ? E(U, Y, H) : w(U, Y, H), H) : Y instanceof t.Name ? (w(U, H, Y), Y) : D(Y, H);
      return ue === t.Name && !(re instanceof t.Name) ? A(U, re) : re;
    };
  }
  e.mergeEvaluated = {
    props: P({
      mergeNames: (E, w, D) => E.if((0, t._)`${D} !== true && ${w} !== undefined`, () => {
        E.if((0, t._)`${w} === true`, () => E.assign(D, !0), () => E.assign(D, (0, t._)`${D} || {}`).code((0, t._)`Object.assign(${D}, ${w})`));
      }),
      mergeToName: (E, w, D) => E.if((0, t._)`${D} !== true`, () => {
        w === !0 ? E.assign(D, !0) : (E.assign(D, (0, t._)`${D} || {}`), g(E, D, w));
      }),
      mergeValues: (E, w) => E === !0 ? !0 : { ...E, ...w },
      resultToName: O
    }),
    items: P({
      mergeNames: (E, w, D) => E.if((0, t._)`${D} !== true && ${w} !== undefined`, () => E.assign(D, (0, t._)`${w} === true ? true : ${D} > ${w} ? ${D} : ${w}`)),
      mergeToName: (E, w, D) => E.if((0, t._)`${D} !== true`, () => E.assign(D, w === !0 ? !0 : (0, t._)`${D} > ${w} ? ${D} : ${w}`)),
      mergeValues: (E, w) => E === !0 ? !0 : Math.max(E, w),
      resultToName: (E, w) => E.var("items", w)
    })
  };
  function O(E, w) {
    if (w === !0)
      return E.var("props", !0);
    const D = E.var("props", (0, t._)`{}`);
    return w !== void 0 && g(E, D, w), D;
  }
  e.evaluatedPropsToName = O;
  function g(E, w, D) {
    Object.keys(D).forEach((A) => E.assign((0, t._)`${w}${(0, t.getProperty)(A)}`, !0));
  }
  e.setEvaluated = g;
  const f = {};
  function m(E, w) {
    return E.scopeValue("func", {
      ref: w,
      code: f[w.code] || (f[w.code] = new r._Code(w.code))
    });
  }
  e.useFunc = m;
  var N;
  (function(E) {
    E[E.Num = 0] = "Num", E[E.Str = 1] = "Str";
  })(N = e.Type || (e.Type = {}));
  function j(E, w, D) {
    if (E instanceof t.Name) {
      const A = w === N.Num;
      return D ? A ? (0, t._)`"[" + ${E} + "]"` : (0, t._)`"['" + ${E} + "']"` : A ? (0, t._)`"/" + ${E}` : (0, t._)`"/" + ${E}.replace(/~/g, "~0").replace(/\\//g, "~1")`;
    }
    return D ? (0, t.getProperty)(E).toString() : "/" + _(E);
  }
  e.getErrorPath = j;
  function V(E, w, D = E.opts.strictSchema) {
    if (D) {
      if (w = `strict mode: ${w}`, D === !0)
        throw new Error(w);
      E.self.logger.warn(w);
    }
  }
  e.checkStrictMode = V;
})(ee);
var Re = {};
Object.defineProperty(Re, "__esModule", { value: !0 });
const $e = X, Za = {
  // validation function arguments
  data: new $e.Name("data"),
  // args passed from referencing schema
  valCxt: new $e.Name("valCxt"),
  instancePath: new $e.Name("instancePath"),
  parentData: new $e.Name("parentData"),
  parentDataProperty: new $e.Name("parentDataProperty"),
  rootData: new $e.Name("rootData"),
  dynamicAnchors: new $e.Name("dynamicAnchors"),
  // function scoped variables
  vErrors: new $e.Name("vErrors"),
  errors: new $e.Name("errors"),
  this: new $e.Name("this"),
  // "globals"
  self: new $e.Name("self"),
  scope: new $e.Name("scope"),
  // JTD serialize/parse name for JSON string and position
  json: new $e.Name("json"),
  jsonPos: new $e.Name("jsonPos"),
  jsonLen: new $e.Name("jsonLen"),
  jsonPart: new $e.Name("jsonPart")
};
Re.default = Za;
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.extendErrors = e.resetErrorsCount = e.reportExtraError = e.reportError = e.keyword$DataError = e.keywordError = void 0;
  const t = X, r = ee, a = Re;
  e.keywordError = {
    message: ({ keyword: g }) => (0, t.str)`must pass "${g}" keyword validation`
  }, e.keyword$DataError = {
    message: ({ keyword: g, schemaType: f }) => f ? (0, t.str)`"${g}" keyword must be ${f} ($data)` : (0, t.str)`"${g}" keyword is invalid ($data)`
  };
  function n(g, f = e.keywordError, m, N) {
    const { it: j } = g, { gen: V, compositeRule: E, allErrors: w } = j, D = _(g, f, m);
    N ?? (E || w) ? y(V, D) : l(j, (0, t._)`[${D}]`);
  }
  e.reportError = n;
  function i(g, f = e.keywordError, m) {
    const { it: N } = g, { gen: j, compositeRule: V, allErrors: E } = N, w = _(g, f, m);
    y(j, w), V || E || l(N, a.default.vErrors);
  }
  e.reportExtraError = i;
  function u(g, f) {
    g.assign(a.default.errors, f), g.if((0, t._)`${a.default.vErrors} !== null`, () => g.if(f, () => g.assign((0, t._)`${a.default.vErrors}.length`, f), () => g.assign(a.default.vErrors, null)));
  }
  e.resetErrorsCount = u;
  function h({ gen: g, keyword: f, schemaValue: m, data: N, errsCount: j, it: V }) {
    if (j === void 0)
      throw new Error("ajv implementation error");
    const E = g.name("err");
    g.forRange("i", j, a.default.errors, (w) => {
      g.const(E, (0, t._)`${a.default.vErrors}[${w}]`), g.if((0, t._)`${E}.instancePath === undefined`, () => g.assign((0, t._)`${E}.instancePath`, (0, t.strConcat)(a.default.instancePath, V.errorPath))), g.assign((0, t._)`${E}.schemaPath`, (0, t.str)`${V.errSchemaPath}/${f}`), V.opts.verbose && (g.assign((0, t._)`${E}.schema`, m), g.assign((0, t._)`${E}.data`, N));
    });
  }
  e.extendErrors = h;
  function y(g, f) {
    const m = g.const("err", f);
    g.if((0, t._)`${a.default.vErrors} === null`, () => g.assign(a.default.vErrors, (0, t._)`[${m}]`), (0, t._)`${a.default.vErrors}.push(${m})`), g.code((0, t._)`${a.default.errors}++`);
  }
  function l(g, f) {
    const { gen: m, validateName: N, schemaEnv: j } = g;
    j.$async ? m.throw((0, t._)`new ${g.ValidationError}(${f})`) : (m.assign((0, t._)`${N}.errors`, f), m.return(!1));
  }
  const p = {
    keyword: new t.Name("keyword"),
    schemaPath: new t.Name("schemaPath"),
    params: new t.Name("params"),
    propertyName: new t.Name("propertyName"),
    message: new t.Name("message"),
    schema: new t.Name("schema"),
    parentSchema: new t.Name("parentSchema")
  };
  function _(g, f, m) {
    const { createErrors: N } = g.it;
    return N === !1 ? (0, t._)`{}` : k(g, f, m);
  }
  function k(g, f, m = {}) {
    const { gen: N, it: j } = g, V = [
      I(j, m),
      P(g, m)
    ];
    return O(g, f, V), N.object(...V);
  }
  function I({ errorPath: g }, { instancePath: f }) {
    const m = f ? (0, t.str)`${g}${(0, r.getErrorPath)(f, r.Type.Str)}` : g;
    return [a.default.instancePath, (0, t.strConcat)(a.default.instancePath, m)];
  }
  function P({ keyword: g, it: { errSchemaPath: f } }, { schemaPath: m, parentSchema: N }) {
    let j = N ? f : (0, t.str)`${f}/${g}`;
    return m && (j = (0, t.str)`${j}${(0, r.getErrorPath)(m, r.Type.Str)}`), [p.schemaPath, j];
  }
  function O(g, { params: f, message: m }, N) {
    const { keyword: j, data: V, schemaValue: E, it: w } = g, { opts: D, propertyName: A, topSchemaRef: U, schemaPath: Y } = w;
    N.push([p.keyword, j], [p.params, typeof f == "function" ? f(g) : f || (0, t._)`{}`]), D.messages && N.push([p.message, typeof m == "function" ? m(g) : m]), D.verbose && N.push([p.schema, E], [p.parentSchema, (0, t._)`${U}${Y}`], [a.default.data, V]), A && N.push([p.propertyName, A]);
  }
})(gt);
Object.defineProperty(yt, "__esModule", { value: !0 });
yt.boolOrEmptySchema = yt.topBoolOrEmptySchema = void 0;
const xa = gt, es = X, ts = Re, rs = {
  message: "boolean schema is false"
};
function ns(e) {
  const { gen: t, schema: r, validateName: a } = e;
  r === !1 ? xn(e, !1) : typeof r == "object" && r.$async === !0 ? t.return(ts.default.data) : (t.assign((0, es._)`${a}.errors`, null), t.return(!0));
}
yt.topBoolOrEmptySchema = ns;
function as(e, t) {
  const { gen: r, schema: a } = e;
  a === !1 ? (r.var(t, !1), xn(e)) : r.var(t, !0);
}
yt.boolOrEmptySchema = as;
function xn(e, t) {
  const { gen: r, data: a } = e, n = {
    gen: r,
    keyword: "false schema",
    data: a,
    schema: !1,
    schemaCode: !1,
    schemaValue: !1,
    params: {},
    it: e
  };
  (0, xa.reportError)(n, rs, void 0, t);
}
var Ut = {}, st = {};
Object.defineProperty(st, "__esModule", { value: !0 });
st.getRules = st.isJSONType = void 0;
const ss = ["string", "number", "integer", "boolean", "null", "object", "array"], os = new Set(ss);
function is(e) {
  return typeof e == "string" && os.has(e);
}
st.isJSONType = is;
function cs() {
  const e = {
    number: { type: "number", rules: [] },
    string: { type: "string", rules: [] },
    array: { type: "array", rules: [] },
    object: { type: "object", rules: [] }
  };
  return {
    types: { ...e, integer: !0, boolean: !0, null: !0 },
    rules: [{ rules: [] }, e.number, e.string, e.array, e.object],
    post: { rules: [] },
    all: {},
    keywords: {}
  };
}
st.getRules = cs;
var Ke = {};
Object.defineProperty(Ke, "__esModule", { value: !0 });
Ke.shouldUseRule = Ke.shouldUseGroup = Ke.schemaHasRulesForType = void 0;
function us({ schema: e, self: t }, r) {
  const a = t.RULES.types[r];
  return a && a !== !0 && ea(e, a);
}
Ke.schemaHasRulesForType = us;
function ea(e, t) {
  return t.rules.some((r) => ta(e, r));
}
Ke.shouldUseGroup = ea;
function ta(e, t) {
  var r;
  return e[t.keyword] !== void 0 || ((r = t.definition.implements) === null || r === void 0 ? void 0 : r.some((a) => e[a] !== void 0));
}
Ke.shouldUseRule = ta;
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.reportTypeError = e.checkDataTypes = e.checkDataType = e.coerceAndCheckDataType = e.getJSONTypes = e.getSchemaTypes = e.DataType = void 0;
  const t = st, r = Ke, a = gt, n = X, i = ee;
  var u;
  (function(N) {
    N[N.Correct = 0] = "Correct", N[N.Wrong = 1] = "Wrong";
  })(u = e.DataType || (e.DataType = {}));
  function h(N) {
    const j = y(N.type);
    if (j.includes("null")) {
      if (N.nullable === !1)
        throw new Error("type: null contradicts nullable: false");
    } else {
      if (!j.length && N.nullable !== void 0)
        throw new Error('"nullable" cannot be used without "type"');
      N.nullable === !0 && j.push("null");
    }
    return j;
  }
  e.getSchemaTypes = h;
  function y(N) {
    const j = Array.isArray(N) ? N : N ? [N] : [];
    if (j.every(t.isJSONType))
      return j;
    throw new Error("type must be JSONType or JSONType[]: " + j.join(","));
  }
  e.getJSONTypes = y;
  function l(N, j) {
    const { gen: V, data: E, opts: w } = N, D = _(j, w.coerceTypes), A = j.length > 0 && !(D.length === 0 && j.length === 1 && (0, r.schemaHasRulesForType)(N, j[0]));
    if (A) {
      const U = O(j, E, w.strictNumbers, u.Wrong);
      V.if(U, () => {
        D.length ? k(N, j, D) : f(N);
      });
    }
    return A;
  }
  e.coerceAndCheckDataType = l;
  const p = /* @__PURE__ */ new Set(["string", "number", "integer", "boolean", "null"]);
  function _(N, j) {
    return j ? N.filter((V) => p.has(V) || j === "array" && V === "array") : [];
  }
  function k(N, j, V) {
    const { gen: E, data: w, opts: D } = N, A = E.let("dataType", (0, n._)`typeof ${w}`), U = E.let("coerced", (0, n._)`undefined`);
    D.coerceTypes === "array" && E.if((0, n._)`${A} == 'object' && Array.isArray(${w}) && ${w}.length == 1`, () => E.assign(w, (0, n._)`${w}[0]`).assign(A, (0, n._)`typeof ${w}`).if(O(j, w, D.strictNumbers), () => E.assign(U, w))), E.if((0, n._)`${U} !== undefined`);
    for (const H of V)
      (p.has(H) || H === "array" && D.coerceTypes === "array") && Y(H);
    E.else(), f(N), E.endIf(), E.if((0, n._)`${U} !== undefined`, () => {
      E.assign(w, U), I(N, U);
    });
    function Y(H) {
      switch (H) {
        case "string":
          E.elseIf((0, n._)`${A} == "number" || ${A} == "boolean"`).assign(U, (0, n._)`"" + ${w}`).elseIf((0, n._)`${w} === null`).assign(U, (0, n._)`""`);
          return;
        case "number":
          E.elseIf((0, n._)`${A} == "boolean" || ${w} === null
              || (${A} == "string" && ${w} && ${w} == +${w})`).assign(U, (0, n._)`+${w}`);
          return;
        case "integer":
          E.elseIf((0, n._)`${A} === "boolean" || ${w} === null
              || (${A} === "string" && ${w} && ${w} == +${w} && !(${w} % 1))`).assign(U, (0, n._)`+${w}`);
          return;
        case "boolean":
          E.elseIf((0, n._)`${w} === "false" || ${w} === 0 || ${w} === null`).assign(U, !1).elseIf((0, n._)`${w} === "true" || ${w} === 1`).assign(U, !0);
          return;
        case "null":
          E.elseIf((0, n._)`${w} === "" || ${w} === 0 || ${w} === false`), E.assign(U, null);
          return;
        case "array":
          E.elseIf((0, n._)`${A} === "string" || ${A} === "number"
              || ${A} === "boolean" || ${w} === null`).assign(U, (0, n._)`[${w}]`);
      }
    }
  }
  function I({ gen: N, parentData: j, parentDataProperty: V }, E) {
    N.if((0, n._)`${j} !== undefined`, () => N.assign((0, n._)`${j}[${V}]`, E));
  }
  function P(N, j, V, E = u.Correct) {
    const w = E === u.Correct ? n.operators.EQ : n.operators.NEQ;
    let D;
    switch (N) {
      case "null":
        return (0, n._)`${j} ${w} null`;
      case "array":
        D = (0, n._)`Array.isArray(${j})`;
        break;
      case "object":
        D = (0, n._)`${j} && typeof ${j} == "object" && !Array.isArray(${j})`;
        break;
      case "integer":
        D = A((0, n._)`!(${j} % 1) && !isNaN(${j})`);
        break;
      case "number":
        D = A();
        break;
      default:
        return (0, n._)`typeof ${j} ${w} ${N}`;
    }
    return E === u.Correct ? D : (0, n.not)(D);
    function A(U = n.nil) {
      return (0, n.and)((0, n._)`typeof ${j} == "number"`, U, V ? (0, n._)`isFinite(${j})` : n.nil);
    }
  }
  e.checkDataType = P;
  function O(N, j, V, E) {
    if (N.length === 1)
      return P(N[0], j, V, E);
    let w;
    const D = (0, i.toHash)(N);
    if (D.array && D.object) {
      const A = (0, n._)`typeof ${j} != "object"`;
      w = D.null ? A : (0, n._)`!${j} || ${A}`, delete D.null, delete D.array, delete D.object;
    } else
      w = n.nil;
    D.number && delete D.integer;
    for (const A in D)
      w = (0, n.and)(w, P(A, j, V, E));
    return w;
  }
  e.checkDataTypes = O;
  const g = {
    message: ({ schema: N }) => `must be ${N}`,
    params: ({ schema: N, schemaValue: j }) => typeof N == "string" ? (0, n._)`{type: ${N}}` : (0, n._)`{type: ${j}}`
  };
  function f(N) {
    const j = m(N);
    (0, a.reportError)(j, g);
  }
  e.reportTypeError = f;
  function m(N) {
    const { gen: j, data: V, schema: E } = N, w = (0, i.schemaRefOrVal)(N, E, "type");
    return {
      gen: j,
      keyword: "type",
      data: V,
      schema: E.type,
      schemaCode: w,
      schemaValue: w,
      parentSchema: E,
      params: {},
      it: N
    };
  }
})(Ut);
var dr = {};
Object.defineProperty(dr, "__esModule", { value: !0 });
dr.assignDefaults = void 0;
const ht = X, ds = ee;
function ls(e, t) {
  const { properties: r, items: a } = e.schema;
  if (t === "object" && r)
    for (const n in r)
      In(e, n, r[n].default);
  else
    t === "array" && Array.isArray(a) && a.forEach((n, i) => In(e, i, n.default));
}
dr.assignDefaults = ls;
function In(e, t, r) {
  const { gen: a, compositeRule: n, data: i, opts: u } = e;
  if (r === void 0)
    return;
  const h = (0, ht._)`${i}${(0, ht.getProperty)(t)}`;
  if (n) {
    (0, ds.checkStrictMode)(e, `default is ignored for: ${h}`);
    return;
  }
  let y = (0, ht._)`${h} === undefined`;
  u.useDefaults === "empty" && (y = (0, ht._)`${y} || ${h} === null || ${h} === ""`), a.if(y, (0, ht._)`${h} = ${(0, ht.stringify)(r)}`);
}
var Ue = {}, Q = {};
Object.defineProperty(Q, "__esModule", { value: !0 });
Q.validateUnion = Q.validateArray = Q.usePattern = Q.callValidateCode = Q.schemaProperties = Q.allSchemaProperties = Q.noPropertyInData = Q.propertyInData = Q.isOwnProperty = Q.hasPropFunc = Q.reportMissingProp = Q.checkMissingProp = Q.checkReportMissingProp = void 0;
const se = X, Ir = ee, Je = Re, fs = ee;
function hs(e, t) {
  const { gen: r, data: a, it: n } = e;
  r.if(Dr(r, a, t, n.opts.ownProperties), () => {
    e.setParams({ missingProperty: (0, se._)`${t}` }, !0), e.error();
  });
}
Q.checkReportMissingProp = hs;
function ms({ gen: e, data: t, it: { opts: r } }, a, n) {
  return (0, se.or)(...a.map((i) => (0, se.and)(Dr(e, t, i, r.ownProperties), (0, se._)`${n} = ${i}`)));
}
Q.checkMissingProp = ms;
function ps(e, t) {
  e.setParams({ missingProperty: t }, !0), e.error();
}
Q.reportMissingProp = ps;
function ra(e) {
  return e.scopeValue("func", {
    // eslint-disable-next-line @typescript-eslint/unbound-method
    ref: Object.prototype.hasOwnProperty,
    code: (0, se._)`Object.prototype.hasOwnProperty`
  });
}
Q.hasPropFunc = ra;
function kr(e, t, r) {
  return (0, se._)`${ra(e)}.call(${t}, ${r})`;
}
Q.isOwnProperty = kr;
function $s(e, t, r, a) {
  const n = (0, se._)`${t}${(0, se.getProperty)(r)} !== undefined`;
  return a ? (0, se._)`${n} && ${kr(e, t, r)}` : n;
}
Q.propertyInData = $s;
function Dr(e, t, r, a) {
  const n = (0, se._)`${t}${(0, se.getProperty)(r)} === undefined`;
  return a ? (0, se.or)(n, (0, se.not)(kr(e, t, r))) : n;
}
Q.noPropertyInData = Dr;
function na(e) {
  return e ? Object.keys(e).filter((t) => t !== "__proto__") : [];
}
Q.allSchemaProperties = na;
function ys(e, t) {
  return na(t).filter((r) => !(0, Ir.alwaysValidSchema)(e, t[r]));
}
Q.schemaProperties = ys;
function vs({ schemaCode: e, data: t, it: { gen: r, topSchemaRef: a, schemaPath: n, errorPath: i }, it: u }, h, y, l) {
  const p = l ? (0, se._)`${e}, ${t}, ${a}${n}` : t, _ = [
    [Je.default.instancePath, (0, se.strConcat)(Je.default.instancePath, i)],
    [Je.default.parentData, u.parentData],
    [Je.default.parentDataProperty, u.parentDataProperty],
    [Je.default.rootData, Je.default.rootData]
  ];
  u.opts.dynamicRef && _.push([Je.default.dynamicAnchors, Je.default.dynamicAnchors]);
  const k = (0, se._)`${p}, ${r.object(..._)}`;
  return y !== se.nil ? (0, se._)`${h}.call(${y}, ${k})` : (0, se._)`${h}(${k})`;
}
Q.callValidateCode = vs;
const _s = (0, se._)`new RegExp`;
function gs({ gen: e, it: { opts: t } }, r) {
  const a = t.unicodeRegExp ? "u" : "", { regExp: n } = t.code, i = n(r, a);
  return e.scopeValue("pattern", {
    key: i.toString(),
    ref: i,
    code: (0, se._)`${n.code === "new RegExp" ? _s : (0, fs.useFunc)(e, n)}(${r}, ${a})`
  });
}
Q.usePattern = gs;
function ws(e) {
  const { gen: t, data: r, keyword: a, it: n } = e, i = t.name("valid");
  if (n.allErrors) {
    const h = t.let("valid", !0);
    return u(() => t.assign(h, !1)), h;
  }
  return t.var(i, !0), u(() => t.break()), i;
  function u(h) {
    const y = t.const("len", (0, se._)`${r}.length`);
    t.forRange("i", 0, y, (l) => {
      e.subschema({
        keyword: a,
        dataProp: l,
        dataPropType: Ir.Type.Num
      }, i), t.if((0, se.not)(i), h);
    });
  }
}
Q.validateArray = ws;
function Es(e) {
  const { gen: t, schema: r, keyword: a, it: n } = e;
  if (!Array.isArray(r))
    throw new Error("ajv implementation error");
  if (r.some((y) => (0, Ir.alwaysValidSchema)(n, y)) && !n.opts.unevaluated)
    return;
  const u = t.let("valid", !1), h = t.name("_valid");
  t.block(() => r.forEach((y, l) => {
    const p = e.subschema({
      keyword: a,
      schemaProp: l,
      compositeRule: !0
    }, h);
    t.assign(u, (0, se._)`${u} || ${h}`), e.mergeValidEvaluated(p, h) || t.if((0, se.not)(u));
  })), e.result(u, () => e.reset(), () => e.error(!0));
}
Q.validateUnion = Es;
Object.defineProperty(Ue, "__esModule", { value: !0 });
Ue.validateKeywordUsage = Ue.validSchemaType = Ue.funcKeywordCode = Ue.macroKeywordCode = void 0;
const ye = X, rt = Re, bs = Q, Ss = gt;
function Ps(e, t) {
  const { gen: r, keyword: a, schema: n, parentSchema: i, it: u } = e, h = t.macro.call(u.self, n, i, u), y = aa(r, a, h);
  u.opts.validateSchema !== !1 && u.self.validateSchema(h, !0);
  const l = r.name("valid");
  e.subschema({
    schema: h,
    schemaPath: ye.nil,
    errSchemaPath: `${u.errSchemaPath}/${a}`,
    topSchemaRef: y,
    compositeRule: !0
  }, l), e.pass(l, () => e.error(!0));
}
Ue.macroKeywordCode = Ps;
function Os(e, t) {
  var r;
  const { gen: a, keyword: n, schema: i, parentSchema: u, $data: h, it: y } = e;
  Ts(y, t);
  const l = !h && t.compile ? t.compile.call(y.self, i, u, y) : t.validate, p = aa(a, n, l), _ = a.let("valid");
  e.block$data(_, k), e.ok((r = t.valid) !== null && r !== void 0 ? r : _);
  function k() {
    if (t.errors === !1)
      O(), t.modifying && kn(e), g(() => e.error());
    else {
      const f = t.async ? I() : P();
      t.modifying && kn(e), g(() => Ns(e, f));
    }
  }
  function I() {
    const f = a.let("ruleErrs", null);
    return a.try(() => O((0, ye._)`await `), (m) => a.assign(_, !1).if((0, ye._)`${m} instanceof ${y.ValidationError}`, () => a.assign(f, (0, ye._)`${m}.errors`), () => a.throw(m))), f;
  }
  function P() {
    const f = (0, ye._)`${p}.errors`;
    return a.assign(f, null), O(ye.nil), f;
  }
  function O(f = t.async ? (0, ye._)`await ` : ye.nil) {
    const m = y.opts.passContext ? rt.default.this : rt.default.self, N = !("compile" in t && !h || t.schema === !1);
    a.assign(_, (0, ye._)`${f}${(0, bs.callValidateCode)(e, p, m, N)}`, t.modifying);
  }
  function g(f) {
    var m;
    a.if((0, ye.not)((m = t.valid) !== null && m !== void 0 ? m : _), f);
  }
}
Ue.funcKeywordCode = Os;
function kn(e) {
  const { gen: t, data: r, it: a } = e;
  t.if(a.parentData, () => t.assign(r, (0, ye._)`${a.parentData}[${a.parentDataProperty}]`));
}
function Ns(e, t) {
  const { gen: r } = e;
  r.if((0, ye._)`Array.isArray(${t})`, () => {
    r.assign(rt.default.vErrors, (0, ye._)`${rt.default.vErrors} === null ? ${t} : ${rt.default.vErrors}.concat(${t})`).assign(rt.default.errors, (0, ye._)`${rt.default.vErrors}.length`), (0, Ss.extendErrors)(e);
  }, () => e.error());
}
function Ts({ schemaEnv: e }, t) {
  if (t.async && !e.$async)
    throw new Error("async keyword in sync schema");
}
function aa(e, t, r) {
  if (r === void 0)
    throw new Error(`keyword "${t}" failed to compile`);
  return e.scopeValue("keyword", typeof r == "function" ? { ref: r } : { ref: r, code: (0, ye.stringify)(r) });
}
function Cs(e, t, r = !1) {
  return !t.length || t.some((a) => a === "array" ? Array.isArray(e) : a === "object" ? e && typeof e == "object" && !Array.isArray(e) : typeof e == a || r && typeof e > "u");
}
Ue.validSchemaType = Cs;
function Rs({ schema: e, opts: t, self: r, errSchemaPath: a }, n, i) {
  if (Array.isArray(n.keyword) ? !n.keyword.includes(i) : n.keyword !== i)
    throw new Error("ajv implementation error");
  const u = n.dependencies;
  if (u != null && u.some((h) => !Object.prototype.hasOwnProperty.call(e, h)))
    throw new Error(`parent schema must have dependencies of ${i}: ${u.join(",")}`);
  if (n.validateSchema && !n.validateSchema(e[i])) {
    const y = `keyword "${i}" value is invalid at path "${a}": ` + r.errorsText(n.validateSchema.errors);
    if (t.validateSchema === "log")
      r.logger.error(y);
    else
      throw new Error(y);
  }
}
Ue.validateKeywordUsage = Rs;
var Ye = {};
Object.defineProperty(Ye, "__esModule", { value: !0 });
Ye.extendSubschemaMode = Ye.extendSubschemaData = Ye.getSubschema = void 0;
const ze = X, sa = ee;
function js(e, { keyword: t, schemaProp: r, schema: a, schemaPath: n, errSchemaPath: i, topSchemaRef: u }) {
  if (t !== void 0 && a !== void 0)
    throw new Error('both "keyword" and "schema" passed, only one allowed');
  if (t !== void 0) {
    const h = e.schema[t];
    return r === void 0 ? {
      schema: h,
      schemaPath: (0, ze._)`${e.schemaPath}${(0, ze.getProperty)(t)}`,
      errSchemaPath: `${e.errSchemaPath}/${t}`
    } : {
      schema: h[r],
      schemaPath: (0, ze._)`${e.schemaPath}${(0, ze.getProperty)(t)}${(0, ze.getProperty)(r)}`,
      errSchemaPath: `${e.errSchemaPath}/${t}/${(0, sa.escapeFragment)(r)}`
    };
  }
  if (a !== void 0) {
    if (n === void 0 || i === void 0 || u === void 0)
      throw new Error('"schemaPath", "errSchemaPath" and "topSchemaRef" are required with "schema"');
    return {
      schema: a,
      schemaPath: n,
      topSchemaRef: u,
      errSchemaPath: i
    };
  }
  throw new Error('either "keyword" or "schema" must be passed');
}
Ye.getSubschema = js;
function Is(e, t, { dataProp: r, dataPropType: a, data: n, dataTypes: i, propertyName: u }) {
  if (n !== void 0 && r !== void 0)
    throw new Error('both "data" and "dataProp" passed, only one allowed');
  const { gen: h } = t;
  if (r !== void 0) {
    const { errorPath: l, dataPathArr: p, opts: _ } = t, k = h.let("data", (0, ze._)`${t.data}${(0, ze.getProperty)(r)}`, !0);
    y(k), e.errorPath = (0, ze.str)`${l}${(0, sa.getErrorPath)(r, a, _.jsPropertySyntax)}`, e.parentDataProperty = (0, ze._)`${r}`, e.dataPathArr = [...p, e.parentDataProperty];
  }
  if (n !== void 0) {
    const l = n instanceof ze.Name ? n : h.let("data", n, !0);
    y(l), u !== void 0 && (e.propertyName = u);
  }
  i && (e.dataTypes = i);
  function y(l) {
    e.data = l, e.dataLevel = t.dataLevel + 1, e.dataTypes = [], t.definedProperties = /* @__PURE__ */ new Set(), e.parentData = t.data, e.dataNames = [...t.dataNames, l];
  }
}
Ye.extendSubschemaData = Is;
function ks(e, { jtdDiscriminator: t, jtdMetadata: r, compositeRule: a, createErrors: n, allErrors: i }) {
  a !== void 0 && (e.compositeRule = a), n !== void 0 && (e.createErrors = n), i !== void 0 && (e.allErrors = i), e.jtdDiscriminator = t, e.jtdMetadata = r;
}
Ye.extendSubschemaMode = ks;
var pe = {}, oa = function e(t, r) {
  if (t === r)
    return !0;
  if (t && r && typeof t == "object" && typeof r == "object") {
    if (t.constructor !== r.constructor)
      return !1;
    var a, n, i;
    if (Array.isArray(t)) {
      if (a = t.length, a != r.length)
        return !1;
      for (n = a; n-- !== 0; )
        if (!e(t[n], r[n]))
          return !1;
      return !0;
    }
    if (t.constructor === RegExp)
      return t.source === r.source && t.flags === r.flags;
    if (t.valueOf !== Object.prototype.valueOf)
      return t.valueOf() === r.valueOf();
    if (t.toString !== Object.prototype.toString)
      return t.toString() === r.toString();
    if (i = Object.keys(t), a = i.length, a !== Object.keys(r).length)
      return !1;
    for (n = a; n-- !== 0; )
      if (!Object.prototype.hasOwnProperty.call(r, i[n]))
        return !1;
    for (n = a; n-- !== 0; ) {
      var u = i[n];
      if (!e(t[u], r[u]))
        return !1;
    }
    return !0;
  }
  return t !== t && r !== r;
}, ia = { exports: {} }, Be = ia.exports = function(e, t, r) {
  typeof t == "function" && (r = t, t = {}), r = t.cb || r;
  var a = typeof r == "function" ? r : r.pre || function() {
  }, n = r.post || function() {
  };
  tr(t, a, n, e, "", e);
};
Be.keywords = {
  additionalItems: !0,
  items: !0,
  contains: !0,
  additionalProperties: !0,
  propertyNames: !0,
  not: !0,
  if: !0,
  then: !0,
  else: !0
};
Be.arrayKeywords = {
  items: !0,
  allOf: !0,
  anyOf: !0,
  oneOf: !0
};
Be.propsKeywords = {
  $defs: !0,
  definitions: !0,
  properties: !0,
  patternProperties: !0,
  dependencies: !0
};
Be.skipKeywords = {
  default: !0,
  enum: !0,
  const: !0,
  required: !0,
  maximum: !0,
  minimum: !0,
  exclusiveMaximum: !0,
  exclusiveMinimum: !0,
  multipleOf: !0,
  maxLength: !0,
  minLength: !0,
  pattern: !0,
  format: !0,
  maxItems: !0,
  minItems: !0,
  uniqueItems: !0,
  maxProperties: !0,
  minProperties: !0
};
function tr(e, t, r, a, n, i, u, h, y, l) {
  if (a && typeof a == "object" && !Array.isArray(a)) {
    t(a, n, i, u, h, y, l);
    for (var p in a) {
      var _ = a[p];
      if (Array.isArray(_)) {
        if (p in Be.arrayKeywords)
          for (var k = 0; k < _.length; k++)
            tr(e, t, r, _[k], n + "/" + p + "/" + k, i, n, p, a, k);
      } else if (p in Be.propsKeywords) {
        if (_ && typeof _ == "object")
          for (var I in _)
            tr(e, t, r, _[I], n + "/" + p + "/" + Ds(I), i, n, p, a, I);
      } else
        (p in Be.keywords || e.allKeys && !(p in Be.skipKeywords)) && tr(e, t, r, _, n + "/" + p, i, n, p, a);
    }
    r(a, n, i, u, h, y, l);
  }
}
function Ds(e) {
  return e.replace(/~/g, "~0").replace(/\//g, "~1");
}
var As = ia.exports;
Object.defineProperty(pe, "__esModule", { value: !0 });
pe.getSchemaRefs = pe.resolveUrl = pe.normalizeId = pe._getFullPath = pe.getFullPath = pe.inlineRef = void 0;
const Ms = ee, Vs = oa, Fs = As, zs = /* @__PURE__ */ new Set([
  "type",
  "format",
  "pattern",
  "maxLength",
  "minLength",
  "maxProperties",
  "minProperties",
  "maxItems",
  "minItems",
  "maximum",
  "minimum",
  "uniqueItems",
  "multipleOf",
  "required",
  "enum",
  "const"
]);
function Us(e, t = !0) {
  return typeof e == "boolean" ? !0 : t === !0 ? !Sr(e) : t ? ca(e) <= t : !1;
}
pe.inlineRef = Us;
const qs = /* @__PURE__ */ new Set([
  "$ref",
  "$recursiveRef",
  "$recursiveAnchor",
  "$dynamicRef",
  "$dynamicAnchor"
]);
function Sr(e) {
  for (const t in e) {
    if (qs.has(t))
      return !0;
    const r = e[t];
    if (Array.isArray(r) && r.some(Sr) || typeof r == "object" && Sr(r))
      return !0;
  }
  return !1;
}
function ca(e) {
  let t = 0;
  for (const r in e) {
    if (r === "$ref")
      return 1 / 0;
    if (t++, !zs.has(r) && (typeof e[r] == "object" && (0, Ms.eachItem)(e[r], (a) => t += ca(a)), t === 1 / 0))
      return 1 / 0;
  }
  return t;
}
function ua(e, t = "", r) {
  r !== !1 && (t = $t(t));
  const a = e.parse(t);
  return da(e, a);
}
pe.getFullPath = ua;
function da(e, t) {
  return e.serialize(t).split("#")[0] + "#";
}
pe._getFullPath = da;
const Ks = /#\/?$/;
function $t(e) {
  return e ? e.replace(Ks, "") : "";
}
pe.normalizeId = $t;
function Ls(e, t, r) {
  return r = $t(r), e.resolve(t, r);
}
pe.resolveUrl = Ls;
const Hs = /^[a-z_][-a-z0-9._]*$/i;
function Gs(e, t) {
  if (typeof e == "boolean")
    return {};
  const { schemaId: r, uriResolver: a } = this.opts, n = $t(e[r] || t), i = { "": n }, u = ua(a, n, !1), h = {}, y = /* @__PURE__ */ new Set();
  return Fs(e, { allKeys: !0 }, (_, k, I, P) => {
    if (P === void 0)
      return;
    const O = u + k;
    let g = i[P];
    typeof _[r] == "string" && (g = f.call(this, _[r])), m.call(this, _.$anchor), m.call(this, _.$dynamicAnchor), i[k] = g;
    function f(N) {
      const j = this.opts.uriResolver.resolve;
      if (N = $t(g ? j(g, N) : N), y.has(N))
        throw p(N);
      y.add(N);
      let V = this.refs[N];
      return typeof V == "string" && (V = this.refs[V]), typeof V == "object" ? l(_, V.schema, N) : N !== $t(O) && (N[0] === "#" ? (l(_, h[N], N), h[N] = _) : this.refs[N] = O), N;
    }
    function m(N) {
      if (typeof N == "string") {
        if (!Hs.test(N))
          throw new Error(`invalid anchor "${N}"`);
        f.call(this, `#${N}`);
      }
    }
  }), h;
  function l(_, k, I) {
    if (k !== void 0 && !Vs(_, k))
      throw p(I);
  }
  function p(_) {
    return new Error(`reference "${_}" resolves to more than one schema`);
  }
}
pe.getSchemaRefs = Gs;
Object.defineProperty(Oe, "__esModule", { value: !0 });
Oe.getData = Oe.KeywordCxt = Oe.validateFunctionCode = void 0;
const la = yt, Dn = Ut, Ar = Ke, sr = Ut, Js = dr, At = Ue, $r = Ye, K = X, W = Re, Ws = pe, Le = ee, It = gt;
function Bs(e) {
  if (ma(e) && (pa(e), ha(e))) {
    Qs(e);
    return;
  }
  fa(e, () => (0, la.topBoolOrEmptySchema)(e));
}
Oe.validateFunctionCode = Bs;
function fa({ gen: e, validateName: t, schema: r, schemaEnv: a, opts: n }, i) {
  n.code.es5 ? e.func(t, (0, K._)`${W.default.data}, ${W.default.valCxt}`, a.$async, () => {
    e.code((0, K._)`"use strict"; ${An(r, n)}`), Xs(e, n), e.code(i);
  }) : e.func(t, (0, K._)`${W.default.data}, ${Ys(n)}`, a.$async, () => e.code(An(r, n)).code(i));
}
function Ys(e) {
  return (0, K._)`{${W.default.instancePath}="", ${W.default.parentData}, ${W.default.parentDataProperty}, ${W.default.rootData}=${W.default.data}${e.dynamicRef ? (0, K._)`, ${W.default.dynamicAnchors}={}` : K.nil}}={}`;
}
function Xs(e, t) {
  e.if(W.default.valCxt, () => {
    e.var(W.default.instancePath, (0, K._)`${W.default.valCxt}.${W.default.instancePath}`), e.var(W.default.parentData, (0, K._)`${W.default.valCxt}.${W.default.parentData}`), e.var(W.default.parentDataProperty, (0, K._)`${W.default.valCxt}.${W.default.parentDataProperty}`), e.var(W.default.rootData, (0, K._)`${W.default.valCxt}.${W.default.rootData}`), t.dynamicRef && e.var(W.default.dynamicAnchors, (0, K._)`${W.default.valCxt}.${W.default.dynamicAnchors}`);
  }, () => {
    e.var(W.default.instancePath, (0, K._)`""`), e.var(W.default.parentData, (0, K._)`undefined`), e.var(W.default.parentDataProperty, (0, K._)`undefined`), e.var(W.default.rootData, W.default.data), t.dynamicRef && e.var(W.default.dynamicAnchors, (0, K._)`{}`);
  });
}
function Qs(e) {
  const { schema: t, opts: r, gen: a } = e;
  fa(e, () => {
    r.$comment && t.$comment && ya(e), ro(e), a.let(W.default.vErrors, null), a.let(W.default.errors, 0), r.unevaluated && Zs(e), $a(e), so(e);
  });
}
function Zs(e) {
  const { gen: t, validateName: r } = e;
  e.evaluated = t.const("evaluated", (0, K._)`${r}.evaluated`), t.if((0, K._)`${e.evaluated}.dynamicProps`, () => t.assign((0, K._)`${e.evaluated}.props`, (0, K._)`undefined`)), t.if((0, K._)`${e.evaluated}.dynamicItems`, () => t.assign((0, K._)`${e.evaluated}.items`, (0, K._)`undefined`));
}
function An(e, t) {
  const r = typeof e == "object" && e[t.schemaId];
  return r && (t.code.source || t.code.process) ? (0, K._)`/*# sourceURL=${r} */` : K.nil;
}
function xs(e, t) {
  if (ma(e) && (pa(e), ha(e))) {
    eo(e, t);
    return;
  }
  (0, la.boolOrEmptySchema)(e, t);
}
function ha({ schema: e, self: t }) {
  if (typeof e == "boolean")
    return !e;
  for (const r in e)
    if (t.RULES.all[r])
      return !0;
  return !1;
}
function ma(e) {
  return typeof e.schema != "boolean";
}
function eo(e, t) {
  const { schema: r, gen: a, opts: n } = e;
  n.$comment && r.$comment && ya(e), no(e), ao(e);
  const i = a.const("_errs", W.default.errors);
  $a(e, i), a.var(t, (0, K._)`${i} === ${W.default.errors}`);
}
function pa(e) {
  (0, Le.checkUnknownRules)(e), to(e);
}
function $a(e, t) {
  if (e.opts.jtd)
    return Mn(e, [], !1, t);
  const r = (0, Dn.getSchemaTypes)(e.schema), a = (0, Dn.coerceAndCheckDataType)(e, r);
  Mn(e, r, !a, t);
}
function to(e) {
  const { schema: t, errSchemaPath: r, opts: a, self: n } = e;
  t.$ref && a.ignoreKeywordsWithRef && (0, Le.schemaHasRulesButRef)(t, n.RULES) && n.logger.warn(`$ref: keywords ignored in schema at path "${r}"`);
}
function ro(e) {
  const { schema: t, opts: r } = e;
  t.default !== void 0 && r.useDefaults && r.strictSchema && (0, Le.checkStrictMode)(e, "default is ignored in the schema root");
}
function no(e) {
  const t = e.schema[e.opts.schemaId];
  t && (e.baseId = (0, Ws.resolveUrl)(e.opts.uriResolver, e.baseId, t));
}
function ao(e) {
  if (e.schema.$async && !e.schemaEnv.$async)
    throw new Error("async schema in sync schema");
}
function ya({ gen: e, schemaEnv: t, schema: r, errSchemaPath: a, opts: n }) {
  const i = r.$comment;
  if (n.$comment === !0)
    e.code((0, K._)`${W.default.self}.logger.log(${i})`);
  else if (typeof n.$comment == "function") {
    const u = (0, K.str)`${a}/$comment`, h = e.scopeValue("root", { ref: t.root });
    e.code((0, K._)`${W.default.self}.opts.$comment(${i}, ${u}, ${h}.schema)`);
  }
}
function so(e) {
  const { gen: t, schemaEnv: r, validateName: a, ValidationError: n, opts: i } = e;
  r.$async ? t.if((0, K._)`${W.default.errors} === 0`, () => t.return(W.default.data), () => t.throw((0, K._)`new ${n}(${W.default.vErrors})`)) : (t.assign((0, K._)`${a}.errors`, W.default.vErrors), i.unevaluated && oo(e), t.return((0, K._)`${W.default.errors} === 0`));
}
function oo({ gen: e, evaluated: t, props: r, items: a }) {
  r instanceof K.Name && e.assign((0, K._)`${t}.props`, r), a instanceof K.Name && e.assign((0, K._)`${t}.items`, a);
}
function Mn(e, t, r, a) {
  const { gen: n, schema: i, data: u, allErrors: h, opts: y, self: l } = e, { RULES: p } = l;
  if (i.$ref && (y.ignoreKeywordsWithRef || !(0, Le.schemaHasRulesButRef)(i, p))) {
    n.block(() => ga(e, "$ref", p.all.$ref.definition));
    return;
  }
  y.jtd || io(e, t), n.block(() => {
    for (const k of p.rules)
      _(k);
    _(p.post);
  });
  function _(k) {
    (0, Ar.shouldUseGroup)(i, k) && (k.type ? (n.if((0, sr.checkDataType)(k.type, u, y.strictNumbers)), Vn(e, k), t.length === 1 && t[0] === k.type && r && (n.else(), (0, sr.reportTypeError)(e)), n.endIf()) : Vn(e, k), h || n.if((0, K._)`${W.default.errors} === ${a || 0}`));
  }
}
function Vn(e, t) {
  const { gen: r, schema: a, opts: { useDefaults: n } } = e;
  n && (0, Js.assignDefaults)(e, t.type), r.block(() => {
    for (const i of t.rules)
      (0, Ar.shouldUseRule)(a, i) && ga(e, i.keyword, i.definition, t.type);
  });
}
function io(e, t) {
  e.schemaEnv.meta || !e.opts.strictTypes || (co(e, t), e.opts.allowUnionTypes || uo(e, t), lo(e, e.dataTypes));
}
function co(e, t) {
  if (t.length) {
    if (!e.dataTypes.length) {
      e.dataTypes = t;
      return;
    }
    t.forEach((r) => {
      va(e.dataTypes, r) || Mr(e, `type "${r}" not allowed by context "${e.dataTypes.join(",")}"`);
    }), ho(e, t);
  }
}
function uo(e, t) {
  t.length > 1 && !(t.length === 2 && t.includes("null")) && Mr(e, "use allowUnionTypes to allow union type keyword");
}
function lo(e, t) {
  const r = e.self.RULES.all;
  for (const a in r) {
    const n = r[a];
    if (typeof n == "object" && (0, Ar.shouldUseRule)(e.schema, n)) {
      const { type: i } = n.definition;
      i.length && !i.some((u) => fo(t, u)) && Mr(e, `missing type "${i.join(",")}" for keyword "${a}"`);
    }
  }
}
function fo(e, t) {
  return e.includes(t) || t === "number" && e.includes("integer");
}
function va(e, t) {
  return e.includes(t) || t === "integer" && e.includes("number");
}
function ho(e, t) {
  const r = [];
  for (const a of e.dataTypes)
    va(t, a) ? r.push(a) : t.includes("integer") && a === "number" && r.push("integer");
  e.dataTypes = r;
}
function Mr(e, t) {
  const r = e.schemaEnv.baseId + e.errSchemaPath;
  t += ` at "${r}" (strictTypes)`, (0, Le.checkStrictMode)(e, t, e.opts.strictTypes);
}
class _a {
  constructor(t, r, a) {
    if ((0, At.validateKeywordUsage)(t, r, a), this.gen = t.gen, this.allErrors = t.allErrors, this.keyword = a, this.data = t.data, this.schema = t.schema[a], this.$data = r.$data && t.opts.$data && this.schema && this.schema.$data, this.schemaValue = (0, Le.schemaRefOrVal)(t, this.schema, a, this.$data), this.schemaType = r.schemaType, this.parentSchema = t.schema, this.params = {}, this.it = t, this.def = r, this.$data)
      this.schemaCode = t.gen.const("vSchema", wa(this.$data, t));
    else if (this.schemaCode = this.schemaValue, !(0, At.validSchemaType)(this.schema, r.schemaType, r.allowUndefined))
      throw new Error(`${a} value must be ${JSON.stringify(r.schemaType)}`);
    ("code" in r ? r.trackErrors : r.errors !== !1) && (this.errsCount = t.gen.const("_errs", W.default.errors));
  }
  result(t, r, a) {
    this.failResult((0, K.not)(t), r, a);
  }
  failResult(t, r, a) {
    this.gen.if(t), a ? a() : this.error(), r ? (this.gen.else(), r(), this.allErrors && this.gen.endIf()) : this.allErrors ? this.gen.endIf() : this.gen.else();
  }
  pass(t, r) {
    this.failResult((0, K.not)(t), void 0, r);
  }
  fail(t) {
    if (t === void 0) {
      this.error(), this.allErrors || this.gen.if(!1);
      return;
    }
    this.gen.if(t), this.error(), this.allErrors ? this.gen.endIf() : this.gen.else();
  }
  fail$data(t) {
    if (!this.$data)
      return this.fail(t);
    const { schemaCode: r } = this;
    this.fail((0, K._)`${r} !== undefined && (${(0, K.or)(this.invalid$data(), t)})`);
  }
  error(t, r, a) {
    if (r) {
      this.setParams(r), this._error(t, a), this.setParams({});
      return;
    }
    this._error(t, a);
  }
  _error(t, r) {
    (t ? It.reportExtraError : It.reportError)(this, this.def.error, r);
  }
  $dataError() {
    (0, It.reportError)(this, this.def.$dataError || It.keyword$DataError);
  }
  reset() {
    if (this.errsCount === void 0)
      throw new Error('add "trackErrors" to keyword definition');
    (0, It.resetErrorsCount)(this.gen, this.errsCount);
  }
  ok(t) {
    this.allErrors || this.gen.if(t);
  }
  setParams(t, r) {
    r ? Object.assign(this.params, t) : this.params = t;
  }
  block$data(t, r, a = K.nil) {
    this.gen.block(() => {
      this.check$data(t, a), r();
    });
  }
  check$data(t = K.nil, r = K.nil) {
    if (!this.$data)
      return;
    const { gen: a, schemaCode: n, schemaType: i, def: u } = this;
    a.if((0, K.or)((0, K._)`${n} === undefined`, r)), t !== K.nil && a.assign(t, !0), (i.length || u.validateSchema) && (a.elseIf(this.invalid$data()), this.$dataError(), t !== K.nil && a.assign(t, !1)), a.else();
  }
  invalid$data() {
    const { gen: t, schemaCode: r, schemaType: a, def: n, it: i } = this;
    return (0, K.or)(u(), h());
    function u() {
      if (a.length) {
        if (!(r instanceof K.Name))
          throw new Error("ajv implementation error");
        const y = Array.isArray(a) ? a : [a];
        return (0, K._)`${(0, sr.checkDataTypes)(y, r, i.opts.strictNumbers, sr.DataType.Wrong)}`;
      }
      return K.nil;
    }
    function h() {
      if (n.validateSchema) {
        const y = t.scopeValue("validate$data", { ref: n.validateSchema });
        return (0, K._)`!${y}(${r})`;
      }
      return K.nil;
    }
  }
  subschema(t, r) {
    const a = (0, $r.getSubschema)(this.it, t);
    (0, $r.extendSubschemaData)(a, this.it, t), (0, $r.extendSubschemaMode)(a, t);
    const n = { ...this.it, ...a, items: void 0, props: void 0 };
    return xs(n, r), n;
  }
  mergeEvaluated(t, r) {
    const { it: a, gen: n } = this;
    a.opts.unevaluated && (a.props !== !0 && t.props !== void 0 && (a.props = Le.mergeEvaluated.props(n, t.props, a.props, r)), a.items !== !0 && t.items !== void 0 && (a.items = Le.mergeEvaluated.items(n, t.items, a.items, r)));
  }
  mergeValidEvaluated(t, r) {
    const { it: a, gen: n } = this;
    if (a.opts.unevaluated && (a.props !== !0 || a.items !== !0))
      return n.if(r, () => this.mergeEvaluated(t, K.Name)), !0;
  }
}
Oe.KeywordCxt = _a;
function ga(e, t, r, a) {
  const n = new _a(e, r, t);
  "code" in r ? r.code(n, a) : n.$data && r.validate ? (0, At.funcKeywordCode)(n, r) : "macro" in r ? (0, At.macroKeywordCode)(n, r) : (r.compile || r.validate) && (0, At.funcKeywordCode)(n, r);
}
const mo = /^\/(?:[^~]|~0|~1)*$/, po = /^([0-9]+)(#|\/(?:[^~]|~0|~1)*)?$/;
function wa(e, { dataLevel: t, dataNames: r, dataPathArr: a }) {
  let n, i;
  if (e === "")
    return W.default.rootData;
  if (e[0] === "/") {
    if (!mo.test(e))
      throw new Error(`Invalid JSON-pointer: ${e}`);
    n = e, i = W.default.rootData;
  } else {
    const l = po.exec(e);
    if (!l)
      throw new Error(`Invalid JSON-pointer: ${e}`);
    const p = +l[1];
    if (n = l[2], n === "#") {
      if (p >= t)
        throw new Error(y("property/index", p));
      return a[t - p];
    }
    if (p > t)
      throw new Error(y("data", p));
    if (i = r[t - p], !n)
      return i;
  }
  let u = i;
  const h = n.split("/");
  for (const l of h)
    l && (i = (0, K._)`${i}${(0, K.getProperty)((0, Le.unescapeJsonPointer)(l))}`, u = (0, K._)`${u} && ${i}`);
  return u;
  function y(l, p) {
    return `Cannot access ${l} ${p} levels up, current level is ${t}`;
  }
}
Oe.getData = wa;
var qt = {};
Object.defineProperty(qt, "__esModule", { value: !0 });
class $o extends Error {
  constructor(t) {
    super("validation failed"), this.errors = t, this.ajv = this.validation = !0;
  }
}
qt.default = $o;
var Kt = {};
Object.defineProperty(Kt, "__esModule", { value: !0 });
const yr = pe;
class yo extends Error {
  constructor(t, r, a, n) {
    super(n || `can't resolve reference ${a} from id ${r}`), this.missingRef = (0, yr.resolveUrl)(t, r, a), this.missingSchema = (0, yr.normalizeId)((0, yr.getFullPath)(t, this.missingRef));
  }
}
Kt.default = yo;
var we = {};
Object.defineProperty(we, "__esModule", { value: !0 });
we.resolveSchema = we.getCompilingSchema = we.resolveRef = we.compileSchema = we.SchemaEnv = void 0;
const Ne = X, vo = qt, tt = Re, Ce = pe, Fn = ee, _o = Oe;
class lr {
  constructor(t) {
    var r;
    this.refs = {}, this.dynamicAnchors = {};
    let a;
    typeof t.schema == "object" && (a = t.schema), this.schema = t.schema, this.schemaId = t.schemaId, this.root = t.root || this, this.baseId = (r = t.baseId) !== null && r !== void 0 ? r : (0, Ce.normalizeId)(a == null ? void 0 : a[t.schemaId || "$id"]), this.schemaPath = t.schemaPath, this.localRefs = t.localRefs, this.meta = t.meta, this.$async = a == null ? void 0 : a.$async, this.refs = {};
  }
}
we.SchemaEnv = lr;
function Vr(e) {
  const t = Ea.call(this, e);
  if (t)
    return t;
  const r = (0, Ce.getFullPath)(this.opts.uriResolver, e.root.baseId), { es5: a, lines: n } = this.opts.code, { ownProperties: i } = this.opts, u = new Ne.CodeGen(this.scope, { es5: a, lines: n, ownProperties: i });
  let h;
  e.$async && (h = u.scopeValue("Error", {
    ref: vo.default,
    code: (0, Ne._)`require("ajv/dist/runtime/validation_error").default`
  }));
  const y = u.scopeName("validate");
  e.validateName = y;
  const l = {
    gen: u,
    allErrors: this.opts.allErrors,
    data: tt.default.data,
    parentData: tt.default.parentData,
    parentDataProperty: tt.default.parentDataProperty,
    dataNames: [tt.default.data],
    dataPathArr: [Ne.nil],
    dataLevel: 0,
    dataTypes: [],
    definedProperties: /* @__PURE__ */ new Set(),
    topSchemaRef: u.scopeValue("schema", this.opts.code.source === !0 ? { ref: e.schema, code: (0, Ne.stringify)(e.schema) } : { ref: e.schema }),
    validateName: y,
    ValidationError: h,
    schema: e.schema,
    schemaEnv: e,
    rootId: r,
    baseId: e.baseId || r,
    schemaPath: Ne.nil,
    errSchemaPath: e.schemaPath || (this.opts.jtd ? "" : "#"),
    errorPath: (0, Ne._)`""`,
    opts: this.opts,
    self: this
  };
  let p;
  try {
    this._compilations.add(e), (0, _o.validateFunctionCode)(l), u.optimize(this.opts.code.optimize);
    const _ = u.toString();
    p = `${u.scopeRefs(tt.default.scope)}return ${_}`, this.opts.code.process && (p = this.opts.code.process(p, e));
    const I = new Function(`${tt.default.self}`, `${tt.default.scope}`, p)(this, this.scope.get());
    if (this.scope.value(y, { ref: I }), I.errors = null, I.schema = e.schema, I.schemaEnv = e, e.$async && (I.$async = !0), this.opts.code.source === !0 && (I.source = { validateName: y, validateCode: _, scopeValues: u._values }), this.opts.unevaluated) {
      const { props: P, items: O } = l;
      I.evaluated = {
        props: P instanceof Ne.Name ? void 0 : P,
        items: O instanceof Ne.Name ? void 0 : O,
        dynamicProps: P instanceof Ne.Name,
        dynamicItems: O instanceof Ne.Name
      }, I.source && (I.source.evaluated = (0, Ne.stringify)(I.evaluated));
    }
    return e.validate = I, e;
  } catch (_) {
    throw delete e.validate, delete e.validateName, p && this.logger.error("Error compiling schema, function code:", p), _;
  } finally {
    this._compilations.delete(e);
  }
}
we.compileSchema = Vr;
function go(e, t, r) {
  var a;
  r = (0, Ce.resolveUrl)(this.opts.uriResolver, t, r);
  const n = e.refs[r];
  if (n)
    return n;
  let i = bo.call(this, e, r);
  if (i === void 0) {
    const u = (a = e.localRefs) === null || a === void 0 ? void 0 : a[r], { schemaId: h } = this.opts;
    u && (i = new lr({ schema: u, schemaId: h, root: e, baseId: t }));
  }
  if (i !== void 0)
    return e.refs[r] = wo.call(this, i);
}
we.resolveRef = go;
function wo(e) {
  return (0, Ce.inlineRef)(e.schema, this.opts.inlineRefs) ? e.schema : e.validate ? e : Vr.call(this, e);
}
function Ea(e) {
  for (const t of this._compilations)
    if (Eo(t, e))
      return t;
}
we.getCompilingSchema = Ea;
function Eo(e, t) {
  return e.schema === t.schema && e.root === t.root && e.baseId === t.baseId;
}
function bo(e, t) {
  let r;
  for (; typeof (r = this.refs[t]) == "string"; )
    t = r;
  return r || this.schemas[t] || fr.call(this, e, t);
}
function fr(e, t) {
  const r = this.opts.uriResolver.parse(t), a = (0, Ce._getFullPath)(this.opts.uriResolver, r);
  let n = (0, Ce.getFullPath)(this.opts.uriResolver, e.baseId, void 0);
  if (Object.keys(e.schema).length > 0 && a === n)
    return vr.call(this, r, e);
  const i = (0, Ce.normalizeId)(a), u = this.refs[i] || this.schemas[i];
  if (typeof u == "string") {
    const h = fr.call(this, e, u);
    return typeof (h == null ? void 0 : h.schema) != "object" ? void 0 : vr.call(this, r, h);
  }
  if (typeof (u == null ? void 0 : u.schema) == "object") {
    if (u.validate || Vr.call(this, u), i === (0, Ce.normalizeId)(t)) {
      const { schema: h } = u, { schemaId: y } = this.opts, l = h[y];
      return l && (n = (0, Ce.resolveUrl)(this.opts.uriResolver, n, l)), new lr({ schema: h, schemaId: y, root: e, baseId: n });
    }
    return vr.call(this, r, u);
  }
}
we.resolveSchema = fr;
const So = /* @__PURE__ */ new Set([
  "properties",
  "patternProperties",
  "enum",
  "dependencies",
  "definitions"
]);
function vr(e, { baseId: t, schema: r, root: a }) {
  var n;
  if (((n = e.fragment) === null || n === void 0 ? void 0 : n[0]) !== "/")
    return;
  for (const h of e.fragment.slice(1).split("/")) {
    if (typeof r == "boolean")
      return;
    const y = r[(0, Fn.unescapeFragment)(h)];
    if (y === void 0)
      return;
    r = y;
    const l = typeof r == "object" && r[this.opts.schemaId];
    !So.has(h) && l && (t = (0, Ce.resolveUrl)(this.opts.uriResolver, t, l));
  }
  let i;
  if (typeof r != "boolean" && r.$ref && !(0, Fn.schemaHasRulesButRef)(r, this.RULES)) {
    const h = (0, Ce.resolveUrl)(this.opts.uriResolver, t, r.$ref);
    i = fr.call(this, a, h);
  }
  const { schemaId: u } = this.opts;
  if (i = i || new lr({ schema: r, schemaId: u, root: a, baseId: t }), i.schema !== i.root.schema)
    return i;
}
const Po = "https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#", Oo = "Meta-schema for $data reference (JSON AnySchema extension proposal)", No = "object", To = [
  "$data"
], Co = {
  $data: {
    type: "string",
    anyOf: [
      {
        format: "relative-json-pointer"
      },
      {
        format: "json-pointer"
      }
    ]
  }
}, Ro = !1, jo = {
  $id: Po,
  description: Oo,
  type: No,
  required: To,
  properties: Co,
  additionalProperties: Ro
};
var Fr = {}, Pr = { exports: {} };
/** @license URI.js v4.4.1 (c) 2011 Gary Court. License: http://github.com/garycourt/uri-js */
(function(e, t) {
  (function(r, a) {
    a(t);
  })(Qa, function(r) {
    function a() {
      for (var d = arguments.length, o = Array(d), $ = 0; $ < d; $++)
        o[$] = arguments[$];
      if (o.length > 1) {
        o[0] = o[0].slice(0, -1);
        for (var R = o.length - 1, C = 1; C < R; ++C)
          o[C] = o[C].slice(1, -1);
        return o[R] = o[R].slice(1), o.join("");
      } else
        return o[0];
    }
    function n(d) {
      return "(?:" + d + ")";
    }
    function i(d) {
      return d === void 0 ? "undefined" : d === null ? "null" : Object.prototype.toString.call(d).split(" ").pop().split("]").shift().toLowerCase();
    }
    function u(d) {
      return d.toUpperCase();
    }
    function h(d) {
      return d != null ? d instanceof Array ? d : typeof d.length != "number" || d.split || d.setInterval || d.call ? [d] : Array.prototype.slice.call(d) : [];
    }
    function y(d, o) {
      var $ = d;
      if (o)
        for (var R in o)
          $[R] = o[R];
      return $;
    }
    function l(d) {
      var o = "[A-Za-z]", $ = "[0-9]", R = a($, "[A-Fa-f]"), C = n(n("%[EFef]" + R + "%" + R + R + "%" + R + R) + "|" + n("%[89A-Fa-f]" + R + "%" + R + R) + "|" + n("%" + R + R)), L = "[\\:\\/\\?\\#\\[\\]\\@]", G = "[\\!\\$\\&\\'\\(\\)\\*\\+\\,\\;\\=]", x = a(L, G), ae = d ? "[\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF]" : "[]", de = d ? "[\\uE000-\\uF8FF]" : "[]", Z = a(o, $, "[\\-\\.\\_\\~]", ae);
      n(o + a(o, $, "[\\+\\-\\.]") + "*"), n(n(C + "|" + a(Z, G, "[\\:]")) + "*");
      var ne = n(n("25[0-5]") + "|" + n("2[0-4]" + $) + "|" + n("1" + $ + $) + "|" + n("0?[1-9]" + $) + "|0?0?" + $), le = n(ne + "\\." + ne + "\\." + ne + "\\." + ne), B = n(R + "{1,4}"), ie = n(n(B + "\\:" + B) + "|" + le), he = n(n(B + "\\:") + "{6}" + ie), ce = n("\\:\\:" + n(B + "\\:") + "{5}" + ie), Ge = n(n(B) + "?\\:\\:" + n(B + "\\:") + "{4}" + ie), Me = n(n(n(B + "\\:") + "{0,1}" + B) + "?\\:\\:" + n(B + "\\:") + "{3}" + ie), Ve = n(n(n(B + "\\:") + "{0,2}" + B) + "?\\:\\:" + n(B + "\\:") + "{2}" + ie), ft = n(n(n(B + "\\:") + "{0,3}" + B) + "?\\:\\:" + B + "\\:" + ie), xe = n(n(n(B + "\\:") + "{0,4}" + B) + "?\\:\\:" + ie), Se = n(n(n(B + "\\:") + "{0,5}" + B) + "?\\:\\:" + B), Fe = n(n(n(B + "\\:") + "{0,6}" + B) + "?\\:\\:"), et = n([he, ce, Ge, Me, Ve, ft, xe, Se, Fe].join("|")), qe = n(n(Z + "|" + C) + "+");
      n("[vV]" + R + "+\\." + a(Z, G, "[\\:]") + "+"), n(n(C + "|" + a(Z, G)) + "*");
      var Rt = n(C + "|" + a(Z, G, "[\\:\\@]"));
      return n(n(C + "|" + a(Z, G, "[\\@]")) + "+"), n(n(Rt + "|" + a("[\\/\\?]", de)) + "*"), {
        NOT_SCHEME: new RegExp(a("[^]", o, $, "[\\+\\-\\.]"), "g"),
        NOT_USERINFO: new RegExp(a("[^\\%\\:]", Z, G), "g"),
        NOT_HOST: new RegExp(a("[^\\%\\[\\]\\:]", Z, G), "g"),
        NOT_PATH: new RegExp(a("[^\\%\\/\\:\\@]", Z, G), "g"),
        NOT_PATH_NOSCHEME: new RegExp(a("[^\\%\\/\\@]", Z, G), "g"),
        NOT_QUERY: new RegExp(a("[^\\%]", Z, G, "[\\:\\@\\/\\?]", de), "g"),
        NOT_FRAGMENT: new RegExp(a("[^\\%]", Z, G, "[\\:\\@\\/\\?]"), "g"),
        ESCAPE: new RegExp(a("[^]", Z, G), "g"),
        UNRESERVED: new RegExp(Z, "g"),
        OTHER_CHARS: new RegExp(a("[^\\%]", Z, x), "g"),
        PCT_ENCODED: new RegExp(C, "g"),
        IPV4ADDRESS: new RegExp("^(" + le + ")$"),
        IPV6ADDRESS: new RegExp("^\\[?(" + et + ")" + n(n("\\%25|\\%(?!" + R + "{2})") + "(" + qe + ")") + "?\\]?$")
        //RFC 6874, with relaxed parsing rules
      };
    }
    var p = l(!1), _ = l(!0), k = /* @__PURE__ */ function() {
      function d(o, $) {
        var R = [], C = !0, L = !1, G = void 0;
        try {
          for (var x = o[Symbol.iterator](), ae; !(C = (ae = x.next()).done) && (R.push(ae.value), !($ && R.length === $)); C = !0)
            ;
        } catch (de) {
          L = !0, G = de;
        } finally {
          try {
            !C && x.return && x.return();
          } finally {
            if (L)
              throw G;
          }
        }
        return R;
      }
      return function(o, $) {
        if (Array.isArray(o))
          return o;
        if (Symbol.iterator in Object(o))
          return d(o, $);
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      };
    }(), I = function(d) {
      if (Array.isArray(d)) {
        for (var o = 0, $ = Array(d.length); o < d.length; o++)
          $[o] = d[o];
        return $;
      } else
        return Array.from(d);
    }, P = 2147483647, O = 36, g = 1, f = 26, m = 38, N = 700, j = 72, V = 128, E = "-", w = /^xn--/, D = /[^\0-\x7E]/, A = /[\x2E\u3002\uFF0E\uFF61]/g, U = {
      overflow: "Overflow: input needs wider integers to process",
      "not-basic": "Illegal input >= 0x80 (not a basic code point)",
      "invalid-input": "Invalid input"
    }, Y = O - g, H = Math.floor, ue = String.fromCharCode;
    function re(d) {
      throw new RangeError(U[d]);
    }
    function ve(d, o) {
      for (var $ = [], R = d.length; R--; )
        $[R] = o(d[R]);
      return $;
    }
    function je(d, o) {
      var $ = d.split("@"), R = "";
      $.length > 1 && (R = $[0] + "@", d = $[1]), d = d.replace(A, ".");
      var C = d.split("."), L = ve(C, o).join(".");
      return R + L;
    }
    function He(d) {
      for (var o = [], $ = 0, R = d.length; $ < R; ) {
        var C = d.charCodeAt($++);
        if (C >= 55296 && C <= 56319 && $ < R) {
          var L = d.charCodeAt($++);
          (L & 64512) == 56320 ? o.push(((C & 1023) << 10) + (L & 1023) + 65536) : (o.push(C), $--);
        } else
          o.push(C);
      }
      return o;
    }
    var Xe = function(o) {
      return String.fromCodePoint.apply(String, I(o));
    }, Ie = function(o) {
      return o - 48 < 10 ? o - 22 : o - 65 < 26 ? o - 65 : o - 97 < 26 ? o - 97 : O;
    }, z = function(o, $) {
      return o + 22 + 75 * (o < 26) - (($ != 0) << 5);
    }, b = function(o, $, R) {
      var C = 0;
      for (
        o = R ? H(o / N) : o >> 1, o += H(o / $);
        /* no initialization */
        o > Y * f >> 1;
        C += O
      )
        o = H(o / Y);
      return H(C + (Y + 1) * o / (o + m));
    }, S = function(o) {
      var $ = [], R = o.length, C = 0, L = V, G = j, x = o.lastIndexOf(E);
      x < 0 && (x = 0);
      for (var ae = 0; ae < x; ++ae)
        o.charCodeAt(ae) >= 128 && re("not-basic"), $.push(o.charCodeAt(ae));
      for (var de = x > 0 ? x + 1 : 0; de < R; ) {
        for (
          var Z = C, ne = 1, le = O;
          ;
          /* no condition */
          le += O
        ) {
          de >= R && re("invalid-input");
          var B = Ie(o.charCodeAt(de++));
          (B >= O || B > H((P - C) / ne)) && re("overflow"), C += B * ne;
          var ie = le <= G ? g : le >= G + f ? f : le - G;
          if (B < ie)
            break;
          var he = O - ie;
          ne > H(P / he) && re("overflow"), ne *= he;
        }
        var ce = $.length + 1;
        G = b(C - Z, ce, Z == 0), H(C / ce) > P - L && re("overflow"), L += H(C / ce), C %= ce, $.splice(C++, 0, L);
      }
      return String.fromCodePoint.apply(String, $);
    }, v = function(o) {
      var $ = [];
      o = He(o);
      var R = o.length, C = V, L = 0, G = j, x = !0, ae = !1, de = void 0;
      try {
        for (var Z = o[Symbol.iterator](), ne; !(x = (ne = Z.next()).done); x = !0) {
          var le = ne.value;
          le < 128 && $.push(ue(le));
        }
      } catch (jt) {
        ae = !0, de = jt;
      } finally {
        try {
          !x && Z.return && Z.return();
        } finally {
          if (ae)
            throw de;
        }
      }
      var B = $.length, ie = B;
      for (B && $.push(E); ie < R; ) {
        var he = P, ce = !0, Ge = !1, Me = void 0;
        try {
          for (var Ve = o[Symbol.iterator](), ft; !(ce = (ft = Ve.next()).done); ce = !0) {
            var xe = ft.value;
            xe >= C && xe < he && (he = xe);
          }
        } catch (jt) {
          Ge = !0, Me = jt;
        } finally {
          try {
            !ce && Ve.return && Ve.return();
          } finally {
            if (Ge)
              throw Me;
          }
        }
        var Se = ie + 1;
        he - C > H((P - L) / Se) && re("overflow"), L += (he - C) * Se, C = he;
        var Fe = !0, et = !1, qe = void 0;
        try {
          for (var Rt = o[Symbol.iterator](), On; !(Fe = (On = Rt.next()).done); Fe = !0) {
            var Nn = On.value;
            if (Nn < C && ++L > P && re("overflow"), Nn == C) {
              for (
                var Gt = L, Jt = O;
                ;
                /* no condition */
                Jt += O
              ) {
                var Wt = Jt <= G ? g : Jt >= G + f ? f : Jt - G;
                if (Gt < Wt)
                  break;
                var Tn = Gt - Wt, Cn = O - Wt;
                $.push(ue(z(Wt + Tn % Cn, 0))), Gt = H(Tn / Cn);
              }
              $.push(ue(z(Gt, 0))), G = b(L, Se, ie == B), L = 0, ++ie;
            }
          }
        } catch (jt) {
          et = !0, qe = jt;
        } finally {
          try {
            !Fe && Rt.return && Rt.return();
          } finally {
            if (et)
              throw qe;
          }
        }
        ++L, ++C;
      }
      return $.join("");
    }, s = function(o) {
      return je(o, function($) {
        return w.test($) ? S($.slice(4).toLowerCase()) : $;
      });
    }, c = function(o) {
      return je(o, function($) {
        return D.test($) ? "xn--" + v($) : $;
      });
    }, T = {
      /**
       * A string representing the current Punycode.js version number.
       * @memberOf punycode
       * @type String
       */
      version: "2.1.0",
      /**
       * An object of methods to convert from JavaScript's internal character
       * representation (UCS-2) to Unicode code points, and back.
       * @see <https://mathiasbynens.be/notes/javascript-encoding>
       * @memberOf punycode
       * @type Object
       */
      ucs2: {
        decode: He,
        encode: Xe
      },
      decode: S,
      encode: v,
      toASCII: c,
      toUnicode: s
    }, F = {};
    function M(d) {
      var o = d.charCodeAt(0), $ = void 0;
      return o < 16 ? $ = "%0" + o.toString(16).toUpperCase() : o < 128 ? $ = "%" + o.toString(16).toUpperCase() : o < 2048 ? $ = "%" + (o >> 6 | 192).toString(16).toUpperCase() + "%" + (o & 63 | 128).toString(16).toUpperCase() : $ = "%" + (o >> 12 | 224).toString(16).toUpperCase() + "%" + (o >> 6 & 63 | 128).toString(16).toUpperCase() + "%" + (o & 63 | 128).toString(16).toUpperCase(), $;
    }
    function q(d) {
      for (var o = "", $ = 0, R = d.length; $ < R; ) {
        var C = parseInt(d.substr($ + 1, 2), 16);
        if (C < 128)
          o += String.fromCharCode(C), $ += 3;
        else if (C >= 194 && C < 224) {
          if (R - $ >= 6) {
            var L = parseInt(d.substr($ + 4, 2), 16);
            o += String.fromCharCode((C & 31) << 6 | L & 63);
          } else
            o += d.substr($, 6);
          $ += 6;
        } else if (C >= 224) {
          if (R - $ >= 9) {
            var G = parseInt(d.substr($ + 4, 2), 16), x = parseInt(d.substr($ + 7, 2), 16);
            o += String.fromCharCode((C & 15) << 12 | (G & 63) << 6 | x & 63);
          } else
            o += d.substr($, 9);
          $ += 9;
        } else
          o += d.substr($, 3), $ += 3;
      }
      return o;
    }
    function J(d, o) {
      function $(R) {
        var C = q(R);
        return C.match(o.UNRESERVED) ? C : R;
      }
      return d.scheme && (d.scheme = String(d.scheme).replace(o.PCT_ENCODED, $).toLowerCase().replace(o.NOT_SCHEME, "")), d.userinfo !== void 0 && (d.userinfo = String(d.userinfo).replace(o.PCT_ENCODED, $).replace(o.NOT_USERINFO, M).replace(o.PCT_ENCODED, u)), d.host !== void 0 && (d.host = String(d.host).replace(o.PCT_ENCODED, $).toLowerCase().replace(o.NOT_HOST, M).replace(o.PCT_ENCODED, u)), d.path !== void 0 && (d.path = String(d.path).replace(o.PCT_ENCODED, $).replace(d.scheme ? o.NOT_PATH : o.NOT_PATH_NOSCHEME, M).replace(o.PCT_ENCODED, u)), d.query !== void 0 && (d.query = String(d.query).replace(o.PCT_ENCODED, $).replace(o.NOT_QUERY, M).replace(o.PCT_ENCODED, u)), d.fragment !== void 0 && (d.fragment = String(d.fragment).replace(o.PCT_ENCODED, $).replace(o.NOT_FRAGMENT, M).replace(o.PCT_ENCODED, u)), d;
    }
    function te(d) {
      return d.replace(/^0*(.*)/, "$1") || "0";
    }
    function oe(d, o) {
      var $ = d.match(o.IPV4ADDRESS) || [], R = k($, 2), C = R[1];
      return C ? C.split(".").map(te).join(".") : d;
    }
    function ke(d, o) {
      var $ = d.match(o.IPV6ADDRESS) || [], R = k($, 3), C = R[1], L = R[2];
      if (C) {
        for (var G = C.toLowerCase().split("::").reverse(), x = k(G, 2), ae = x[0], de = x[1], Z = de ? de.split(":").map(te) : [], ne = ae.split(":").map(te), le = o.IPV4ADDRESS.test(ne[ne.length - 1]), B = le ? 7 : 8, ie = ne.length - B, he = Array(B), ce = 0; ce < B; ++ce)
          he[ce] = Z[ce] || ne[ie + ce] || "";
        le && (he[B - 1] = oe(he[B - 1], o));
        var Ge = he.reduce(function(Se, Fe, et) {
          if (!Fe || Fe === "0") {
            var qe = Se[Se.length - 1];
            qe && qe.index + qe.length === et ? qe.length++ : Se.push({ index: et, length: 1 });
          }
          return Se;
        }, []), Me = Ge.sort(function(Se, Fe) {
          return Fe.length - Se.length;
        })[0], Ve = void 0;
        if (Me && Me.length > 1) {
          var ft = he.slice(0, Me.index), xe = he.slice(Me.index + Me.length);
          Ve = ft.join(":") + "::" + xe.join(":");
        } else
          Ve = he.join(":");
        return L && (Ve += "%" + L), Ve;
      } else
        return d;
    }
    var bt = /^(?:([^:\/?#]+):)?(?:\/\/((?:([^\/?#@]*)@)?(\[[^\/?#\]]+\]|[^\/?#:]*)(?:\:(\d*))?))?([^?#]*)(?:\?([^#]*))?(?:#((?:.|\n|\r)*))?/i, St = "".match(/(){0}/)[1] === void 0;
    function Ee(d) {
      var o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, $ = {}, R = o.iri !== !1 ? _ : p;
      o.reference === "suffix" && (d = (o.scheme ? o.scheme + ":" : "") + "//" + d);
      var C = d.match(bt);
      if (C) {
        St ? ($.scheme = C[1], $.userinfo = C[3], $.host = C[4], $.port = parseInt(C[5], 10), $.path = C[6] || "", $.query = C[7], $.fragment = C[8], isNaN($.port) && ($.port = C[5])) : ($.scheme = C[1] || void 0, $.userinfo = d.indexOf("@") !== -1 ? C[3] : void 0, $.host = d.indexOf("//") !== -1 ? C[4] : void 0, $.port = parseInt(C[5], 10), $.path = C[6] || "", $.query = d.indexOf("?") !== -1 ? C[7] : void 0, $.fragment = d.indexOf("#") !== -1 ? C[8] : void 0, isNaN($.port) && ($.port = d.match(/\/\/(?:.|\n)*\:(?:\/|\?|\#|$)/) ? C[4] : void 0)), $.host && ($.host = ke(oe($.host, R), R)), $.scheme === void 0 && $.userinfo === void 0 && $.host === void 0 && $.port === void 0 && !$.path && $.query === void 0 ? $.reference = "same-document" : $.scheme === void 0 ? $.reference = "relative" : $.fragment === void 0 ? $.reference = "absolute" : $.reference = "uri", o.reference && o.reference !== "suffix" && o.reference !== $.reference && ($.error = $.error || "URI is not a " + o.reference + " reference.");
        var L = F[(o.scheme || $.scheme || "").toLowerCase()];
        if (!o.unicodeSupport && (!L || !L.unicodeSupport)) {
          if ($.host && (o.domainHost || L && L.domainHost))
            try {
              $.host = T.toASCII($.host.replace(R.PCT_ENCODED, q).toLowerCase());
            } catch (G) {
              $.error = $.error || "Host's domain name can not be converted to ASCII via punycode: " + G;
            }
          J($, p);
        } else
          J($, R);
        L && L.parse && L.parse($, o);
      } else
        $.error = $.error || "URI can not be parsed.";
      return $;
    }
    function Pt(d, o) {
      var $ = o.iri !== !1 ? _ : p, R = [];
      return d.userinfo !== void 0 && (R.push(d.userinfo), R.push("@")), d.host !== void 0 && R.push(ke(oe(String(d.host), $), $).replace($.IPV6ADDRESS, function(C, L, G) {
        return "[" + L + (G ? "%25" + G : "") + "]";
      })), (typeof d.port == "number" || typeof d.port == "string") && (R.push(":"), R.push(String(d.port))), R.length ? R.join("") : void 0;
    }
    var it = /^\.\.?\//, ct = /^\/\.(\/|$)/, ut = /^\/\.\.(\/|$)/, Ot = /^\/?(?:.|\n)*?(?=\/|$)/;
    function De(d) {
      for (var o = []; d.length; )
        if (d.match(it))
          d = d.replace(it, "");
        else if (d.match(ct))
          d = d.replace(ct, "/");
        else if (d.match(ut))
          d = d.replace(ut, "/"), o.pop();
        else if (d === "." || d === "..")
          d = "";
        else {
          var $ = d.match(Ot);
          if ($) {
            var R = $[0];
            d = d.slice(R.length), o.push(R);
          } else
            throw new Error("Unexpected dot segment condition");
        }
      return o.join("");
    }
    function _e(d) {
      var o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, $ = o.iri ? _ : p, R = [], C = F[(o.scheme || d.scheme || "").toLowerCase()];
      if (C && C.serialize && C.serialize(d, o), d.host && !$.IPV6ADDRESS.test(d.host)) {
        if (o.domainHost || C && C.domainHost)
          try {
            d.host = o.iri ? T.toUnicode(d.host) : T.toASCII(d.host.replace($.PCT_ENCODED, q).toLowerCase());
          } catch (x) {
            d.error = d.error || "Host's domain name can not be converted to " + (o.iri ? "Unicode" : "ASCII") + " via punycode: " + x;
          }
      }
      J(d, $), o.reference !== "suffix" && d.scheme && (R.push(d.scheme), R.push(":"));
      var L = Pt(d, o);
      if (L !== void 0 && (o.reference !== "suffix" && R.push("//"), R.push(L), d.path && d.path.charAt(0) !== "/" && R.push("/")), d.path !== void 0) {
        var G = d.path;
        !o.absolutePath && (!C || !C.absolutePath) && (G = De(G)), L === void 0 && (G = G.replace(/^\/\//, "/%2F")), R.push(G);
      }
      return d.query !== void 0 && (R.push("?"), R.push(d.query)), d.fragment !== void 0 && (R.push("#"), R.push(d.fragment)), R.join("");
    }
    function dt(d, o) {
      var $ = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, R = arguments[3], C = {};
      return R || (d = Ee(_e(d, $), $), o = Ee(_e(o, $), $)), $ = $ || {}, !$.tolerant && o.scheme ? (C.scheme = o.scheme, C.userinfo = o.userinfo, C.host = o.host, C.port = o.port, C.path = De(o.path || ""), C.query = o.query) : (o.userinfo !== void 0 || o.host !== void 0 || o.port !== void 0 ? (C.userinfo = o.userinfo, C.host = o.host, C.port = o.port, C.path = De(o.path || ""), C.query = o.query) : (o.path ? (o.path.charAt(0) === "/" ? C.path = De(o.path) : ((d.userinfo !== void 0 || d.host !== void 0 || d.port !== void 0) && !d.path ? C.path = "/" + o.path : d.path ? C.path = d.path.slice(0, d.path.lastIndexOf("/") + 1) + o.path : C.path = o.path, C.path = De(C.path)), C.query = o.query) : (C.path = d.path, o.query !== void 0 ? C.query = o.query : C.query = d.query), C.userinfo = d.userinfo, C.host = d.host, C.port = d.port), C.scheme = d.scheme), C.fragment = o.fragment, C;
    }
    function Nt(d, o, $) {
      var R = y({ scheme: "null" }, $);
      return _e(dt(Ee(d, R), Ee(o, R), R, !0), R);
    }
    function Qe(d, o) {
      return typeof d == "string" ? d = _e(Ee(d, o), o) : i(d) === "object" && (d = Ee(_e(d, o), o)), d;
    }
    function Tt(d, o, $) {
      return typeof d == "string" ? d = _e(Ee(d, $), $) : i(d) === "object" && (d = _e(d, $)), typeof o == "string" ? o = _e(Ee(o, $), $) : i(o) === "object" && (o = _e(o, $)), d === o;
    }
    function Ht(d, o) {
      return d && d.toString().replace(!o || !o.iri ? p.ESCAPE : _.ESCAPE, M);
    }
    function be(d, o) {
      return d && d.toString().replace(!o || !o.iri ? p.PCT_ENCODED : _.PCT_ENCODED, q);
    }
    var Ze = {
      scheme: "http",
      domainHost: !0,
      parse: function(o, $) {
        return o.host || (o.error = o.error || "HTTP URIs must have a host."), o;
      },
      serialize: function(o, $) {
        var R = String(o.scheme).toLowerCase() === "https";
        return (o.port === (R ? 443 : 80) || o.port === "") && (o.port = void 0), o.path || (o.path = "/"), o;
      }
    }, vn = {
      scheme: "https",
      domainHost: Ze.domainHost,
      parse: Ze.parse,
      serialize: Ze.serialize
    };
    function _n(d) {
      return typeof d.secure == "boolean" ? d.secure : String(d.scheme).toLowerCase() === "wss";
    }
    var Ct = {
      scheme: "ws",
      domainHost: !0,
      parse: function(o, $) {
        var R = o;
        return R.secure = _n(R), R.resourceName = (R.path || "/") + (R.query ? "?" + R.query : ""), R.path = void 0, R.query = void 0, R;
      },
      serialize: function(o, $) {
        if ((o.port === (_n(o) ? 443 : 80) || o.port === "") && (o.port = void 0), typeof o.secure == "boolean" && (o.scheme = o.secure ? "wss" : "ws", o.secure = void 0), o.resourceName) {
          var R = o.resourceName.split("?"), C = k(R, 2), L = C[0], G = C[1];
          o.path = L && L !== "/" ? L : void 0, o.query = G, o.resourceName = void 0;
        }
        return o.fragment = void 0, o;
      }
    }, gn = {
      scheme: "wss",
      domainHost: Ct.domainHost,
      parse: Ct.parse,
      serialize: Ct.serialize
    }, Aa = {}, wn = "[A-Za-z0-9\\-\\.\\_\\~\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF]", Ae = "[0-9A-Fa-f]", Ma = n(n("%[EFef]" + Ae + "%" + Ae + Ae + "%" + Ae + Ae) + "|" + n("%[89A-Fa-f]" + Ae + "%" + Ae + Ae) + "|" + n("%" + Ae + Ae)), Va = "[A-Za-z0-9\\!\\$\\%\\'\\*\\+\\-\\^\\_\\`\\{\\|\\}\\~]", Fa = "[\\!\\$\\%\\'\\(\\)\\*\\+\\,\\-\\.0-9\\<\\>A-Z\\x5E-\\x7E]", za = a(Fa, '[\\"\\\\]'), Ua = "[\\!\\$\\'\\(\\)\\*\\+\\,\\;\\:\\@]", qa = new RegExp(wn, "g"), lt = new RegExp(Ma, "g"), Ka = new RegExp(a("[^]", Va, "[\\.]", '[\\"]', za), "g"), En = new RegExp(a("[^]", wn, Ua), "g"), La = En;
    function mr(d) {
      var o = q(d);
      return o.match(qa) ? o : d;
    }
    var bn = {
      scheme: "mailto",
      parse: function(o, $) {
        var R = o, C = R.to = R.path ? R.path.split(",") : [];
        if (R.path = void 0, R.query) {
          for (var L = !1, G = {}, x = R.query.split("&"), ae = 0, de = x.length; ae < de; ++ae) {
            var Z = x[ae].split("=");
            switch (Z[0]) {
              case "to":
                for (var ne = Z[1].split(","), le = 0, B = ne.length; le < B; ++le)
                  C.push(ne[le]);
                break;
              case "subject":
                R.subject = be(Z[1], $);
                break;
              case "body":
                R.body = be(Z[1], $);
                break;
              default:
                L = !0, G[be(Z[0], $)] = be(Z[1], $);
                break;
            }
          }
          L && (R.headers = G);
        }
        R.query = void 0;
        for (var ie = 0, he = C.length; ie < he; ++ie) {
          var ce = C[ie].split("@");
          if (ce[0] = be(ce[0]), $.unicodeSupport)
            ce[1] = be(ce[1], $).toLowerCase();
          else
            try {
              ce[1] = T.toASCII(be(ce[1], $).toLowerCase());
            } catch (Ge) {
              R.error = R.error || "Email address's domain name can not be converted to ASCII via punycode: " + Ge;
            }
          C[ie] = ce.join("@");
        }
        return R;
      },
      serialize: function(o, $) {
        var R = o, C = h(o.to);
        if (C) {
          for (var L = 0, G = C.length; L < G; ++L) {
            var x = String(C[L]), ae = x.lastIndexOf("@"), de = x.slice(0, ae).replace(lt, mr).replace(lt, u).replace(Ka, M), Z = x.slice(ae + 1);
            try {
              Z = $.iri ? T.toUnicode(Z) : T.toASCII(be(Z, $).toLowerCase());
            } catch (ie) {
              R.error = R.error || "Email address's domain name can not be converted to " + ($.iri ? "Unicode" : "ASCII") + " via punycode: " + ie;
            }
            C[L] = de + "@" + Z;
          }
          R.path = C.join(",");
        }
        var ne = o.headers = o.headers || {};
        o.subject && (ne.subject = o.subject), o.body && (ne.body = o.body);
        var le = [];
        for (var B in ne)
          ne[B] !== Aa[B] && le.push(B.replace(lt, mr).replace(lt, u).replace(En, M) + "=" + ne[B].replace(lt, mr).replace(lt, u).replace(La, M));
        return le.length && (R.query = le.join("&")), R;
      }
    }, Ha = /^([^\:]+)\:(.*)/, Sn = {
      scheme: "urn",
      parse: function(o, $) {
        var R = o.path && o.path.match(Ha), C = o;
        if (R) {
          var L = $.scheme || C.scheme || "urn", G = R[1].toLowerCase(), x = R[2], ae = L + ":" + ($.nid || G), de = F[ae];
          C.nid = G, C.nss = x, C.path = void 0, de && (C = de.parse(C, $));
        } else
          C.error = C.error || "URN can not be parsed.";
        return C;
      },
      serialize: function(o, $) {
        var R = $.scheme || o.scheme || "urn", C = o.nid, L = R + ":" + ($.nid || C), G = F[L];
        G && (o = G.serialize(o, $));
        var x = o, ae = o.nss;
        return x.path = (C || $.nid) + ":" + ae, x;
      }
    }, Ga = /^[0-9A-Fa-f]{8}(?:\-[0-9A-Fa-f]{4}){3}\-[0-9A-Fa-f]{12}$/, Pn = {
      scheme: "urn:uuid",
      parse: function(o, $) {
        var R = o;
        return R.uuid = R.nss, R.nss = void 0, !$.tolerant && (!R.uuid || !R.uuid.match(Ga)) && (R.error = R.error || "UUID is not valid."), R;
      },
      serialize: function(o, $) {
        var R = o;
        return R.nss = (o.uuid || "").toLowerCase(), R;
      }
    };
    F[Ze.scheme] = Ze, F[vn.scheme] = vn, F[Ct.scheme] = Ct, F[gn.scheme] = gn, F[bn.scheme] = bn, F[Sn.scheme] = Sn, F[Pn.scheme] = Pn, r.SCHEMES = F, r.pctEncChar = M, r.pctDecChars = q, r.parse = Ee, r.removeDotSegments = De, r.serialize = _e, r.resolveComponents = dt, r.resolve = Nt, r.normalize = Qe, r.equal = Tt, r.escapeComponent = Ht, r.unescapeComponent = be, Object.defineProperty(r, "__esModule", { value: !0 });
  });
})(Pr, Pr.exports);
var Io = Pr.exports;
Object.defineProperty(Fr, "__esModule", { value: !0 });
const ba = Io;
ba.code = 'require("ajv/dist/runtime/uri").default';
Fr.default = ba;
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.CodeGen = e.Name = e.nil = e.stringify = e.str = e._ = e.KeywordCxt = void 0;
  var t = Oe;
  Object.defineProperty(e, "KeywordCxt", { enumerable: !0, get: function() {
    return t.KeywordCxt;
  } });
  var r = X;
  Object.defineProperty(e, "_", { enumerable: !0, get: function() {
    return r._;
  } }), Object.defineProperty(e, "str", { enumerable: !0, get: function() {
    return r.str;
  } }), Object.defineProperty(e, "stringify", { enumerable: !0, get: function() {
    return r.stringify;
  } }), Object.defineProperty(e, "nil", { enumerable: !0, get: function() {
    return r.nil;
  } }), Object.defineProperty(e, "Name", { enumerable: !0, get: function() {
    return r.Name;
  } }), Object.defineProperty(e, "CodeGen", { enumerable: !0, get: function() {
    return r.CodeGen;
  } });
  const a = qt, n = Kt, i = st, u = we, h = X, y = pe, l = Ut, p = ee, _ = jo, k = Fr, I = (z, b) => new RegExp(z, b);
  I.code = "new RegExp";
  const P = ["removeAdditional", "useDefaults", "coerceTypes"], O = /* @__PURE__ */ new Set([
    "validate",
    "serialize",
    "parse",
    "wrapper",
    "root",
    "schema",
    "keyword",
    "pattern",
    "formats",
    "validate$data",
    "func",
    "obj",
    "Error"
  ]), g = {
    errorDataPath: "",
    format: "`validateFormats: false` can be used instead.",
    nullable: '"nullable" keyword is supported by default.',
    jsonPointers: "Deprecated jsPropertySyntax can be used instead.",
    extendRefs: "Deprecated ignoreKeywordsWithRef can be used instead.",
    missingRefs: "Pass empty schema with $id that should be ignored to ajv.addSchema.",
    processCode: "Use option `code: {process: (code, schemaEnv: object) => string}`",
    sourceCode: "Use option `code: {source: true}`",
    strictDefaults: "It is default now, see option `strict`.",
    strictKeywords: "It is default now, see option `strict`.",
    uniqueItems: '"uniqueItems" keyword is always validated.',
    unknownFormats: "Disable strict mode or pass `true` to `ajv.addFormat` (or `formats` option).",
    cache: "Map is used as cache, schema object as key.",
    serialize: "Map is used as cache, schema object as key.",
    ajvErrors: "It is default now."
  }, f = {
    ignoreKeywordsWithRef: "",
    jsPropertySyntax: "",
    unicode: '"minLength"/"maxLength" account for unicode characters by default.'
  }, m = 200;
  function N(z) {
    var b, S, v, s, c, T, F, M, q, J, te, oe, ke, bt, St, Ee, Pt, it, ct, ut, Ot, De, _e, dt, Nt;
    const Qe = z.strict, Tt = (b = z.code) === null || b === void 0 ? void 0 : b.optimize, Ht = Tt === !0 || Tt === void 0 ? 1 : Tt || 0, be = (v = (S = z.code) === null || S === void 0 ? void 0 : S.regExp) !== null && v !== void 0 ? v : I, Ze = (s = z.uriResolver) !== null && s !== void 0 ? s : k.default;
    return {
      strictSchema: (T = (c = z.strictSchema) !== null && c !== void 0 ? c : Qe) !== null && T !== void 0 ? T : !0,
      strictNumbers: (M = (F = z.strictNumbers) !== null && F !== void 0 ? F : Qe) !== null && M !== void 0 ? M : !0,
      strictTypes: (J = (q = z.strictTypes) !== null && q !== void 0 ? q : Qe) !== null && J !== void 0 ? J : "log",
      strictTuples: (oe = (te = z.strictTuples) !== null && te !== void 0 ? te : Qe) !== null && oe !== void 0 ? oe : "log",
      strictRequired: (bt = (ke = z.strictRequired) !== null && ke !== void 0 ? ke : Qe) !== null && bt !== void 0 ? bt : !1,
      code: z.code ? { ...z.code, optimize: Ht, regExp: be } : { optimize: Ht, regExp: be },
      loopRequired: (St = z.loopRequired) !== null && St !== void 0 ? St : m,
      loopEnum: (Ee = z.loopEnum) !== null && Ee !== void 0 ? Ee : m,
      meta: (Pt = z.meta) !== null && Pt !== void 0 ? Pt : !0,
      messages: (it = z.messages) !== null && it !== void 0 ? it : !0,
      inlineRefs: (ct = z.inlineRefs) !== null && ct !== void 0 ? ct : !0,
      schemaId: (ut = z.schemaId) !== null && ut !== void 0 ? ut : "$id",
      addUsedSchema: (Ot = z.addUsedSchema) !== null && Ot !== void 0 ? Ot : !0,
      validateSchema: (De = z.validateSchema) !== null && De !== void 0 ? De : !0,
      validateFormats: (_e = z.validateFormats) !== null && _e !== void 0 ? _e : !0,
      unicodeRegExp: (dt = z.unicodeRegExp) !== null && dt !== void 0 ? dt : !0,
      int32range: (Nt = z.int32range) !== null && Nt !== void 0 ? Nt : !0,
      uriResolver: Ze
    };
  }
  class j {
    constructor(b = {}) {
      this.schemas = {}, this.refs = {}, this.formats = {}, this._compilations = /* @__PURE__ */ new Set(), this._loading = {}, this._cache = /* @__PURE__ */ new Map(), b = this.opts = { ...b, ...N(b) };
      const { es5: S, lines: v } = this.opts.code;
      this.scope = new h.ValueScope({ scope: {}, prefixes: O, es5: S, lines: v }), this.logger = H(b.logger);
      const s = b.validateFormats;
      b.validateFormats = !1, this.RULES = (0, i.getRules)(), V.call(this, g, b, "NOT SUPPORTED"), V.call(this, f, b, "DEPRECATED", "warn"), this._metaOpts = U.call(this), b.formats && D.call(this), this._addVocabularies(), this._addDefaultMetaSchema(), b.keywords && A.call(this, b.keywords), typeof b.meta == "object" && this.addMetaSchema(b.meta), w.call(this), b.validateFormats = s;
    }
    _addVocabularies() {
      this.addKeyword("$async");
    }
    _addDefaultMetaSchema() {
      const { $data: b, meta: S, schemaId: v } = this.opts;
      let s = _;
      v === "id" && (s = { ..._ }, s.id = s.$id, delete s.$id), S && b && this.addMetaSchema(s, s[v], !1);
    }
    defaultMeta() {
      const { meta: b, schemaId: S } = this.opts;
      return this.opts.defaultMeta = typeof b == "object" ? b[S] || b : void 0;
    }
    validate(b, S) {
      let v;
      if (typeof b == "string") {
        if (v = this.getSchema(b), !v)
          throw new Error(`no schema with key or ref "${b}"`);
      } else
        v = this.compile(b);
      const s = v(S);
      return "$async" in v || (this.errors = v.errors), s;
    }
    compile(b, S) {
      const v = this._addSchema(b, S);
      return v.validate || this._compileSchemaEnv(v);
    }
    compileAsync(b, S) {
      if (typeof this.opts.loadSchema != "function")
        throw new Error("options.loadSchema should be a function");
      const { loadSchema: v } = this.opts;
      return s.call(this, b, S);
      async function s(J, te) {
        await c.call(this, J.$schema);
        const oe = this._addSchema(J, te);
        return oe.validate || T.call(this, oe);
      }
      async function c(J) {
        J && !this.getSchema(J) && await s.call(this, { $ref: J }, !0);
      }
      async function T(J) {
        try {
          return this._compileSchemaEnv(J);
        } catch (te) {
          if (!(te instanceof n.default))
            throw te;
          return F.call(this, te), await M.call(this, te.missingSchema), T.call(this, J);
        }
      }
      function F({ missingSchema: J, missingRef: te }) {
        if (this.refs[J])
          throw new Error(`AnySchema ${J} is loaded but ${te} cannot be resolved`);
      }
      async function M(J) {
        const te = await q.call(this, J);
        this.refs[J] || await c.call(this, te.$schema), this.refs[J] || this.addSchema(te, J, S);
      }
      async function q(J) {
        const te = this._loading[J];
        if (te)
          return te;
        try {
          return await (this._loading[J] = v(J));
        } finally {
          delete this._loading[J];
        }
      }
    }
    // Adds schema to the instance
    addSchema(b, S, v, s = this.opts.validateSchema) {
      if (Array.isArray(b)) {
        for (const T of b)
          this.addSchema(T, void 0, v, s);
        return this;
      }
      let c;
      if (typeof b == "object") {
        const { schemaId: T } = this.opts;
        if (c = b[T], c !== void 0 && typeof c != "string")
          throw new Error(`schema ${T} must be string`);
      }
      return S = (0, y.normalizeId)(S || c), this._checkUnique(S), this.schemas[S] = this._addSchema(b, v, S, s, !0), this;
    }
    // Add schema that will be used to validate other schemas
    // options in META_IGNORE_OPTIONS are alway set to false
    addMetaSchema(b, S, v = this.opts.validateSchema) {
      return this.addSchema(b, S, !0, v), this;
    }
    //  Validate schema against its meta-schema
    validateSchema(b, S) {
      if (typeof b == "boolean")
        return !0;
      let v;
      if (v = b.$schema, v !== void 0 && typeof v != "string")
        throw new Error("$schema must be a string");
      if (v = v || this.opts.defaultMeta || this.defaultMeta(), !v)
        return this.logger.warn("meta-schema not available"), this.errors = null, !0;
      const s = this.validate(v, b);
      if (!s && S) {
        const c = "schema is invalid: " + this.errorsText();
        if (this.opts.validateSchema === "log")
          this.logger.error(c);
        else
          throw new Error(c);
      }
      return s;
    }
    // Get compiled schema by `key` or `ref`.
    // (`key` that was passed to `addSchema` or full schema reference - `schema.$id` or resolved id)
    getSchema(b) {
      let S;
      for (; typeof (S = E.call(this, b)) == "string"; )
        b = S;
      if (S === void 0) {
        const { schemaId: v } = this.opts, s = new u.SchemaEnv({ schema: {}, schemaId: v });
        if (S = u.resolveSchema.call(this, s, b), !S)
          return;
        this.refs[b] = S;
      }
      return S.validate || this._compileSchemaEnv(S);
    }
    // Remove cached schema(s).
    // If no parameter is passed all schemas but meta-schemas are removed.
    // If RegExp is passed all schemas with key/id matching pattern but meta-schemas are removed.
    // Even if schema is referenced by other schemas it still can be removed as other schemas have local references.
    removeSchema(b) {
      if (b instanceof RegExp)
        return this._removeAllSchemas(this.schemas, b), this._removeAllSchemas(this.refs, b), this;
      switch (typeof b) {
        case "undefined":
          return this._removeAllSchemas(this.schemas), this._removeAllSchemas(this.refs), this._cache.clear(), this;
        case "string": {
          const S = E.call(this, b);
          return typeof S == "object" && this._cache.delete(S.schema), delete this.schemas[b], delete this.refs[b], this;
        }
        case "object": {
          const S = b;
          this._cache.delete(S);
          let v = b[this.opts.schemaId];
          return v && (v = (0, y.normalizeId)(v), delete this.schemas[v], delete this.refs[v]), this;
        }
        default:
          throw new Error("ajv.removeSchema: invalid parameter");
      }
    }
    // add "vocabulary" - a collection of keywords
    addVocabulary(b) {
      for (const S of b)
        this.addKeyword(S);
      return this;
    }
    addKeyword(b, S) {
      let v;
      if (typeof b == "string")
        v = b, typeof S == "object" && (this.logger.warn("these parameters are deprecated, see docs for addKeyword"), S.keyword = v);
      else if (typeof b == "object" && S === void 0) {
        if (S = b, v = S.keyword, Array.isArray(v) && !v.length)
          throw new Error("addKeywords: keyword must be string or non-empty array");
      } else
        throw new Error("invalid addKeywords parameters");
      if (re.call(this, v, S), !S)
        return (0, p.eachItem)(v, (c) => ve.call(this, c)), this;
      He.call(this, S);
      const s = {
        ...S,
        type: (0, l.getJSONTypes)(S.type),
        schemaType: (0, l.getJSONTypes)(S.schemaType)
      };
      return (0, p.eachItem)(v, s.type.length === 0 ? (c) => ve.call(this, c, s) : (c) => s.type.forEach((T) => ve.call(this, c, s, T))), this;
    }
    getKeyword(b) {
      const S = this.RULES.all[b];
      return typeof S == "object" ? S.definition : !!S;
    }
    // Remove keyword
    removeKeyword(b) {
      const { RULES: S } = this;
      delete S.keywords[b], delete S.all[b];
      for (const v of S.rules) {
        const s = v.rules.findIndex((c) => c.keyword === b);
        s >= 0 && v.rules.splice(s, 1);
      }
      return this;
    }
    // Add format
    addFormat(b, S) {
      return typeof S == "string" && (S = new RegExp(S)), this.formats[b] = S, this;
    }
    errorsText(b = this.errors, { separator: S = ", ", dataVar: v = "data" } = {}) {
      return !b || b.length === 0 ? "No errors" : b.map((s) => `${v}${s.instancePath} ${s.message}`).reduce((s, c) => s + S + c);
    }
    $dataMetaSchema(b, S) {
      const v = this.RULES.all;
      b = JSON.parse(JSON.stringify(b));
      for (const s of S) {
        const c = s.split("/").slice(1);
        let T = b;
        for (const F of c)
          T = T[F];
        for (const F in v) {
          const M = v[F];
          if (typeof M != "object")
            continue;
          const { $data: q } = M.definition, J = T[F];
          q && J && (T[F] = Ie(J));
        }
      }
      return b;
    }
    _removeAllSchemas(b, S) {
      for (const v in b) {
        const s = b[v];
        (!S || S.test(v)) && (typeof s == "string" ? delete b[v] : s && !s.meta && (this._cache.delete(s.schema), delete b[v]));
      }
    }
    _addSchema(b, S, v, s = this.opts.validateSchema, c = this.opts.addUsedSchema) {
      let T;
      const { schemaId: F } = this.opts;
      if (typeof b == "object")
        T = b[F];
      else {
        if (this.opts.jtd)
          throw new Error("schema must be object");
        if (typeof b != "boolean")
          throw new Error("schema must be object or boolean");
      }
      let M = this._cache.get(b);
      if (M !== void 0)
        return M;
      v = (0, y.normalizeId)(T || v);
      const q = y.getSchemaRefs.call(this, b, v);
      return M = new u.SchemaEnv({ schema: b, schemaId: F, meta: S, baseId: v, localRefs: q }), this._cache.set(M.schema, M), c && !v.startsWith("#") && (v && this._checkUnique(v), this.refs[v] = M), s && this.validateSchema(b, !0), M;
    }
    _checkUnique(b) {
      if (this.schemas[b] || this.refs[b])
        throw new Error(`schema with key or id "${b}" already exists`);
    }
    _compileSchemaEnv(b) {
      if (b.meta ? this._compileMetaSchema(b) : u.compileSchema.call(this, b), !b.validate)
        throw new Error("ajv implementation error");
      return b.validate;
    }
    _compileMetaSchema(b) {
      const S = this.opts;
      this.opts = this._metaOpts;
      try {
        u.compileSchema.call(this, b);
      } finally {
        this.opts = S;
      }
    }
  }
  e.default = j, j.ValidationError = a.default, j.MissingRefError = n.default;
  function V(z, b, S, v = "error") {
    for (const s in z) {
      const c = s;
      c in b && this.logger[v](`${S}: option ${s}. ${z[c]}`);
    }
  }
  function E(z) {
    return z = (0, y.normalizeId)(z), this.schemas[z] || this.refs[z];
  }
  function w() {
    const z = this.opts.schemas;
    if (z)
      if (Array.isArray(z))
        this.addSchema(z);
      else
        for (const b in z)
          this.addSchema(z[b], b);
  }
  function D() {
    for (const z in this.opts.formats) {
      const b = this.opts.formats[z];
      b && this.addFormat(z, b);
    }
  }
  function A(z) {
    if (Array.isArray(z)) {
      this.addVocabulary(z);
      return;
    }
    this.logger.warn("keywords option as map is deprecated, pass array");
    for (const b in z) {
      const S = z[b];
      S.keyword || (S.keyword = b), this.addKeyword(S);
    }
  }
  function U() {
    const z = { ...this.opts };
    for (const b of P)
      delete z[b];
    return z;
  }
  const Y = { log() {
  }, warn() {
  }, error() {
  } };
  function H(z) {
    if (z === !1)
      return Y;
    if (z === void 0)
      return console;
    if (z.log && z.warn && z.error)
      return z;
    throw new Error("logger must implement log, warn and error methods");
  }
  const ue = /^[a-z_$][a-z0-9_$:-]*$/i;
  function re(z, b) {
    const { RULES: S } = this;
    if ((0, p.eachItem)(z, (v) => {
      if (S.keywords[v])
        throw new Error(`Keyword ${v} is already defined`);
      if (!ue.test(v))
        throw new Error(`Keyword ${v} has invalid name`);
    }), !!b && b.$data && !("code" in b || "validate" in b))
      throw new Error('$data keyword must have "code" or "validate" function');
  }
  function ve(z, b, S) {
    var v;
    const s = b == null ? void 0 : b.post;
    if (S && s)
      throw new Error('keyword with "post" flag cannot have "type"');
    const { RULES: c } = this;
    let T = s ? c.post : c.rules.find(({ type: M }) => M === S);
    if (T || (T = { type: S, rules: [] }, c.rules.push(T)), c.keywords[z] = !0, !b)
      return;
    const F = {
      keyword: z,
      definition: {
        ...b,
        type: (0, l.getJSONTypes)(b.type),
        schemaType: (0, l.getJSONTypes)(b.schemaType)
      }
    };
    b.before ? je.call(this, T, F, b.before) : T.rules.push(F), c.all[z] = F, (v = b.implements) === null || v === void 0 || v.forEach((M) => this.addKeyword(M));
  }
  function je(z, b, S) {
    const v = z.rules.findIndex((s) => s.keyword === S);
    v >= 0 ? z.rules.splice(v, 0, b) : (z.rules.push(b), this.logger.warn(`rule ${S} is not defined`));
  }
  function He(z) {
    let { metaSchema: b } = z;
    b !== void 0 && (z.$data && this.opts.$data && (b = Ie(b)), z.validateSchema = this.compile(b, !0));
  }
  const Xe = {
    $ref: "https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#"
  };
  function Ie(z) {
    return { anyOf: [z, Xe] };
  }
})(Zn);
var zr = {}, Ur = {}, qr = {};
Object.defineProperty(qr, "__esModule", { value: !0 });
const ko = {
  keyword: "id",
  code() {
    throw new Error('NOT SUPPORTED: keyword "id", use "$id" for schema ID');
  }
};
qr.default = ko;
var ot = {};
Object.defineProperty(ot, "__esModule", { value: !0 });
ot.callRef = ot.getValidate = void 0;
const Do = Kt, zn = Q, ge = X, mt = Re, Un = we, Yt = ee, Ao = {
  keyword: "$ref",
  schemaType: "string",
  code(e) {
    const { gen: t, schema: r, it: a } = e, { baseId: n, schemaEnv: i, validateName: u, opts: h, self: y } = a, { root: l } = i;
    if ((r === "#" || r === "#/") && n === l.baseId)
      return _();
    const p = Un.resolveRef.call(y, l, n, r);
    if (p === void 0)
      throw new Do.default(a.opts.uriResolver, n, r);
    if (p instanceof Un.SchemaEnv)
      return k(p);
    return I(p);
    function _() {
      if (i === l)
        return rr(e, u, i, i.$async);
      const P = t.scopeValue("root", { ref: l });
      return rr(e, (0, ge._)`${P}.validate`, l, l.$async);
    }
    function k(P) {
      const O = Sa(e, P);
      rr(e, O, P, P.$async);
    }
    function I(P) {
      const O = t.scopeValue("schema", h.code.source === !0 ? { ref: P, code: (0, ge.stringify)(P) } : { ref: P }), g = t.name("valid"), f = e.subschema({
        schema: P,
        dataTypes: [],
        schemaPath: ge.nil,
        topSchemaRef: O,
        errSchemaPath: r
      }, g);
      e.mergeEvaluated(f), e.ok(g);
    }
  }
};
function Sa(e, t) {
  const { gen: r } = e;
  return t.validate ? r.scopeValue("validate", { ref: t.validate }) : (0, ge._)`${r.scopeValue("wrapper", { ref: t })}.validate`;
}
ot.getValidate = Sa;
function rr(e, t, r, a) {
  const { gen: n, it: i } = e, { allErrors: u, schemaEnv: h, opts: y } = i, l = y.passContext ? mt.default.this : ge.nil;
  a ? p() : _();
  function p() {
    if (!h.$async)
      throw new Error("async schema referenced by sync schema");
    const P = n.let("valid");
    n.try(() => {
      n.code((0, ge._)`await ${(0, zn.callValidateCode)(e, t, l)}`), I(t), u || n.assign(P, !0);
    }, (O) => {
      n.if((0, ge._)`!(${O} instanceof ${i.ValidationError})`, () => n.throw(O)), k(O), u || n.assign(P, !1);
    }), e.ok(P);
  }
  function _() {
    e.result((0, zn.callValidateCode)(e, t, l), () => I(t), () => k(t));
  }
  function k(P) {
    const O = (0, ge._)`${P}.errors`;
    n.assign(mt.default.vErrors, (0, ge._)`${mt.default.vErrors} === null ? ${O} : ${mt.default.vErrors}.concat(${O})`), n.assign(mt.default.errors, (0, ge._)`${mt.default.vErrors}.length`);
  }
  function I(P) {
    var O;
    if (!i.opts.unevaluated)
      return;
    const g = (O = r == null ? void 0 : r.validate) === null || O === void 0 ? void 0 : O.evaluated;
    if (i.props !== !0)
      if (g && !g.dynamicProps)
        g.props !== void 0 && (i.props = Yt.mergeEvaluated.props(n, g.props, i.props));
      else {
        const f = n.var("props", (0, ge._)`${P}.evaluated.props`);
        i.props = Yt.mergeEvaluated.props(n, f, i.props, ge.Name);
      }
    if (i.items !== !0)
      if (g && !g.dynamicItems)
        g.items !== void 0 && (i.items = Yt.mergeEvaluated.items(n, g.items, i.items));
      else {
        const f = n.var("items", (0, ge._)`${P}.evaluated.items`);
        i.items = Yt.mergeEvaluated.items(n, f, i.items, ge.Name);
      }
  }
}
ot.callRef = rr;
ot.default = Ao;
Object.defineProperty(Ur, "__esModule", { value: !0 });
const Mo = qr, Vo = ot, Fo = [
  "$schema",
  "$id",
  "$defs",
  "$vocabulary",
  { keyword: "$comment" },
  "definitions",
  Mo.default,
  Vo.default
];
Ur.default = Fo;
var Kr = {}, Lr = {};
Object.defineProperty(Lr, "__esModule", { value: !0 });
const or = X, We = or.operators, ir = {
  maximum: { okStr: "<=", ok: We.LTE, fail: We.GT },
  minimum: { okStr: ">=", ok: We.GTE, fail: We.LT },
  exclusiveMaximum: { okStr: "<", ok: We.LT, fail: We.GTE },
  exclusiveMinimum: { okStr: ">", ok: We.GT, fail: We.LTE }
}, zo = {
  message: ({ keyword: e, schemaCode: t }) => (0, or.str)`must be ${ir[e].okStr} ${t}`,
  params: ({ keyword: e, schemaCode: t }) => (0, or._)`{comparison: ${ir[e].okStr}, limit: ${t}}`
}, Uo = {
  keyword: Object.keys(ir),
  type: "number",
  schemaType: "number",
  $data: !0,
  error: zo,
  code(e) {
    const { keyword: t, data: r, schemaCode: a } = e;
    e.fail$data((0, or._)`${r} ${ir[t].fail} ${a} || isNaN(${r})`);
  }
};
Lr.default = Uo;
var Hr = {};
Object.defineProperty(Hr, "__esModule", { value: !0 });
const Mt = X, qo = {
  message: ({ schemaCode: e }) => (0, Mt.str)`must be multiple of ${e}`,
  params: ({ schemaCode: e }) => (0, Mt._)`{multipleOf: ${e}}`
}, Ko = {
  keyword: "multipleOf",
  type: "number",
  schemaType: "number",
  $data: !0,
  error: qo,
  code(e) {
    const { gen: t, data: r, schemaCode: a, it: n } = e, i = n.opts.multipleOfPrecision, u = t.let("res"), h = i ? (0, Mt._)`Math.abs(Math.round(${u}) - ${u}) > 1e-${i}` : (0, Mt._)`${u} !== parseInt(${u})`;
    e.fail$data((0, Mt._)`(${a} === 0 || (${u} = ${r}/${a}, ${h}))`);
  }
};
Hr.default = Ko;
var Gr = {}, Jr = {};
Object.defineProperty(Jr, "__esModule", { value: !0 });
function Pa(e) {
  const t = e.length;
  let r = 0, a = 0, n;
  for (; a < t; )
    r++, n = e.charCodeAt(a++), n >= 55296 && n <= 56319 && a < t && (n = e.charCodeAt(a), (n & 64512) === 56320 && a++);
  return r;
}
Jr.default = Pa;
Pa.code = 'require("ajv/dist/runtime/ucs2length").default';
Object.defineProperty(Gr, "__esModule", { value: !0 });
const nt = X, Lo = ee, Ho = Jr, Go = {
  message({ keyword: e, schemaCode: t }) {
    const r = e === "maxLength" ? "more" : "fewer";
    return (0, nt.str)`must NOT have ${r} than ${t} characters`;
  },
  params: ({ schemaCode: e }) => (0, nt._)`{limit: ${e}}`
}, Jo = {
  keyword: ["maxLength", "minLength"],
  type: "string",
  schemaType: "number",
  $data: !0,
  error: Go,
  code(e) {
    const { keyword: t, data: r, schemaCode: a, it: n } = e, i = t === "maxLength" ? nt.operators.GT : nt.operators.LT, u = n.opts.unicode === !1 ? (0, nt._)`${r}.length` : (0, nt._)`${(0, Lo.useFunc)(e.gen, Ho.default)}(${r})`;
    e.fail$data((0, nt._)`${u} ${i} ${a}`);
  }
};
Gr.default = Jo;
var Wr = {};
Object.defineProperty(Wr, "__esModule", { value: !0 });
const Wo = Q, cr = X, Bo = {
  message: ({ schemaCode: e }) => (0, cr.str)`must match pattern "${e}"`,
  params: ({ schemaCode: e }) => (0, cr._)`{pattern: ${e}}`
}, Yo = {
  keyword: "pattern",
  type: "string",
  schemaType: "string",
  $data: !0,
  error: Bo,
  code(e) {
    const { data: t, $data: r, schema: a, schemaCode: n, it: i } = e, u = i.opts.unicodeRegExp ? "u" : "", h = r ? (0, cr._)`(new RegExp(${n}, ${u}))` : (0, Wo.usePattern)(e, a);
    e.fail$data((0, cr._)`!${h}.test(${t})`);
  }
};
Wr.default = Yo;
var Br = {};
Object.defineProperty(Br, "__esModule", { value: !0 });
const Vt = X, Xo = {
  message({ keyword: e, schemaCode: t }) {
    const r = e === "maxProperties" ? "more" : "fewer";
    return (0, Vt.str)`must NOT have ${r} than ${t} properties`;
  },
  params: ({ schemaCode: e }) => (0, Vt._)`{limit: ${e}}`
}, Qo = {
  keyword: ["maxProperties", "minProperties"],
  type: "object",
  schemaType: "number",
  $data: !0,
  error: Xo,
  code(e) {
    const { keyword: t, data: r, schemaCode: a } = e, n = t === "maxProperties" ? Vt.operators.GT : Vt.operators.LT;
    e.fail$data((0, Vt._)`Object.keys(${r}).length ${n} ${a}`);
  }
};
Br.default = Qo;
var Yr = {};
Object.defineProperty(Yr, "__esModule", { value: !0 });
const kt = Q, Ft = X, Zo = ee, xo = {
  message: ({ params: { missingProperty: e } }) => (0, Ft.str)`must have required property '${e}'`,
  params: ({ params: { missingProperty: e } }) => (0, Ft._)`{missingProperty: ${e}}`
}, ei = {
  keyword: "required",
  type: "object",
  schemaType: "array",
  $data: !0,
  error: xo,
  code(e) {
    const { gen: t, schema: r, schemaCode: a, data: n, $data: i, it: u } = e, { opts: h } = u;
    if (!i && r.length === 0)
      return;
    const y = r.length >= h.loopRequired;
    if (u.allErrors ? l() : p(), h.strictRequired) {
      const I = e.parentSchema.properties, { definedProperties: P } = e.it;
      for (const O of r)
        if ((I == null ? void 0 : I[O]) === void 0 && !P.has(O)) {
          const g = u.schemaEnv.baseId + u.errSchemaPath, f = `required property "${O}" is not defined at "${g}" (strictRequired)`;
          (0, Zo.checkStrictMode)(u, f, u.opts.strictRequired);
        }
    }
    function l() {
      if (y || i)
        e.block$data(Ft.nil, _);
      else
        for (const I of r)
          (0, kt.checkReportMissingProp)(e, I);
    }
    function p() {
      const I = t.let("missing");
      if (y || i) {
        const P = t.let("valid", !0);
        e.block$data(P, () => k(I, P)), e.ok(P);
      } else
        t.if((0, kt.checkMissingProp)(e, r, I)), (0, kt.reportMissingProp)(e, I), t.else();
    }
    function _() {
      t.forOf("prop", a, (I) => {
        e.setParams({ missingProperty: I }), t.if((0, kt.noPropertyInData)(t, n, I, h.ownProperties), () => e.error());
      });
    }
    function k(I, P) {
      e.setParams({ missingProperty: I }), t.forOf(I, a, () => {
        t.assign(P, (0, kt.propertyInData)(t, n, I, h.ownProperties)), t.if((0, Ft.not)(P), () => {
          e.error(), t.break();
        });
      }, Ft.nil);
    }
  }
};
Yr.default = ei;
var Xr = {};
Object.defineProperty(Xr, "__esModule", { value: !0 });
const zt = X, ti = {
  message({ keyword: e, schemaCode: t }) {
    const r = e === "maxItems" ? "more" : "fewer";
    return (0, zt.str)`must NOT have ${r} than ${t} items`;
  },
  params: ({ schemaCode: e }) => (0, zt._)`{limit: ${e}}`
}, ri = {
  keyword: ["maxItems", "minItems"],
  type: "array",
  schemaType: "number",
  $data: !0,
  error: ti,
  code(e) {
    const { keyword: t, data: r, schemaCode: a } = e, n = t === "maxItems" ? zt.operators.GT : zt.operators.LT;
    e.fail$data((0, zt._)`${r}.length ${n} ${a}`);
  }
};
Xr.default = ri;
var Qr = {}, Lt = {};
Object.defineProperty(Lt, "__esModule", { value: !0 });
const Oa = oa;
Oa.code = 'require("ajv/dist/runtime/equal").default';
Lt.default = Oa;
Object.defineProperty(Qr, "__esModule", { value: !0 });
const _r = Ut, me = X, ni = ee, ai = Lt, si = {
  message: ({ params: { i: e, j: t } }) => (0, me.str)`must NOT have duplicate items (items ## ${t} and ${e} are identical)`,
  params: ({ params: { i: e, j: t } }) => (0, me._)`{i: ${e}, j: ${t}}`
}, oi = {
  keyword: "uniqueItems",
  type: "array",
  schemaType: "boolean",
  $data: !0,
  error: si,
  code(e) {
    const { gen: t, data: r, $data: a, schema: n, parentSchema: i, schemaCode: u, it: h } = e;
    if (!a && !n)
      return;
    const y = t.let("valid"), l = i.items ? (0, _r.getSchemaTypes)(i.items) : [];
    e.block$data(y, p, (0, me._)`${u} === false`), e.ok(y);
    function p() {
      const P = t.let("i", (0, me._)`${r}.length`), O = t.let("j");
      e.setParams({ i: P, j: O }), t.assign(y, !0), t.if((0, me._)`${P} > 1`, () => (_() ? k : I)(P, O));
    }
    function _() {
      return l.length > 0 && !l.some((P) => P === "object" || P === "array");
    }
    function k(P, O) {
      const g = t.name("item"), f = (0, _r.checkDataTypes)(l, g, h.opts.strictNumbers, _r.DataType.Wrong), m = t.const("indices", (0, me._)`{}`);
      t.for((0, me._)`;${P}--;`, () => {
        t.let(g, (0, me._)`${r}[${P}]`), t.if(f, (0, me._)`continue`), l.length > 1 && t.if((0, me._)`typeof ${g} == "string"`, (0, me._)`${g} += "_"`), t.if((0, me._)`typeof ${m}[${g}] == "number"`, () => {
          t.assign(O, (0, me._)`${m}[${g}]`), e.error(), t.assign(y, !1).break();
        }).code((0, me._)`${m}[${g}] = ${P}`);
      });
    }
    function I(P, O) {
      const g = (0, ni.useFunc)(t, ai.default), f = t.name("outer");
      t.label(f).for((0, me._)`;${P}--;`, () => t.for((0, me._)`${O} = ${P}; ${O}--;`, () => t.if((0, me._)`${g}(${r}[${P}], ${r}[${O}])`, () => {
        e.error(), t.assign(y, !1).break(f);
      })));
    }
  }
};
Qr.default = oi;
var Zr = {};
Object.defineProperty(Zr, "__esModule", { value: !0 });
const Or = X, ii = ee, ci = Lt, ui = {
  message: "must be equal to constant",
  params: ({ schemaCode: e }) => (0, Or._)`{allowedValue: ${e}}`
}, di = {
  keyword: "const",
  $data: !0,
  error: ui,
  code(e) {
    const { gen: t, data: r, $data: a, schemaCode: n, schema: i } = e;
    a || i && typeof i == "object" ? e.fail$data((0, Or._)`!${(0, ii.useFunc)(t, ci.default)}(${r}, ${n})`) : e.fail((0, Or._)`${i} !== ${r}`);
  }
};
Zr.default = di;
var xr = {};
Object.defineProperty(xr, "__esModule", { value: !0 });
const Dt = X, li = ee, fi = Lt, hi = {
  message: "must be equal to one of the allowed values",
  params: ({ schemaCode: e }) => (0, Dt._)`{allowedValues: ${e}}`
}, mi = {
  keyword: "enum",
  schemaType: "array",
  $data: !0,
  error: hi,
  code(e) {
    const { gen: t, data: r, $data: a, schema: n, schemaCode: i, it: u } = e;
    if (!a && n.length === 0)
      throw new Error("enum must have non-empty array");
    const h = n.length >= u.opts.loopEnum;
    let y;
    const l = () => y ?? (y = (0, li.useFunc)(t, fi.default));
    let p;
    if (h || a)
      p = t.let("valid"), e.block$data(p, _);
    else {
      if (!Array.isArray(n))
        throw new Error("ajv implementation error");
      const I = t.const("vSchema", i);
      p = (0, Dt.or)(...n.map((P, O) => k(I, O)));
    }
    e.pass(p);
    function _() {
      t.assign(p, !1), t.forOf("v", i, (I) => t.if((0, Dt._)`${l()}(${r}, ${I})`, () => t.assign(p, !0).break()));
    }
    function k(I, P) {
      const O = n[P];
      return typeof O == "object" && O !== null ? (0, Dt._)`${l()}(${r}, ${I}[${P}])` : (0, Dt._)`${r} === ${O}`;
    }
  }
};
xr.default = mi;
Object.defineProperty(Kr, "__esModule", { value: !0 });
const pi = Lr, $i = Hr, yi = Gr, vi = Wr, _i = Br, gi = Yr, wi = Xr, Ei = Qr, bi = Zr, Si = xr, Pi = [
  // number
  pi.default,
  $i.default,
  // string
  yi.default,
  vi.default,
  // object
  _i.default,
  gi.default,
  // array
  wi.default,
  Ei.default,
  // any
  { keyword: "type", schemaType: ["string", "array"] },
  { keyword: "nullable", schemaType: "boolean" },
  bi.default,
  Si.default
];
Kr.default = Pi;
var en = {}, wt = {};
Object.defineProperty(wt, "__esModule", { value: !0 });
wt.validateAdditionalItems = void 0;
const at = X, Nr = ee, Oi = {
  message: ({ params: { len: e } }) => (0, at.str)`must NOT have more than ${e} items`,
  params: ({ params: { len: e } }) => (0, at._)`{limit: ${e}}`
}, Ni = {
  keyword: "additionalItems",
  type: "array",
  schemaType: ["boolean", "object"],
  before: "uniqueItems",
  error: Oi,
  code(e) {
    const { parentSchema: t, it: r } = e, { items: a } = t;
    if (!Array.isArray(a)) {
      (0, Nr.checkStrictMode)(r, '"additionalItems" is ignored when "items" is not an array of schemas');
      return;
    }
    Na(e, a);
  }
};
function Na(e, t) {
  const { gen: r, schema: a, data: n, keyword: i, it: u } = e;
  u.items = !0;
  const h = r.const("len", (0, at._)`${n}.length`);
  if (a === !1)
    e.setParams({ len: t.length }), e.pass((0, at._)`${h} <= ${t.length}`);
  else if (typeof a == "object" && !(0, Nr.alwaysValidSchema)(u, a)) {
    const l = r.var("valid", (0, at._)`${h} <= ${t.length}`);
    r.if((0, at.not)(l), () => y(l)), e.ok(l);
  }
  function y(l) {
    r.forRange("i", t.length, h, (p) => {
      e.subschema({ keyword: i, dataProp: p, dataPropType: Nr.Type.Num }, l), u.allErrors || r.if((0, at.not)(l), () => r.break());
    });
  }
}
wt.validateAdditionalItems = Na;
wt.default = Ni;
var tn = {}, Et = {};
Object.defineProperty(Et, "__esModule", { value: !0 });
Et.validateTuple = void 0;
const qn = X, nr = ee, Ti = Q, Ci = {
  keyword: "items",
  type: "array",
  schemaType: ["object", "array", "boolean"],
  before: "uniqueItems",
  code(e) {
    const { schema: t, it: r } = e;
    if (Array.isArray(t))
      return Ta(e, "additionalItems", t);
    r.items = !0, !(0, nr.alwaysValidSchema)(r, t) && e.ok((0, Ti.validateArray)(e));
  }
};
function Ta(e, t, r = e.schema) {
  const { gen: a, parentSchema: n, data: i, keyword: u, it: h } = e;
  p(n), h.opts.unevaluated && r.length && h.items !== !0 && (h.items = nr.mergeEvaluated.items(a, r.length, h.items));
  const y = a.name("valid"), l = a.const("len", (0, qn._)`${i}.length`);
  r.forEach((_, k) => {
    (0, nr.alwaysValidSchema)(h, _) || (a.if((0, qn._)`${l} > ${k}`, () => e.subschema({
      keyword: u,
      schemaProp: k,
      dataProp: k
    }, y)), e.ok(y));
  });
  function p(_) {
    const { opts: k, errSchemaPath: I } = h, P = r.length, O = P === _.minItems && (P === _.maxItems || _[t] === !1);
    if (k.strictTuples && !O) {
      const g = `"${u}" is ${P}-tuple, but minItems or maxItems/${t} are not specified or different at path "${I}"`;
      (0, nr.checkStrictMode)(h, g, k.strictTuples);
    }
  }
}
Et.validateTuple = Ta;
Et.default = Ci;
Object.defineProperty(tn, "__esModule", { value: !0 });
const Ri = Et, ji = {
  keyword: "prefixItems",
  type: "array",
  schemaType: ["array"],
  before: "uniqueItems",
  code: (e) => (0, Ri.validateTuple)(e, "items")
};
tn.default = ji;
var rn = {};
Object.defineProperty(rn, "__esModule", { value: !0 });
const Kn = X, Ii = ee, ki = Q, Di = wt, Ai = {
  message: ({ params: { len: e } }) => (0, Kn.str)`must NOT have more than ${e} items`,
  params: ({ params: { len: e } }) => (0, Kn._)`{limit: ${e}}`
}, Mi = {
  keyword: "items",
  type: "array",
  schemaType: ["object", "boolean"],
  before: "uniqueItems",
  error: Ai,
  code(e) {
    const { schema: t, parentSchema: r, it: a } = e, { prefixItems: n } = r;
    a.items = !0, !(0, Ii.alwaysValidSchema)(a, t) && (n ? (0, Di.validateAdditionalItems)(e, n) : e.ok((0, ki.validateArray)(e)));
  }
};
rn.default = Mi;
var nn = {};
Object.defineProperty(nn, "__esModule", { value: !0 });
const Pe = X, Xt = ee, Vi = {
  message: ({ params: { min: e, max: t } }) => t === void 0 ? (0, Pe.str)`must contain at least ${e} valid item(s)` : (0, Pe.str)`must contain at least ${e} and no more than ${t} valid item(s)`,
  params: ({ params: { min: e, max: t } }) => t === void 0 ? (0, Pe._)`{minContains: ${e}}` : (0, Pe._)`{minContains: ${e}, maxContains: ${t}}`
}, Fi = {
  keyword: "contains",
  type: "array",
  schemaType: ["object", "boolean"],
  before: "uniqueItems",
  trackErrors: !0,
  error: Vi,
  code(e) {
    const { gen: t, schema: r, parentSchema: a, data: n, it: i } = e;
    let u, h;
    const { minContains: y, maxContains: l } = a;
    i.opts.next ? (u = y === void 0 ? 1 : y, h = l) : u = 1;
    const p = t.const("len", (0, Pe._)`${n}.length`);
    if (e.setParams({ min: u, max: h }), h === void 0 && u === 0) {
      (0, Xt.checkStrictMode)(i, '"minContains" == 0 without "maxContains": "contains" keyword ignored');
      return;
    }
    if (h !== void 0 && u > h) {
      (0, Xt.checkStrictMode)(i, '"minContains" > "maxContains" is always invalid'), e.fail();
      return;
    }
    if ((0, Xt.alwaysValidSchema)(i, r)) {
      let O = (0, Pe._)`${p} >= ${u}`;
      h !== void 0 && (O = (0, Pe._)`${O} && ${p} <= ${h}`), e.pass(O);
      return;
    }
    i.items = !0;
    const _ = t.name("valid");
    h === void 0 && u === 1 ? I(_, () => t.if(_, () => t.break())) : u === 0 ? (t.let(_, !0), h !== void 0 && t.if((0, Pe._)`${n}.length > 0`, k)) : (t.let(_, !1), k()), e.result(_, () => e.reset());
    function k() {
      const O = t.name("_valid"), g = t.let("count", 0);
      I(O, () => t.if(O, () => P(g)));
    }
    function I(O, g) {
      t.forRange("i", 0, p, (f) => {
        e.subschema({
          keyword: "contains",
          dataProp: f,
          dataPropType: Xt.Type.Num,
          compositeRule: !0
        }, O), g();
      });
    }
    function P(O) {
      t.code((0, Pe._)`${O}++`), h === void 0 ? t.if((0, Pe._)`${O} >= ${u}`, () => t.assign(_, !0).break()) : (t.if((0, Pe._)`${O} > ${h}`, () => t.assign(_, !1).break()), u === 1 ? t.assign(_, !0) : t.if((0, Pe._)`${O} >= ${u}`, () => t.assign(_, !0)));
    }
  }
};
nn.default = Fi;
var Ca = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.validateSchemaDeps = e.validatePropertyDeps = e.error = void 0;
  const t = X, r = ee, a = Q;
  e.error = {
    message: ({ params: { property: y, depsCount: l, deps: p } }) => {
      const _ = l === 1 ? "property" : "properties";
      return (0, t.str)`must have ${_} ${p} when property ${y} is present`;
    },
    params: ({ params: { property: y, depsCount: l, deps: p, missingProperty: _ } }) => (0, t._)`{property: ${y},
    missingProperty: ${_},
    depsCount: ${l},
    deps: ${p}}`
    // TODO change to reference
  };
  const n = {
    keyword: "dependencies",
    type: "object",
    schemaType: "object",
    error: e.error,
    code(y) {
      const [l, p] = i(y);
      u(y, l), h(y, p);
    }
  };
  function i({ schema: y }) {
    const l = {}, p = {};
    for (const _ in y) {
      if (_ === "__proto__")
        continue;
      const k = Array.isArray(y[_]) ? l : p;
      k[_] = y[_];
    }
    return [l, p];
  }
  function u(y, l = y.schema) {
    const { gen: p, data: _, it: k } = y;
    if (Object.keys(l).length === 0)
      return;
    const I = p.let("missing");
    for (const P in l) {
      const O = l[P];
      if (O.length === 0)
        continue;
      const g = (0, a.propertyInData)(p, _, P, k.opts.ownProperties);
      y.setParams({
        property: P,
        depsCount: O.length,
        deps: O.join(", ")
      }), k.allErrors ? p.if(g, () => {
        for (const f of O)
          (0, a.checkReportMissingProp)(y, f);
      }) : (p.if((0, t._)`${g} && (${(0, a.checkMissingProp)(y, O, I)})`), (0, a.reportMissingProp)(y, I), p.else());
    }
  }
  e.validatePropertyDeps = u;
  function h(y, l = y.schema) {
    const { gen: p, data: _, keyword: k, it: I } = y, P = p.name("valid");
    for (const O in l)
      (0, r.alwaysValidSchema)(I, l[O]) || (p.if(
        (0, a.propertyInData)(p, _, O, I.opts.ownProperties),
        () => {
          const g = y.subschema({ keyword: k, schemaProp: O }, P);
          y.mergeValidEvaluated(g, P);
        },
        () => p.var(P, !0)
        // TODO var
      ), y.ok(P));
  }
  e.validateSchemaDeps = h, e.default = n;
})(Ca);
var an = {};
Object.defineProperty(an, "__esModule", { value: !0 });
const Ra = X, zi = ee, Ui = {
  message: "property name must be valid",
  params: ({ params: e }) => (0, Ra._)`{propertyName: ${e.propertyName}}`
}, qi = {
  keyword: "propertyNames",
  type: "object",
  schemaType: ["object", "boolean"],
  error: Ui,
  code(e) {
    const { gen: t, schema: r, data: a, it: n } = e;
    if ((0, zi.alwaysValidSchema)(n, r))
      return;
    const i = t.name("valid");
    t.forIn("key", a, (u) => {
      e.setParams({ propertyName: u }), e.subschema({
        keyword: "propertyNames",
        data: u,
        dataTypes: ["string"],
        propertyName: u,
        compositeRule: !0
      }, i), t.if((0, Ra.not)(i), () => {
        e.error(!0), n.allErrors || t.break();
      });
    }), e.ok(i);
  }
};
an.default = qi;
var hr = {};
Object.defineProperty(hr, "__esModule", { value: !0 });
const Qt = Q, Te = X, Ki = Re, Zt = ee, Li = {
  message: "must NOT have additional properties",
  params: ({ params: e }) => (0, Te._)`{additionalProperty: ${e.additionalProperty}}`
}, Hi = {
  keyword: "additionalProperties",
  type: ["object"],
  schemaType: ["boolean", "object"],
  allowUndefined: !0,
  trackErrors: !0,
  error: Li,
  code(e) {
    const { gen: t, schema: r, parentSchema: a, data: n, errsCount: i, it: u } = e;
    if (!i)
      throw new Error("ajv implementation error");
    const { allErrors: h, opts: y } = u;
    if (u.props = !0, y.removeAdditional !== "all" && (0, Zt.alwaysValidSchema)(u, r))
      return;
    const l = (0, Qt.allSchemaProperties)(a.properties), p = (0, Qt.allSchemaProperties)(a.patternProperties);
    _(), e.ok((0, Te._)`${i} === ${Ki.default.errors}`);
    function _() {
      t.forIn("key", n, (g) => {
        !l.length && !p.length ? P(g) : t.if(k(g), () => P(g));
      });
    }
    function k(g) {
      let f;
      if (l.length > 8) {
        const m = (0, Zt.schemaRefOrVal)(u, a.properties, "properties");
        f = (0, Qt.isOwnProperty)(t, m, g);
      } else
        l.length ? f = (0, Te.or)(...l.map((m) => (0, Te._)`${g} === ${m}`)) : f = Te.nil;
      return p.length && (f = (0, Te.or)(f, ...p.map((m) => (0, Te._)`${(0, Qt.usePattern)(e, m)}.test(${g})`))), (0, Te.not)(f);
    }
    function I(g) {
      t.code((0, Te._)`delete ${n}[${g}]`);
    }
    function P(g) {
      if (y.removeAdditional === "all" || y.removeAdditional && r === !1) {
        I(g);
        return;
      }
      if (r === !1) {
        e.setParams({ additionalProperty: g }), e.error(), h || t.break();
        return;
      }
      if (typeof r == "object" && !(0, Zt.alwaysValidSchema)(u, r)) {
        const f = t.name("valid");
        y.removeAdditional === "failing" ? (O(g, f, !1), t.if((0, Te.not)(f), () => {
          e.reset(), I(g);
        })) : (O(g, f), h || t.if((0, Te.not)(f), () => t.break()));
      }
    }
    function O(g, f, m) {
      const N = {
        keyword: "additionalProperties",
        dataProp: g,
        dataPropType: Zt.Type.Str
      };
      m === !1 && Object.assign(N, {
        compositeRule: !0,
        createErrors: !1,
        allErrors: !1
      }), e.subschema(N, f);
    }
  }
};
hr.default = Hi;
var sn = {};
Object.defineProperty(sn, "__esModule", { value: !0 });
const Gi = Oe, Ln = Q, gr = ee, Hn = hr, Ji = {
  keyword: "properties",
  type: "object",
  schemaType: "object",
  code(e) {
    const { gen: t, schema: r, parentSchema: a, data: n, it: i } = e;
    i.opts.removeAdditional === "all" && a.additionalProperties === void 0 && Hn.default.code(new Gi.KeywordCxt(i, Hn.default, "additionalProperties"));
    const u = (0, Ln.allSchemaProperties)(r);
    for (const _ of u)
      i.definedProperties.add(_);
    i.opts.unevaluated && u.length && i.props !== !0 && (i.props = gr.mergeEvaluated.props(t, (0, gr.toHash)(u), i.props));
    const h = u.filter((_) => !(0, gr.alwaysValidSchema)(i, r[_]));
    if (h.length === 0)
      return;
    const y = t.name("valid");
    for (const _ of h)
      l(_) ? p(_) : (t.if((0, Ln.propertyInData)(t, n, _, i.opts.ownProperties)), p(_), i.allErrors || t.else().var(y, !0), t.endIf()), e.it.definedProperties.add(_), e.ok(y);
    function l(_) {
      return i.opts.useDefaults && !i.compositeRule && r[_].default !== void 0;
    }
    function p(_) {
      e.subschema({
        keyword: "properties",
        schemaProp: _,
        dataProp: _
      }, y);
    }
  }
};
sn.default = Ji;
var on = {};
Object.defineProperty(on, "__esModule", { value: !0 });
const Gn = Q, xt = X, Jn = ee, Wn = ee, Wi = {
  keyword: "patternProperties",
  type: "object",
  schemaType: "object",
  code(e) {
    const { gen: t, schema: r, data: a, parentSchema: n, it: i } = e, { opts: u } = i, h = (0, Gn.allSchemaProperties)(r), y = h.filter((O) => (0, Jn.alwaysValidSchema)(i, r[O]));
    if (h.length === 0 || y.length === h.length && (!i.opts.unevaluated || i.props === !0))
      return;
    const l = u.strictSchema && !u.allowMatchingProperties && n.properties, p = t.name("valid");
    i.props !== !0 && !(i.props instanceof xt.Name) && (i.props = (0, Wn.evaluatedPropsToName)(t, i.props));
    const { props: _ } = i;
    k();
    function k() {
      for (const O of h)
        l && I(O), i.allErrors ? P(O) : (t.var(p, !0), P(O), t.if(p));
    }
    function I(O) {
      for (const g in l)
        new RegExp(O).test(g) && (0, Jn.checkStrictMode)(i, `property ${g} matches pattern ${O} (use allowMatchingProperties)`);
    }
    function P(O) {
      t.forIn("key", a, (g) => {
        t.if((0, xt._)`${(0, Gn.usePattern)(e, O)}.test(${g})`, () => {
          const f = y.includes(O);
          f || e.subschema({
            keyword: "patternProperties",
            schemaProp: O,
            dataProp: g,
            dataPropType: Wn.Type.Str
          }, p), i.opts.unevaluated && _ !== !0 ? t.assign((0, xt._)`${_}[${g}]`, !0) : !f && !i.allErrors && t.if((0, xt.not)(p), () => t.break());
        });
      });
    }
  }
};
on.default = Wi;
var cn = {};
Object.defineProperty(cn, "__esModule", { value: !0 });
const Bi = ee, Yi = {
  keyword: "not",
  schemaType: ["object", "boolean"],
  trackErrors: !0,
  code(e) {
    const { gen: t, schema: r, it: a } = e;
    if ((0, Bi.alwaysValidSchema)(a, r)) {
      e.fail();
      return;
    }
    const n = t.name("valid");
    e.subschema({
      keyword: "not",
      compositeRule: !0,
      createErrors: !1,
      allErrors: !1
    }, n), e.failResult(n, () => e.reset(), () => e.error());
  },
  error: { message: "must NOT be valid" }
};
cn.default = Yi;
var un = {};
Object.defineProperty(un, "__esModule", { value: !0 });
const Xi = Q, Qi = {
  keyword: "anyOf",
  schemaType: "array",
  trackErrors: !0,
  code: Xi.validateUnion,
  error: { message: "must match a schema in anyOf" }
};
un.default = Qi;
var dn = {};
Object.defineProperty(dn, "__esModule", { value: !0 });
const ar = X, Zi = ee, xi = {
  message: "must match exactly one schema in oneOf",
  params: ({ params: e }) => (0, ar._)`{passingSchemas: ${e.passing}}`
}, ec = {
  keyword: "oneOf",
  schemaType: "array",
  trackErrors: !0,
  error: xi,
  code(e) {
    const { gen: t, schema: r, parentSchema: a, it: n } = e;
    if (!Array.isArray(r))
      throw new Error("ajv implementation error");
    if (n.opts.discriminator && a.discriminator)
      return;
    const i = r, u = t.let("valid", !1), h = t.let("passing", null), y = t.name("_valid");
    e.setParams({ passing: h }), t.block(l), e.result(u, () => e.reset(), () => e.error(!0));
    function l() {
      i.forEach((p, _) => {
        let k;
        (0, Zi.alwaysValidSchema)(n, p) ? t.var(y, !0) : k = e.subschema({
          keyword: "oneOf",
          schemaProp: _,
          compositeRule: !0
        }, y), _ > 0 && t.if((0, ar._)`${y} && ${u}`).assign(u, !1).assign(h, (0, ar._)`[${h}, ${_}]`).else(), t.if(y, () => {
          t.assign(u, !0), t.assign(h, _), k && e.mergeEvaluated(k, ar.Name);
        });
      });
    }
  }
};
dn.default = ec;
var ln = {};
Object.defineProperty(ln, "__esModule", { value: !0 });
const tc = ee, rc = {
  keyword: "allOf",
  schemaType: "array",
  code(e) {
    const { gen: t, schema: r, it: a } = e;
    if (!Array.isArray(r))
      throw new Error("ajv implementation error");
    const n = t.name("valid");
    r.forEach((i, u) => {
      if ((0, tc.alwaysValidSchema)(a, i))
        return;
      const h = e.subschema({ keyword: "allOf", schemaProp: u }, n);
      e.ok(n), e.mergeEvaluated(h);
    });
  }
};
ln.default = rc;
var fn = {};
Object.defineProperty(fn, "__esModule", { value: !0 });
const ur = X, ja = ee, nc = {
  message: ({ params: e }) => (0, ur.str)`must match "${e.ifClause}" schema`,
  params: ({ params: e }) => (0, ur._)`{failingKeyword: ${e.ifClause}}`
}, ac = {
  keyword: "if",
  schemaType: ["object", "boolean"],
  trackErrors: !0,
  error: nc,
  code(e) {
    const { gen: t, parentSchema: r, it: a } = e;
    r.then === void 0 && r.else === void 0 && (0, ja.checkStrictMode)(a, '"if" without "then" and "else" is ignored');
    const n = Bn(a, "then"), i = Bn(a, "else");
    if (!n && !i)
      return;
    const u = t.let("valid", !0), h = t.name("_valid");
    if (y(), e.reset(), n && i) {
      const p = t.let("ifClause");
      e.setParams({ ifClause: p }), t.if(h, l("then", p), l("else", p));
    } else
      n ? t.if(h, l("then")) : t.if((0, ur.not)(h), l("else"));
    e.pass(u, () => e.error(!0));
    function y() {
      const p = e.subschema({
        keyword: "if",
        compositeRule: !0,
        createErrors: !1,
        allErrors: !1
      }, h);
      e.mergeEvaluated(p);
    }
    function l(p, _) {
      return () => {
        const k = e.subschema({ keyword: p }, h);
        t.assign(u, h), e.mergeValidEvaluated(k, u), _ ? t.assign(_, (0, ur._)`${p}`) : e.setParams({ ifClause: p });
      };
    }
  }
};
function Bn(e, t) {
  const r = e.schema[t];
  return r !== void 0 && !(0, ja.alwaysValidSchema)(e, r);
}
fn.default = ac;
var hn = {};
Object.defineProperty(hn, "__esModule", { value: !0 });
const sc = ee, oc = {
  keyword: ["then", "else"],
  schemaType: ["object", "boolean"],
  code({ keyword: e, parentSchema: t, it: r }) {
    t.if === void 0 && (0, sc.checkStrictMode)(r, `"${e}" without "if" is ignored`);
  }
};
hn.default = oc;
Object.defineProperty(en, "__esModule", { value: !0 });
const ic = wt, cc = tn, uc = Et, dc = rn, lc = nn, fc = Ca, hc = an, mc = hr, pc = sn, $c = on, yc = cn, vc = un, _c = dn, gc = ln, wc = fn, Ec = hn;
function bc(e = !1) {
  const t = [
    // any
    yc.default,
    vc.default,
    _c.default,
    gc.default,
    wc.default,
    Ec.default,
    // object
    hc.default,
    mc.default,
    fc.default,
    pc.default,
    $c.default
  ];
  return e ? t.push(cc.default, dc.default) : t.push(ic.default, uc.default), t.push(lc.default), t;
}
en.default = bc;
var mn = {}, pn = {};
Object.defineProperty(pn, "__esModule", { value: !0 });
const fe = X, Sc = {
  message: ({ schemaCode: e }) => (0, fe.str)`must match format "${e}"`,
  params: ({ schemaCode: e }) => (0, fe._)`{format: ${e}}`
}, Pc = {
  keyword: "format",
  type: ["number", "string"],
  schemaType: "string",
  $data: !0,
  error: Sc,
  code(e, t) {
    const { gen: r, data: a, $data: n, schema: i, schemaCode: u, it: h } = e, { opts: y, errSchemaPath: l, schemaEnv: p, self: _ } = h;
    if (!y.validateFormats)
      return;
    n ? k() : I();
    function k() {
      const P = r.scopeValue("formats", {
        ref: _.formats,
        code: y.code.formats
      }), O = r.const("fDef", (0, fe._)`${P}[${u}]`), g = r.let("fType"), f = r.let("format");
      r.if((0, fe._)`typeof ${O} == "object" && !(${O} instanceof RegExp)`, () => r.assign(g, (0, fe._)`${O}.type || "string"`).assign(f, (0, fe._)`${O}.validate`), () => r.assign(g, (0, fe._)`"string"`).assign(f, O)), e.fail$data((0, fe.or)(m(), N()));
      function m() {
        return y.strictSchema === !1 ? fe.nil : (0, fe._)`${u} && !${f}`;
      }
      function N() {
        const j = p.$async ? (0, fe._)`(${O}.async ? await ${f}(${a}) : ${f}(${a}))` : (0, fe._)`${f}(${a})`, V = (0, fe._)`(typeof ${f} == "function" ? ${j} : ${f}.test(${a}))`;
        return (0, fe._)`${f} && ${f} !== true && ${g} === ${t} && !${V}`;
      }
    }
    function I() {
      const P = _.formats[i];
      if (!P) {
        m();
        return;
      }
      if (P === !0)
        return;
      const [O, g, f] = N(P);
      O === t && e.pass(j());
      function m() {
        if (y.strictSchema === !1) {
          _.logger.warn(V());
          return;
        }
        throw new Error(V());
        function V() {
          return `unknown format "${i}" ignored in schema at path "${l}"`;
        }
      }
      function N(V) {
        const E = V instanceof RegExp ? (0, fe.regexpCode)(V) : y.code.formats ? (0, fe._)`${y.code.formats}${(0, fe.getProperty)(i)}` : void 0, w = r.scopeValue("formats", { key: i, ref: V, code: E });
        return typeof V == "object" && !(V instanceof RegExp) ? [V.type || "string", V.validate, (0, fe._)`${w}.validate`] : ["string", V, w];
      }
      function j() {
        if (typeof P == "object" && !(P instanceof RegExp) && P.async) {
          if (!p.$async)
            throw new Error("async format in sync schema");
          return (0, fe._)`await ${f}(${a})`;
        }
        return typeof g == "function" ? (0, fe._)`${f}(${a})` : (0, fe._)`${f}.test(${a})`;
      }
    }
  }
};
pn.default = Pc;
Object.defineProperty(mn, "__esModule", { value: !0 });
const Oc = pn, Nc = [Oc.default];
mn.default = Nc;
var _t = {};
Object.defineProperty(_t, "__esModule", { value: !0 });
_t.contentVocabulary = _t.metadataVocabulary = void 0;
_t.metadataVocabulary = [
  "title",
  "description",
  "default",
  "deprecated",
  "readOnly",
  "writeOnly",
  "examples"
];
_t.contentVocabulary = [
  "contentMediaType",
  "contentEncoding",
  "contentSchema"
];
Object.defineProperty(zr, "__esModule", { value: !0 });
const Tc = Ur, Cc = Kr, Rc = en, jc = mn, Yn = _t, Ic = [
  Tc.default,
  Cc.default,
  (0, Rc.default)(),
  jc.default,
  Yn.metadataVocabulary,
  Yn.contentVocabulary
];
zr.default = Ic;
var $n = {}, Ia = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.DiscrError = void 0, function(t) {
    t.Tag = "tag", t.Mapping = "mapping";
  }(e.DiscrError || (e.DiscrError = {}));
})(Ia);
Object.defineProperty($n, "__esModule", { value: !0 });
const pt = X, Tr = Ia, Xn = we, kc = ee, Dc = {
  message: ({ params: { discrError: e, tagName: t } }) => e === Tr.DiscrError.Tag ? `tag "${t}" must be string` : `value of tag "${t}" must be in oneOf`,
  params: ({ params: { discrError: e, tag: t, tagName: r } }) => (0, pt._)`{error: ${e}, tag: ${r}, tagValue: ${t}}`
}, Ac = {
  keyword: "discriminator",
  type: "object",
  schemaType: "object",
  error: Dc,
  code(e) {
    const { gen: t, data: r, schema: a, parentSchema: n, it: i } = e, { oneOf: u } = n;
    if (!i.opts.discriminator)
      throw new Error("discriminator: requires discriminator option");
    const h = a.propertyName;
    if (typeof h != "string")
      throw new Error("discriminator: requires propertyName");
    if (a.mapping)
      throw new Error("discriminator: mapping is not supported");
    if (!u)
      throw new Error("discriminator: requires oneOf keyword");
    const y = t.let("valid", !1), l = t.const("tag", (0, pt._)`${r}${(0, pt.getProperty)(h)}`);
    t.if((0, pt._)`typeof ${l} == "string"`, () => p(), () => e.error(!1, { discrError: Tr.DiscrError.Tag, tag: l, tagName: h })), e.ok(y);
    function p() {
      const I = k();
      t.if(!1);
      for (const P in I)
        t.elseIf((0, pt._)`${l} === ${P}`), t.assign(y, _(I[P]));
      t.else(), e.error(!1, { discrError: Tr.DiscrError.Mapping, tag: l, tagName: h }), t.endIf();
    }
    function _(I) {
      const P = t.name("valid"), O = e.subschema({ keyword: "oneOf", schemaProp: I }, P);
      return e.mergeEvaluated(O, pt.Name), P;
    }
    function k() {
      var I;
      const P = {}, O = f(n);
      let g = !0;
      for (let j = 0; j < u.length; j++) {
        let V = u[j];
        V != null && V.$ref && !(0, kc.schemaHasRulesButRef)(V, i.self.RULES) && (V = Xn.resolveRef.call(i.self, i.schemaEnv.root, i.baseId, V == null ? void 0 : V.$ref), V instanceof Xn.SchemaEnv && (V = V.schema));
        const E = (I = V == null ? void 0 : V.properties) === null || I === void 0 ? void 0 : I[h];
        if (typeof E != "object")
          throw new Error(`discriminator: oneOf subschemas (or referenced schemas) must have "properties/${h}"`);
        g = g && (O || f(V)), m(E, j);
      }
      if (!g)
        throw new Error(`discriminator: "${h}" must be required`);
      return P;
      function f({ required: j }) {
        return Array.isArray(j) && j.includes(h);
      }
      function m(j, V) {
        if (j.const)
          N(j.const, V);
        else if (j.enum)
          for (const E of j.enum)
            N(E, V);
        else
          throw new Error(`discriminator: "properties/${h}" must have "const" or "enum"`);
      }
      function N(j, V) {
        if (typeof j != "string" || j in P)
          throw new Error(`discriminator: "${h}" values must be unique strings`);
        P[j] = V;
      }
    }
  }
};
$n.default = Ac;
const Mc = "http://json-schema.org/draft-07/schema#", Vc = "http://json-schema.org/draft-07/schema#", Fc = "Core schema meta-schema", zc = {
  schemaArray: {
    type: "array",
    minItems: 1,
    items: {
      $ref: "#"
    }
  },
  nonNegativeInteger: {
    type: "integer",
    minimum: 0
  },
  nonNegativeIntegerDefault0: {
    allOf: [
      {
        $ref: "#/definitions/nonNegativeInteger"
      },
      {
        default: 0
      }
    ]
  },
  simpleTypes: {
    enum: [
      "array",
      "boolean",
      "integer",
      "null",
      "number",
      "object",
      "string"
    ]
  },
  stringArray: {
    type: "array",
    items: {
      type: "string"
    },
    uniqueItems: !0,
    default: []
  }
}, Uc = [
  "object",
  "boolean"
], qc = {
  $id: {
    type: "string",
    format: "uri-reference"
  },
  $schema: {
    type: "string",
    format: "uri"
  },
  $ref: {
    type: "string",
    format: "uri-reference"
  },
  $comment: {
    type: "string"
  },
  title: {
    type: "string"
  },
  description: {
    type: "string"
  },
  default: !0,
  readOnly: {
    type: "boolean",
    default: !1
  },
  examples: {
    type: "array",
    items: !0
  },
  multipleOf: {
    type: "number",
    exclusiveMinimum: 0
  },
  maximum: {
    type: "number"
  },
  exclusiveMaximum: {
    type: "number"
  },
  minimum: {
    type: "number"
  },
  exclusiveMinimum: {
    type: "number"
  },
  maxLength: {
    $ref: "#/definitions/nonNegativeInteger"
  },
  minLength: {
    $ref: "#/definitions/nonNegativeIntegerDefault0"
  },
  pattern: {
    type: "string",
    format: "regex"
  },
  additionalItems: {
    $ref: "#"
  },
  items: {
    anyOf: [
      {
        $ref: "#"
      },
      {
        $ref: "#/definitions/schemaArray"
      }
    ],
    default: !0
  },
  maxItems: {
    $ref: "#/definitions/nonNegativeInteger"
  },
  minItems: {
    $ref: "#/definitions/nonNegativeIntegerDefault0"
  },
  uniqueItems: {
    type: "boolean",
    default: !1
  },
  contains: {
    $ref: "#"
  },
  maxProperties: {
    $ref: "#/definitions/nonNegativeInteger"
  },
  minProperties: {
    $ref: "#/definitions/nonNegativeIntegerDefault0"
  },
  required: {
    $ref: "#/definitions/stringArray"
  },
  additionalProperties: {
    $ref: "#"
  },
  definitions: {
    type: "object",
    additionalProperties: {
      $ref: "#"
    },
    default: {}
  },
  properties: {
    type: "object",
    additionalProperties: {
      $ref: "#"
    },
    default: {}
  },
  patternProperties: {
    type: "object",
    additionalProperties: {
      $ref: "#"
    },
    propertyNames: {
      format: "regex"
    },
    default: {}
  },
  dependencies: {
    type: "object",
    additionalProperties: {
      anyOf: [
        {
          $ref: "#"
        },
        {
          $ref: "#/definitions/stringArray"
        }
      ]
    }
  },
  propertyNames: {
    $ref: "#"
  },
  const: !0,
  enum: {
    type: "array",
    items: !0,
    minItems: 1,
    uniqueItems: !0
  },
  type: {
    anyOf: [
      {
        $ref: "#/definitions/simpleTypes"
      },
      {
        type: "array",
        items: {
          $ref: "#/definitions/simpleTypes"
        },
        minItems: 1,
        uniqueItems: !0
      }
    ]
  },
  format: {
    type: "string"
  },
  contentMediaType: {
    type: "string"
  },
  contentEncoding: {
    type: "string"
  },
  if: {
    $ref: "#"
  },
  then: {
    $ref: "#"
  },
  else: {
    $ref: "#"
  },
  allOf: {
    $ref: "#/definitions/schemaArray"
  },
  anyOf: {
    $ref: "#/definitions/schemaArray"
  },
  oneOf: {
    $ref: "#/definitions/schemaArray"
  },
  not: {
    $ref: "#"
  }
}, Kc = {
  $schema: Mc,
  $id: Vc,
  title: Fc,
  definitions: zc,
  type: Uc,
  properties: qc,
  default: !0
};
(function(e, t) {
  Object.defineProperty(t, "__esModule", { value: !0 }), t.MissingRefError = t.ValidationError = t.CodeGen = t.Name = t.nil = t.stringify = t.str = t._ = t.KeywordCxt = void 0;
  const r = Zn, a = zr, n = $n, i = Kc, u = ["/properties"], h = "http://json-schema.org/draft-07/schema";
  class y extends r.default {
    _addVocabularies() {
      super._addVocabularies(), a.default.forEach((P) => this.addVocabulary(P)), this.opts.discriminator && this.addKeyword(n.default);
    }
    _addDefaultMetaSchema() {
      if (super._addDefaultMetaSchema(), !this.opts.meta)
        return;
      const P = this.opts.$data ? this.$dataMetaSchema(i, u) : i;
      this.addMetaSchema(P, h, !1), this.refs["http://json-schema.org/schema"] = h;
    }
    defaultMeta() {
      return this.opts.defaultMeta = super.defaultMeta() || (this.getSchema(h) ? h : void 0);
    }
  }
  e.exports = t = y, Object.defineProperty(t, "__esModule", { value: !0 }), t.default = y;
  var l = Oe;
  Object.defineProperty(t, "KeywordCxt", { enumerable: !0, get: function() {
    return l.KeywordCxt;
  } });
  var p = X;
  Object.defineProperty(t, "_", { enumerable: !0, get: function() {
    return p._;
  } }), Object.defineProperty(t, "str", { enumerable: !0, get: function() {
    return p.str;
  } }), Object.defineProperty(t, "stringify", { enumerable: !0, get: function() {
    return p.stringify;
  } }), Object.defineProperty(t, "nil", { enumerable: !0, get: function() {
    return p.nil;
  } }), Object.defineProperty(t, "Name", { enumerable: !0, get: function() {
    return p.Name;
  } }), Object.defineProperty(t, "CodeGen", { enumerable: !0, get: function() {
    return p.CodeGen;
  } });
  var _ = qt;
  Object.defineProperty(t, "ValidationError", { enumerable: !0, get: function() {
    return _.default;
  } });
  var k = Kt;
  Object.defineProperty(t, "MissingRefError", { enumerable: !0, get: function() {
    return k.default;
  } });
})(Er, Er.exports);
var yn = Er.exports;
const Lc = /* @__PURE__ */ jr(yn);
var Cr = { exports: {} };
(function(e, t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  const r = yn, a = X, n = vt, i = Oe, u = gt, h = Re, y = "errorMessage", l = new r.Name("emUsed"), p = {
    required: "missingProperty",
    dependencies: "property",
    dependentRequired: "property"
  }, _ = /\$\{[^}]+\}/, k = /\$\{([^}]+)\}/g, I = /^""\s*\+\s*|\s*\+\s*""$/g;
  function P(g) {
    return {
      keyword: y,
      schemaType: ["string", "object"],
      post: !0,
      code(f) {
        const { gen: m, data: N, schema: j, schemaValue: V, it: E } = f;
        if (E.createErrors === !1)
          return;
        const w = j, D = a.strConcat(h.default.instancePath, E.errorPath);
        m.if(r._`${h.default.errors} > 0`, () => {
          if (typeof w == "object") {
            const [v, s] = U(w);
            s && Y(s), v && H(v), ue(A(w));
          }
          const S = typeof w == "string" ? w : w._;
          S && re(S), g.keepErrors || ve();
        });
        function A({ properties: S, items: v }) {
          const s = {};
          if (S) {
            s.props = {};
            for (const c in S)
              s.props[c] = [];
          }
          if (v) {
            s.items = {};
            for (let c = 0; c < v.length; c++)
              s.items[c] = [];
          }
          return s;
        }
        function U(S) {
          let v, s;
          for (const c in S) {
            if (c === "properties" || c === "items")
              continue;
            const T = S[c];
            if (typeof T == "object") {
              v || (v = {});
              const F = v[c] = {};
              for (const M in T)
                F[M] = [];
            } else
              s || (s = {}), s[c] = [];
          }
          return [v, s];
        }
        function Y(S) {
          const v = m.const("emErrors", r.stringify(S)), s = m.const("templates", Ie(S, j));
          m.forOf("err", h.default.vErrors, (M) => m.if(je(M, v), () => m.code(r._`${v}[${M}.keyword].push(${M})`).assign(r._`${M}.${l}`, !0)));
          const { singleError: c } = g;
          if (c) {
            const M = m.let("message", r._`""`), q = m.let("paramsErrors", r._`[]`);
            T((J) => {
              m.if(M, () => m.code(r._`${M} += ${typeof c == "string" ? c : ";"}`)), m.code(r._`${M} += ${F(J)}`), m.assign(q, r._`${q}.concat(${v}[${J}])`);
            }), u.reportError(f, { message: M, params: r._`{errors: ${q}}` });
          } else
            T((M) => u.reportError(f, {
              message: F(M),
              params: r._`{errors: ${v}[${M}]}`
            }));
          function T(M) {
            m.forIn("key", v, (q) => m.if(r._`${v}[${q}].length`, () => M(q)));
          }
          function F(M) {
            return r._`${M} in ${s} ? ${s}[${M}]() : ${V}[${M}]`;
          }
        }
        function H(S) {
          const v = m.const("emErrors", r.stringify(S)), s = [];
          for (const q in S)
            s.push([
              q,
              Ie(S[q], j[q])
            ]);
          const c = m.const("templates", m.object(...s)), T = m.scopeValue("obj", {
            ref: p,
            code: r.stringify(p)
          }), F = m.let("emPropParams"), M = m.let("emParamsErrors");
          m.forOf("err", h.default.vErrors, (q) => m.if(je(q, v), () => {
            m.assign(F, r._`${T}[${q}.keyword]`), m.assign(M, r._`${v}[${q}.keyword][${q}.params[${F}]]`), m.if(M, () => m.code(r._`${M}.push(${q})`).assign(r._`${q}.${l}`, !0));
          })), m.forIn("key", v, (q) => m.forIn("keyProp", r._`${v}[${q}]`, (J) => {
            m.assign(M, r._`${v}[${q}][${J}]`), m.if(r._`${M}.length`, () => {
              const te = m.const("tmpl", r._`${c}[${q}] && ${c}[${q}][${J}]`);
              u.reportError(f, {
                message: r._`${te} ? ${te}() : ${V}[${q}][${J}]`,
                params: r._`{errors: ${M}}`
              });
            });
          }));
        }
        function ue(S) {
          const { props: v, items: s } = S;
          if (!v && !s)
            return;
          const c = r._`typeof ${N} == "object"`, T = r._`Array.isArray(${N})`, F = m.let("emErrors");
          let M, q;
          const J = m.let("templates");
          v && s ? (M = m.let("emChildKwd"), m.if(c), m.if(T, () => {
            te(s, j.items), m.assign(M, r.str`items`);
          }, () => {
            te(v, j.properties), m.assign(M, r.str`properties`);
          }), q = r._`[${M}]`) : s ? (m.if(T), te(s, j.items), q = r._`.items`) : v && (m.if(a.and(c, a.not(T))), te(v, j.properties), q = r._`.properties`), m.forOf("err", h.default.vErrors, (oe) => He(oe, F, (ke) => m.code(r._`${F}[${ke}].push(${oe})`).assign(r._`${oe}.${l}`, !0))), m.forIn("key", F, (oe) => m.if(r._`${F}[${oe}].length`, () => {
            u.reportError(f, {
              message: r._`${oe} in ${J} ? ${J}[${oe}]() : ${V}${q}[${oe}]`,
              params: r._`{errors: ${F}[${oe}]}`
            }), m.assign(r._`${h.default.vErrors}[${h.default.errors}-1].instancePath`, r._`${D} + "/" + ${oe}.replace(/~/g, "~0").replace(/\\//g, "~1")`);
          })), m.endIf();
          function te(oe, ke) {
            m.assign(F, r.stringify(oe)), m.assign(J, Ie(oe, ke));
          }
        }
        function re(S) {
          const v = m.const("emErrs", r._`[]`);
          m.forOf("err", h.default.vErrors, (s) => m.if(Xe(s), () => m.code(r._`${v}.push(${s})`).assign(r._`${s}.${l}`, !0))), m.if(r._`${v}.length`, () => u.reportError(f, {
            message: z(S),
            params: r._`{errors: ${v}}`
          }));
        }
        function ve() {
          const S = m.const("emErrs", r._`[]`);
          m.forOf("err", h.default.vErrors, (v) => m.if(r._`!${v}.${l}`, () => m.code(r._`${S}.push(${v})`))), m.assign(h.default.vErrors, S).assign(h.default.errors, r._`${S}.length`);
        }
        function je(S, v) {
          return a.and(
            r._`${S}.keyword !== ${y}`,
            r._`!${S}.${l}`,
            r._`${S}.instancePath === ${D}`,
            r._`${S}.keyword in ${v}`,
            // TODO match the end of the string?
            r._`${S}.schemaPath.indexOf(${E.errSchemaPath}) === 0`,
            r._`/^\\/[^\\/]*$/.test(${S}.schemaPath.slice(${E.errSchemaPath.length}))`
          );
        }
        function He(S, v, s) {
          m.if(a.and(r._`${S}.keyword !== ${y}`, r._`!${S}.${l}`, r._`${S}.instancePath.indexOf(${D}) === 0`), () => {
            const c = m.scopeValue("pattern", {
              ref: /^\/([^/]*)(?:\/|$)/,
              code: r._`new RegExp("^\\\/([^/]*)(?:\\\/|$)")`
            }), T = m.const("emMatches", r._`${c}.exec(${S}.instancePath.slice(${D}.length))`), F = m.const("emChild", r._`${T} && ${T}[1].replace(/~1/g, "/").replace(/~0/g, "~")`);
            m.if(r._`${F} !== undefined && ${F} in ${v}`, () => s(F));
          });
        }
        function Xe(S) {
          return a.and(r._`${S}.keyword !== ${y}`, r._`!${S}.${l}`, a.or(r._`${S}.instancePath === ${D}`, a.and(r._`${S}.instancePath.indexOf(${D}) === 0`, r._`${S}.instancePath[${D}.length] === "/"`)), r._`${S}.schemaPath.indexOf(${E.errSchemaPath}) === 0`, r._`${S}.schemaPath[${E.errSchemaPath}.length] === "/"`);
        }
        function Ie(S, v) {
          const s = [];
          for (const c in S) {
            const T = v[c];
            _.test(T) && s.push([c, b(T)]);
          }
          return m.object(...s);
        }
        function z(S) {
          return _.test(S) ? new n._Code(n.safeStringify(S).replace(k, (v, s) => `" + JSON.stringify(${i.getData(s, E)}) + "`).replace(I, "")) : r.stringify(S);
        }
        function b(S) {
          return r._`function(){return ${z(S)}}`;
        }
      },
      metaSchema: {
        anyOf: [
          { type: "string" },
          {
            type: "object",
            properties: {
              properties: { $ref: "#/$defs/stringMap" },
              items: { $ref: "#/$defs/stringList" },
              required: { $ref: "#/$defs/stringOrMap" },
              dependencies: { $ref: "#/$defs/stringOrMap" }
            },
            additionalProperties: { type: "string" }
          }
        ],
        $defs: {
          stringMap: {
            type: "object",
            additionalProperties: { type: "string" }
          },
          stringOrMap: {
            anyOf: [{ type: "string" }, { $ref: "#/$defs/stringMap" }]
          },
          stringList: { type: "array", items: { type: "string" } }
        }
      }
    };
  }
  const O = (g, f = {}) => {
    if (!g.opts.allErrors)
      throw new Error("ajv-errors: Ajv option allErrors must be true");
    if (g.opts.jsPropertySyntax)
      throw new Error("ajv-errors: ajv option jsPropertySyntax is not supported");
    return g.addKeyword(P(f));
  };
  t.default = O, e.exports = O, e.exports.default = O;
})(Cr, Cr.exports);
var Hc = Cr.exports;
const Gc = /* @__PURE__ */ jr(Hc);
var Rr = { exports: {} }, ka = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.formatNames = e.fastFormats = e.fullFormats = void 0;
  function t(A, U) {
    return { validate: A, compare: U };
  }
  e.fullFormats = {
    // date: http://tools.ietf.org/html/rfc3339#section-5.6
    date: t(i, u),
    // date-time: http://tools.ietf.org/html/rfc3339#section-5.6
    time: t(y, l),
    "date-time": t(_, k),
    // duration: https://tools.ietf.org/html/rfc3339#appendix-A
    duration: /^P(?!$)((\d+Y)?(\d+M)?(\d+D)?(T(?=\d)(\d+H)?(\d+M)?(\d+S)?)?|(\d+W)?)$/,
    uri: O,
    "uri-reference": /^(?:[a-z][a-z0-9+\-.]*:)?(?:\/?\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:]|%[0-9a-f]{2})*@)?(?:\[(?:(?:(?:(?:[0-9a-f]{1,4}:){6}|::(?:[0-9a-f]{1,4}:){5}|(?:[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){4}|(?:(?:[0-9a-f]{1,4}:){0,1}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){3}|(?:(?:[0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){2}|(?:(?:[0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:|(?:(?:[0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::)(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?))|(?:(?:[0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4}|(?:(?:[0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::)|[Vv][0-9a-f]+\.[a-z0-9\-._~!$&'()*+,;=:]+)\]|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)|(?:[a-z0-9\-._~!$&'"()*+,;=]|%[0-9a-f]{2})*)(?::\d*)?(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*|\/(?:(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*)?|(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*)?(?:\?(?:[a-z0-9\-._~!$&'"()*+,;=:@/?]|%[0-9a-f]{2})*)?(?:#(?:[a-z0-9\-._~!$&'"()*+,;=:@/?]|%[0-9a-f]{2})*)?$/i,
    // uri-template: https://tools.ietf.org/html/rfc6570
    "uri-template": /^(?:(?:[^\x00-\x20"'<>%\\^`{|}]|%[0-9a-f]{2})|\{[+#./;?&=,!@|]?(?:[a-z0-9_]|%[0-9a-f]{2})+(?::[1-9][0-9]{0,3}|\*)?(?:,(?:[a-z0-9_]|%[0-9a-f]{2})+(?::[1-9][0-9]{0,3}|\*)?)*\})*$/i,
    // For the source: https://gist.github.com/dperini/729294
    // For test cases: https://mathiasbynens.be/demo/url-regex
    url: /^(?:https?|ftp):\/\/(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u{00a1}-\u{ffff}]+-)*[a-z0-9\u{00a1}-\u{ffff}]+)(?:\.(?:[a-z0-9\u{00a1}-\u{ffff}]+-)*[a-z0-9\u{00a1}-\u{ffff}]+)*(?:\.(?:[a-z\u{00a1}-\u{ffff}]{2,})))(?::\d{2,5})?(?:\/[^\s]*)?$/iu,
    email: /^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/i,
    hostname: /^(?=.{1,253}\.?$)[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?(?:\.[a-z0-9](?:[-0-9a-z]{0,61}[0-9a-z])?)*\.?$/i,
    // optimized https://www.safaribooksonline.com/library/view/regular-expressions-cookbook/9780596802837/ch07s16.html
    ipv4: /^(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)$/,
    ipv6: /^((([0-9a-f]{1,4}:){7}([0-9a-f]{1,4}|:))|(([0-9a-f]{1,4}:){6}(:[0-9a-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9a-f]{1,4}:){5}(((:[0-9a-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9a-f]{1,4}:){4}(((:[0-9a-f]{1,4}){1,3})|((:[0-9a-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){3}(((:[0-9a-f]{1,4}){1,4})|((:[0-9a-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){2}(((:[0-9a-f]{1,4}){1,5})|((:[0-9a-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){1}(((:[0-9a-f]{1,4}){1,6})|((:[0-9a-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9a-f]{1,4}){1,7})|((:[0-9a-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))$/i,
    regex: D,
    // uuid: http://tools.ietf.org/html/rfc4122
    uuid: /^(?:urn:uuid:)?[0-9a-f]{8}-(?:[0-9a-f]{4}-){3}[0-9a-f]{12}$/i,
    // JSON-pointer: https://tools.ietf.org/html/rfc6901
    // uri fragment: https://tools.ietf.org/html/rfc3986#appendix-A
    "json-pointer": /^(?:\/(?:[^~/]|~0|~1)*)*$/,
    "json-pointer-uri-fragment": /^#(?:\/(?:[a-z0-9_\-.!$&'()*+,;:=@]|%[0-9a-f]{2}|~0|~1)*)*$/i,
    // relative JSON-pointer: http://tools.ietf.org/html/draft-luff-relative-json-pointer-00
    "relative-json-pointer": /^(?:0|[1-9][0-9]*)(?:#|(?:\/(?:[^~/]|~0|~1)*)*)$/,
    // the following formats are used by the openapi specification: https://spec.openapis.org/oas/v3.0.0#data-types
    // byte: https://github.com/miguelmota/is-base64
    byte: f,
    // signed 32 bit integer
    int32: { type: "number", validate: j },
    // signed 64 bit integer
    int64: { type: "number", validate: V },
    // C-type float
    float: { type: "number", validate: E },
    // C-type double
    double: { type: "number", validate: E },
    // hint to the UI to hide input strings
    password: !0,
    // unchecked string payload
    binary: !0
  }, e.fastFormats = {
    ...e.fullFormats,
    date: t(/^\d\d\d\d-[0-1]\d-[0-3]\d$/, u),
    time: t(/^(?:[0-2]\d:[0-5]\d:[0-5]\d|23:59:60)(?:\.\d+)?(?:z|[+-]\d\d(?::?\d\d)?)?$/i, l),
    "date-time": t(/^\d\d\d\d-[0-1]\d-[0-3]\d[t\s](?:[0-2]\d:[0-5]\d:[0-5]\d|23:59:60)(?:\.\d+)?(?:z|[+-]\d\d(?::?\d\d)?)$/i, k),
    // uri: https://github.com/mafintosh/is-my-json-valid/blob/master/formats.js
    uri: /^(?:[a-z][a-z0-9+\-.]*:)(?:\/?\/)?[^\s]*$/i,
    "uri-reference": /^(?:(?:[a-z][a-z0-9+\-.]*:)?\/?\/)?(?:[^\\\s#][^\s#]*)?(?:#[^\\\s]*)?$/i,
    // email (sources from jsen validator):
    // http://stackoverflow.com/questions/201323/using-a-regular-expression-to-validate-an-email-address#answer-8829363
    // http://www.w3.org/TR/html5/forms.html#valid-e-mail-address (search for 'wilful violation')
    email: /^[a-z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?(?:\.[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?)*$/i
  }, e.formatNames = Object.keys(e.fullFormats);
  function r(A) {
    return A % 4 === 0 && (A % 100 !== 0 || A % 400 === 0);
  }
  const a = /^(\d\d\d\d)-(\d\d)-(\d\d)$/, n = [0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
  function i(A) {
    const U = a.exec(A);
    if (!U)
      return !1;
    const Y = +U[1], H = +U[2], ue = +U[3];
    return H >= 1 && H <= 12 && ue >= 1 && ue <= (H === 2 && r(Y) ? 29 : n[H]);
  }
  function u(A, U) {
    if (A && U)
      return A > U ? 1 : A < U ? -1 : 0;
  }
  const h = /^(\d\d):(\d\d):(\d\d)(\.\d+)?(z|[+-]\d\d(?::?\d\d)?)?$/i;
  function y(A, U) {
    const Y = h.exec(A);
    if (!Y)
      return !1;
    const H = +Y[1], ue = +Y[2], re = +Y[3], ve = Y[5];
    return (H <= 23 && ue <= 59 && re <= 59 || H === 23 && ue === 59 && re === 60) && (!U || ve !== "");
  }
  function l(A, U) {
    if (!(A && U))
      return;
    const Y = h.exec(A), H = h.exec(U);
    if (Y && H)
      return A = Y[1] + Y[2] + Y[3] + (Y[4] || ""), U = H[1] + H[2] + H[3] + (H[4] || ""), A > U ? 1 : A < U ? -1 : 0;
  }
  const p = /t|\s/i;
  function _(A) {
    const U = A.split(p);
    return U.length === 2 && i(U[0]) && y(U[1], !0);
  }
  function k(A, U) {
    if (!(A && U))
      return;
    const [Y, H] = A.split(p), [ue, re] = U.split(p), ve = u(Y, ue);
    if (ve !== void 0)
      return ve || l(H, re);
  }
  const I = /\/|:/, P = /^(?:[a-z][a-z0-9+\-.]*:)(?:\/?\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:]|%[0-9a-f]{2})*@)?(?:\[(?:(?:(?:(?:[0-9a-f]{1,4}:){6}|::(?:[0-9a-f]{1,4}:){5}|(?:[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){4}|(?:(?:[0-9a-f]{1,4}:){0,1}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){3}|(?:(?:[0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){2}|(?:(?:[0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:|(?:(?:[0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::)(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?))|(?:(?:[0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4}|(?:(?:[0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::)|[Vv][0-9a-f]+\.[a-z0-9\-._~!$&'()*+,;=:]+)\]|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)|(?:[a-z0-9\-._~!$&'()*+,;=]|%[0-9a-f]{2})*)(?::\d*)?(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*|\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*)?|(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*)(?:\?(?:[a-z0-9\-._~!$&'()*+,;=:@/?]|%[0-9a-f]{2})*)?(?:#(?:[a-z0-9\-._~!$&'()*+,;=:@/?]|%[0-9a-f]{2})*)?$/i;
  function O(A) {
    return I.test(A) && P.test(A);
  }
  const g = /^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=)?$/gm;
  function f(A) {
    return g.lastIndex = 0, g.test(A);
  }
  const m = -(2 ** 31), N = 2 ** 31 - 1;
  function j(A) {
    return Number.isInteger(A) && A <= N && A >= m;
  }
  function V(A) {
    return Number.isInteger(A);
  }
  function E() {
    return !0;
  }
  const w = /[^\\]\\Z/;
  function D(A) {
    if (w.test(A))
      return !1;
    try {
      return new RegExp(A), !0;
    } catch {
      return !1;
    }
  }
})(ka);
var Da = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.formatLimitDefinition = void 0;
  const t = yn, r = X, a = r.operators, n = {
    formatMaximum: { okStr: "<=", ok: a.LTE, fail: a.GT },
    formatMinimum: { okStr: ">=", ok: a.GTE, fail: a.LT },
    formatExclusiveMaximum: { okStr: "<", ok: a.LT, fail: a.GTE },
    formatExclusiveMinimum: { okStr: ">", ok: a.GT, fail: a.LTE }
  }, i = {
    message: ({ keyword: h, schemaCode: y }) => r.str`should be ${n[h].okStr} ${y}`,
    params: ({ keyword: h, schemaCode: y }) => r._`{comparison: ${n[h].okStr}, limit: ${y}}`
  };
  e.formatLimitDefinition = {
    keyword: Object.keys(n),
    type: "string",
    schemaType: "string",
    $data: !0,
    error: i,
    code(h) {
      const { gen: y, data: l, schemaCode: p, keyword: _, it: k } = h, { opts: I, self: P } = k;
      if (!I.validateFormats)
        return;
      const O = new t.KeywordCxt(k, P.RULES.all.format.definition, "format");
      O.$data ? g() : f();
      function g() {
        const N = y.scopeValue("formats", {
          ref: P.formats,
          code: I.code.formats
        }), j = y.const("fmt", r._`${N}[${O.schemaCode}]`);
        h.fail$data(r.or(r._`typeof ${j} != "object"`, r._`${j} instanceof RegExp`, r._`typeof ${j}.compare != "function"`, m(j)));
      }
      function f() {
        const N = O.schema, j = P.formats[N];
        if (!j || j === !0)
          return;
        if (typeof j != "object" || j instanceof RegExp || typeof j.compare != "function")
          throw new Error(`"${_}": format "${N}" does not define "compare" function`);
        const V = y.scopeValue("formats", {
          key: N,
          ref: j,
          code: I.code.formats ? r._`${I.code.formats}${r.getProperty(N)}` : void 0
        });
        h.fail$data(m(V));
      }
      function m(N) {
        return r._`${N}.compare(${l}, ${p}) ${n[_].fail} 0`;
      }
    },
    dependencies: ["format"]
  };
  const u = (h) => (h.addKeyword(e.formatLimitDefinition), h);
  e.default = u;
})(Da);
(function(e, t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  const r = ka, a = Da, n = X, i = new n.Name("fullFormats"), u = new n.Name("fastFormats"), h = (l, p = { keywords: !0 }) => {
    if (Array.isArray(p))
      return y(l, p, r.fullFormats, i), l;
    const [_, k] = p.mode === "fast" ? [r.fastFormats, u] : [r.fullFormats, i], I = p.formats || r.formatNames;
    return y(l, I, _, k), p.keywords && a.default(l), l;
  };
  h.get = (l, p = "full") => {
    const k = (p === "fast" ? r.fastFormats : r.fullFormats)[l];
    if (!k)
      throw new Error(`Unknown format "${l}"`);
    return k;
  };
  function y(l, p, _, k) {
    var I, P;
    (I = (P = l.opts.code).formats) !== null && I !== void 0 || (P.formats = n._`require("ajv-formats/dist/formats").${k}`);
    for (const O of p)
      l.addFormat(O, _[O]);
  }
  e.exports = t = h, Object.defineProperty(t, "__esModule", { value: !0 }), t.default = h;
})(Rr, Rr.exports);
var Jc = Rr.exports;
const Wc = /* @__PURE__ */ jr(Jc), Qn = Wc(
  Gc(
    new Lc({
      allErrors: !0,
      $data: !0,
      strict: !0,
      strictTypes: !0,
      strictSchema: !0,
      strictRequired: !0,
      strictNumbers: !0,
      strictTuples: !0,
      coerceTypes: !0,
      removeAdditional: !0,
      useDefaults: !0
    })
  )
);
function Bc(e, t = 250) {
  const [r, a] = er(e);
  return wr(() => {
    const n = setTimeout(() => {
      a(e);
    }, t);
    return () => {
      clearTimeout(n);
    };
  }, [e, t]), r;
}
const Xc = (e, t, r) => {
  var E;
  const a = Ja(jn(e)), [n, i] = er(jn(e)), [u, h] = er(null), [y, l] = er(0), p = Bc(u, (r == null ? void 0 : r.debounceTime) || 500);
  (E = r == null ? void 0 : r.customKeywords) != null && E.length && Xa(Qn, r.customKeywords);
  const _ = Qn.compile(t), k = () => {
    i(
      Object.keys(n).reduce((w, D) => ({
        ...w,
        [D]: {
          value: "",
          error: ""
        }
      }), {})
    );
  }, I = (w) => {
    const D = _({ [w]: n[w].value }), A = _.errors || [], U = D ? {} : pr(A, r == null ? void 0 : r.userDefinedMessages), Y = j && U[w] || "";
    i((H) => ({
      ...H,
      [w]: {
        ...H[w],
        error: Y
      }
    }));
  }, P = (w) => {
    I(w);
  }, O = (w) => {
    i((D) => {
      const A = Object.keys(w)[0], U = { ...D };
      return U[A] = {
        ...U[A],
        value: Bt(w[A]),
        error: ""
      }, h({ name: A, editId: y }), l(y + 1), U;
    });
  }, g = (w) => Object.keys(w).reduce(
    (D, A) => {
      const U = A;
      return {
        ...D,
        [A]: {
          value: Bt(n[U].value),
          error: w[A] || ""
        }
      };
    },
    { ...n }
  ), f = () => {
    try {
      const w = Object.keys(n).reduce((D, A) => ({
        ...D,
        [A]: Bt(n[A].value)
      }), {});
      if (!_(w) && _.errors) {
        const D = pr(
          _.errors,
          r == null ? void 0 : r.userDefinedMessages
        );
        return i(
          g(
            Object.keys(D).reduce((A, U) => ({
              ...A,
              [U]: Bt(D[U])
            }), {})
          )
        ), { isValid: !1, data: null };
      }
      return { isValid: !0, data: w };
    } catch {
      return { isValid: !1, data: null };
    }
  }, m = (w, D) => Object.keys(w).some(
    (A) => w[A].value !== D[A].value
  ), N = (w) => !Object.keys(w).some((D) => w[D].error !== ""), j = Rn(
    () => m(n, a.current),
    [n]
  ), V = Rn(() => N(n), [n]);
  return wr(() => {
    (r == null ? void 0 : r.shouldDebounceAndValidate) === !1 || !p || I(p.name);
  }, [p]), wr(() => {
    var w;
    (w = r == null ? void 0 : r.errors) != null && w.length && i(g(pr(r == null ? void 0 : r.errors, r == null ? void 0 : r.userDefinedMessages)));
  }, [r == null ? void 0 : r.errors]), {
    reset: k,
    set: O,
    validate: f,
    onBlur: P,
    isValid: V,
    isDirty: j,
    state: n
  };
};
export {
  Xc as default
};
